
c Copyright (C) 2002 - Observatoire de Paris/Meudon
c                      Universite Paris 7
c                      CNRS (France)
c                      Contact : Jacques.Lebourlot@obspm.fr
c 
c This program is free software; you can redistribute it and/or
c modify it under the terms of the GNU General Public License version 2
c as published by the Free Software Foundation.
c 
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c GNU General Public License for more details.
c 
c You should have received a copy of the GNU General Public License
c along with this program; if not, write to the Free Software
c Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.


c      %%%%%%%%%%%%%%%
       program stdprep
c      %%%%%%%%%%%%%%%

       use constantes
       use prepvar
       use inoutput
       USE H2_DATA
       USE SP_DATA
       USE CHEM_DATA
       USE PROFIL

        implicit double precision (a-h,o-z)

c  definition des variables locales.
c  (les variables transmises sont dans INCLUDE).

        character (LEN=75) :: texte
        character (LEN=50) :: fichi
        character (LEN=50) :: fichout

c--------+---------+---------+---------+---------+---------+---------+-*-------+

       print *, "**********************************************"
       print *, "*                                            *"
       print *, "*   ANALYSE DES RESULTATS DU PROGRAMME PDR   *"
       print *, "*                                            *"
       print *, "**********************************************"
       print *
       print *, '     Voulez-vous enregistrer les commandes?'
       print *, '            1: oui,   0: non'
       read *, irec
       if (irec == 1) then
         print *, '   Les commandes seront enregistree dans'
         print *, '          le fichier "prepin"'
         open (8, file='prepin', status='new')
         write (8,*) irec-1
       endif

c   Lecture des resultats du run a analyser:

       print *
       print *, 'Entrez le nom du fichier raw: (max 50 lettres)'
       read (*,5) fichi
       fichi = TRIM(ADJUSTL(fichi))
       if (irec == 1) then
         write (8,5) fichi
       endif
   5   format(a50)

       ipoint = INDEX(fichi,'.')
       if (ipoint > 1) then
         modele = fichi(1:ipoint-1)
         print *, modele
       endif

       call PLECTUR (fichi, irec)
       call INI_DATA_H3P_PREP

c   Calcul des grandeurs derivees (col densites, ...)

       call CALCUL (irec)

c   Fabrication des fichiers pour Kaleidagraph:

 500   continue

c  Module d analyse chimique

      print *, 'Voulez-vous analyser la chimie ?'
      print *, '                 (oui:1, non: 0)'
      read *, iana
      if (irec == 1) then
        write (8,*) iana
      endif

      if (iana == 1) then
        call ANALYS
        print *, 'Voulez-vous continuer ?'
        print *, '       (oui: 1, non: 0)'
        read *, ifin
        if (ifin == 1) then
          goto 500
        else
          goto 600
        endif
      endif

c  Definition des variables a imprimer:

       print *
       print *, 'Entrez le nom du fichier a fabriquer:'
       read (*,5) fichout
       fichout = TRIM(ADJUSTL(fichout))
       if (irec == 1) then
         write (8,5) fichout
       endif

       fichier = TRIM(out_dir)//fichout
       print *,"Le fichier de sortie sera ecrit dans:"
       print *, fichier
       open (25, file = fichier, status = 'new')

       print *, '   Entrez une ligne de commentaire (sans_espaces)'
       read (*,6) texte
       if (irec == 1) then
         write (8,6) texte
       endif
   6   format(a75)
c       print *, texte

       write (25,1001) texte

 2001  print *
       print *, '   Quel doit etre la variable x?'
       print *, '         1: tau         2: Av'
       print *, '         3: NH          4: N(H2)'
       read *, ii
       if (irec == 1) then
         write (8,*) ii
       endif

       if (ii == 1) then
         do j=0,npo
           x(j) = tau(j)
         end do
         textx = 'tau           '

       else if (ii == 2) then
         do j=0,npo
           x(j) = tau(j) * tautav
         end do
         textx = 'Av            '

       else if (ii == 3) then
         do j=0,npo
           x(j) = codesp(i_h,j) + 2.0_dp * codesp(i_h2,j)
         end do
         textx = 'NH            '

       else if (ii == 4) then
         do j=0,npo
           x(j) = codesp(i_h2,j)
         end do
         textx = 'N(H2)         '

       else

         print *, '     ****  ATTENTION: valeur impossible  ****'
         goto 2001

       endif

       iimax = 0

 2002  print *
       print *, '   Quelle est le type de la prochaine variable y ?'
       print *, '     0: termine '
       print *, '     1: Abondance  2: Colonne densite   3: Emissivite'
       print *, '     4: Chauffage - Refroidissement'
       print *, '     5: Autre (T, densite, ions, ...)'
       read *, ii1
       if (irec == 1) then
         write (8,*) ii1
       endif

       if (ii1 == 0) then

         goto 2003

       else if (ii1 == 1) then

         call ABONDA (iimax, irec)

       else if (ii1 == 2) then

         call COLDEN (iimax, irec)

       else if (ii1 == 3) then

         call EMISSI (iimax, irec)

       else if (ii1 == 4) then

         call CHOFRO (iimax, irec)

       else if (ii1 == 5) then

         call AUTRE (iimax, irec)

       else

         print *, '     ****  ATTENTION: valeur impossible!  ****'
         goto 2002

       endif

       if (iimax < ncolf) then
         print *
         print *, '   Y a-t-il une nouvelle colonne ?'
         print *, '         0: non      1: oui'
         read *, ii
         if (irec == 1) then
           write (8,*) ii
         endif

         if (ii == 1) then
           goto 2002
         endif
       else
         print *, "   C'etait la derniere colonne possible"
         print *, "      il faut augmenter NCOLF !"
       endif

c   Ecriture du fichier de sortie:

 2003  print *
       print *, '   il y a ', iimax,' colonnes de y dans le fichier '
     1        ,fichout

       write (25,1002) textx, (texty(ii), ii=1,iimax)
       do 900 j=1,npo
         write (25,1003) x(j), (y(ii,j), ii=1,iimax)
  900  continue

       close (25)

c   On peut creer plusieurs fichiers:

       print *
       print *, '   Faut-il creer un nouveau fichier?'
       print *, '         0: non            1: oui'
       read *, ii
       if (irec == 1) then
         write (8,*) ii
       endif

       if (ii == 1) then
         goto 500
       endif

  600  continue

 1001  format (7x,a75)
 1002  format (2x,151a14)
 1003  format (1p,e16.8,152e14.6)

       stop
       end
