
! Copyright (C) 2002 - Observatoire de Paris/Meudon
!                      Universite Paris 7
!                      CNRS (France)
!                      Contact : Jacques.Lebourlot@obspm.fr
! 
! This program is free software; you can redistribute it and/or
! modify it under the terms of the GNU General Public License version 2
! as published by the Free Software Foundation.
! 
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
! 
! You should have received a copy of the GNU General Public License
! along with this program; if not, write to the Free Software
! Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

!--------+---------+---------+---------+---------+---------+---------+-*-------+

module prepvar

  use constantes
  use STR_DATA

  implicit none

  integer, public, parameter :: ncolf = 150  ! Max number of columns in output file

! real (KIND=DP), public, dimension (nlevh2,-1:1,0:nvxh2,0:noptm) :: rvfjh2
  real (KIND=DP), public, allocatable, dimension (:,:,:,:)        :: rvfjh2
  real (KIND=DP), public, dimension (0:nvxh2,0:noptm)             :: rvfvh2
  real (KIND=DP), public, dimension (0:noptm)                     :: rvfh2t
! real (KIND=DP), public, dimension (nlevh2,-1:1,0:nvxh2,0:noptm) :: rfjh2i
! real (KIND=DP), public, dimension (nlevhd,-2:2,0:nvxhd,0:noptm) :: rvfjhd
  real (KIND=DP), public, allocatable, dimension (:,:,:,:)        :: rvfjhd
  real (KIND=DP), public, dimension (0:noptm)                     :: rvfhdt

  real (KIND=DP), public, dimension (nes,0:noptm)           :: codesp
  real (KIND=DP), public, dimension (nlevh2,0:noptm)        :: codeh2
  real (KIND=DP), public, dimension (0:nvxh2,0:noptm)       :: codh2v
  real (KIND=DP), public, dimension (nlevhd,0:noptm)        :: codehd
  real (KIND=DP), public, dimension (0:nvxhd,0:noptm)       :: codhdv
  real (KIND=DP), public, dimension (nlvco0,0:noptm)        :: cdeco0
  real (KIND=DP), public, dimension (nlvco0,0:noptm)        :: cdeco1
  real (KIND=DP), public, dimension (nlvco0,0:noptm)        :: cdeco2
  real (KIND=DP), public, dimension (nlvco0,0:noptm)        :: cdeco3
  real (KIND=DP), public, dimension (nlvcs0,0:noptm)        :: codecs
  real (KIND=DP), public, dimension (nlvhcop,0:noptm)       :: codehcop
  real (KIND=DP), public, ALLOCATABLE                       :: codeh3p(:,:)
  real (KIND=DP), public, dimension (nlvh2o,0:noptm)        :: codeh2o
  real (KIND=DP), public, dimension (nlvcat,0:noptm)        :: codecat
  real (KIND=DP), public, dimension (nlvnat,0:noptm)        :: codenat
  real (KIND=DP), public, dimension (nlvoat,0:noptm)        :: codeoat
  real (KIND=DP), public, dimension (nlvsat,0:noptm)        :: codesat
  real (KIND=DP), public, dimension (nlvsiat,0:noptm)       :: codesiat
  real (KIND=DP), public, dimension (nlvcpl,0:noptm)        :: codecpl
  real (KIND=DP), public, dimension (nlvnpl,0:noptm)        :: codenpl
  real (KIND=DP), public, dimension (nlvopl,0:noptm)        :: codeopl
  real (KIND=DP), public, dimension (nlvspl,0:noptm)        :: codespl
  real (KIND=DP), public, dimension (nlvsip,0:noptm)        :: codesip
  real (KIND=DP), public, dimension (3,0:noptm)             :: cdoph2
  real (KIND=DP), public, dimension (0:nvbc,0:njbc,0:noptm) :: codeh2b
  real (KIND=DP), public, dimension (0:nvbc,0:njbc,0:noptm) :: codeh2c

  character(len=8), public, dimension (:), allocatable      :: ndiesp

  real (KIND=DP), public, dimension(0:nvxh2,0:noptm)        :: h2v

! Quantites associees a des especes particulieres
  real (KIND=DP), public                                    :: Emaxh3p_lu

! grains:
  real (KIND=DP), public :: dustio
  real (KIND=DP), public :: depl
  real (KIND=DP), public :: rath2g

! output file
  real (KIND=DP), public, dimension (0:noptm)       :: x
  real (KIND=DP), public, dimension (ncolf,0:noptm) :: y
  character (LEN=14), public                        :: textx
  character (LEN=14), public, dimension (ncolf)     :: texty

end module prepvar
