
c Copyright (C) 2002 - Observatoire de Paris/Meudon
c                      Universite Paris 7
c                      CNRS (France)
c                      Contact : Jacques.Lebourlot@obspm.fr
c 
c This program is free software; you can redistribute it and/or
c modify it under the terms of the GNU General Public License version 2
c as published by the Free Software Foundation.
c 
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c GNU General Public License for more details.
c 
c You should have received a copy of the GNU General Public License
c along with this program; if not, write to the Free Software
c Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.


c      %%%%%%%%%%%%%%%%%%%%%%%%
       subroutine CALCUL (irec)
c      %%%%%%%%%%%%%%%%%%%%%%%%

       use constantes
       use prepvar
       use inoutput
       USE H2_DATA
       USE HD_DATA
       USE SP_DATA
       USE CHEM_DATA
       USE PROFIL

c--------+---------+---------+---------+---------+---------+---------+-*-------+

c                     ordres non executables:
c                     ***********************

        implicit double precision (a-h,o-z)

c  definition des variables locales.
c  (les variables transmises sont dans INCLUDE).

c--------+---------+---------+---------+---------+---------+---------+-*-------+

c  emissivites:
c  ------------

       cdcte = tautav * cdunit / (4.0_dp * xpi * rrr)

c d-hydrogene moleculaire:

c  Lecture des probabilites de transition quadrupolaires

       allocate (evlqua(nlevh2,nlevh2))
       evlqua = 0.0_dp

c modif: on lit par defaut les infos sur les transitions

       fichier = TRIM(data_dir)//'aquadh2.dat'

       open (iread2, file = fichier, status = 'old')
       read (iread2,4005)
       read (iread2,4101) nrh2q
       print *, '    Nombre de raies de H2:',nrh2q

       do i=1,nrh2q
         read (iread2,4004) nvu, nvl, nju, as, aq, ao
         if (nju > njh2) cycle
         levu = level(nvu,nju)
         njl = nju -2
         if (njl >= 0 .and. as /= 0.0_dp) then
           levl = level(nvl,njl)
           evlqua(levl,levu) = - as
         endif
         njl = nju
         if (aq /= 0.0_dp) then
           levl = level(nvl,njl)
           evlqua(levl,levu) = - aq
         endif
         njl = nju + 2
         if (njl > njh2) cycle
         if (ao /= 0.0_dp) then
           levl = level(nvl,njl)
           evlqua(levl,levu) = - ao
         endif
       end do
       close (iread2)

c   rvfjh2 contient les emissivites raie par raie de h2
c     qu il est inutile de calculer dans froid.

       allocate (rvfjh2(l0h2,-1:1,nvxh2,0:npo))

       do iopt=0,npo
         rvfvh2(0:nvxh2,iopt) = 0.0_dp
         rvfh2t(iopt) = 0.0_dp
         do levu=2,l0h2
           ju = njlev(levu)
           if (ju > njh2) cycle
           do levl = 1,levu-1
             jl = njlev(levl)
             if (jl > njh2) cycle
             jj = ju - jl
             if (jj == 0 .or. iabs(jj) == 2) then
               jj = jj / 2
               nvl = nvlev(levl)
               nvu = nvlev(levu)
               emici = - evlqua(levl,levu)
     1             * (elhm(levu) - elhm(levl))
     2             * xreh2(levu,iopt) * abnua(i_h2,iopt) * xk
               rvfjh2(levu,jj,nvl,iopt) = emici
               rvfvh2(nvu,iopt) = rvfvh2(nvu,iopt) + emici
               rvfh2t(iopt) = rvfh2t(iopt) + emici
             endif
           end do
         end do
       end do


       do levl=1,l0h2-1
         jl = njlev(levl)
         if (jl > njh2) cycle
         do levu=levl+1,l0h2
           ju = njlev(levu)
           if (ju > njh2) cycle
           jj = ju -jl
           if (jj == 0 .or. iabs(jj) == 2) then
             jj = jj / 2
             nvl = nvlev(levl)
c            rfjh2i(levu,jj,nvl,0) = 0.0_dp
             rvfjh2(levu,jj,nvl,0) = rvfjh2(levu,jj,nvl,1)
           endif
         end do
       end do

c--------------------------
c d bis- HD
c--------------------------

c  Lecture des probabilites de transition dipolaires et quadrupolaires

c modif: on lit par defaut les donnees des emissivites de HD

         evdihd = 0.0_dp

c  Replace here by the PATH to your data directory

         fichier = TRIM(data_dir)//'aquadhd.dat'
         open (iread2, file = fichier, status = 'old')
         read (iread2,4005)
         read (iread2,4101) nrhdq
         print *,'    Nombre de raies de HD:',nrhdq
         print *,'----------------------------------------'
         print *

         do 293 i=1,nrhdq
           read (iread2,4006) nvu, nvl, nju, as, ar, aq, ap, ao
           if (nju > mjhd) goto 293
           levu = levhd(nvu,nju)
           njl = nju -2
           if (njl >= 0 .and. as /= 0.0_dp) then
             levl = levhd(nvl,njl)
             evdihd(levl,levu) = - as
           endif
           njl = nju - 1
           if (njl >= 0 .and. ar /= 0.0_dp) then
             levl = levhd(nvl,njl)
             evdihd(levl,levu) = - ar
           endif
           njl = nju
           if (aq /= 0.0_dp) then
             levl = levhd(nvl,njl)
             evdihd(levl,levu) = - aq
           endif
           njl = nju + 1
           if (njl <= mjhd .and. ap /= 0.0_dp) then
             levl = levhd(nvl,njl)
             evdihd(levl,levu) = - ap
           endif
           njl = nju + 2
           if (njl <= mjhd .and. ao /= 0.0_dp) then
             levl = levhd(nvl,njl)
             evdihd(levl,levu) = - ao
           endif
  293    continue
       close (iread2)
c   rvfjhd contient les emissivites raie par raie de hd
c     qu il est inutile de calculer dans froid.

       allocate (rvfjhd(l0hd,-2:2,nvxhd,0:npo))

       do 1532 iopt=0,npo
         rvfhdt(iopt) = 0.0_dp

         do 1530 levu=2,l0hd
           ju = njhd(levu)
           if (ju > mjhd) goto 1530
           do 1531 levl = 1,levu-1
             jl = njhd(levl)
             if (jl > mjhd) goto 1531
             jj = ju - jl
             if (jj == 0 .or. iabs(jj) == 1
     1                     .or. iabs(jj) == 2) then
               nvl = nvhd(levl)
               nvu = nvhd(levu)
               emici = - evdihd(levl,levu)
     1             * (elhd(levu) - elhd(levl))
     2             * xrehd(levu,iopt) * abnua(i_hd,iopt) * xk
               rvfjhd(levu,jj,nvl,iopt) = emici
               rvfhdt(iopt) = rvfhdt(iopt) + emici
             endif
 1531      continue
 1530    continue
 1532  continue

       do 1540 levl=1,l0hd-1
         jl = njhd(levl)
         if (jl > mjhd) goto 1540
         do 1541 levu=levl+1,l0hd
           ju = njhd(levu)
           if (ju > mjhd) goto 1541
           jj = ju -jl
           if (jj == 0 .or. iabs(jj) == 1
     1                   .or. iabs(jj) == 2) then
             nvl = nvhd(levl)
             rvfjhd(levu,jj,nvl,0) = rvfjhd(levu,jj,nvl,1)
           endif
 1541    continue
 1540  continue

c--------+---------+---------+---------+---------+---------+---------+-*-------+
c e-CO et al.:

       emico0(:,0) = emico0(:,1)
       emico1(:,0) = emico1(:,1)
       emico2(:,0) = emico2(:,1)
       emico3(:,0) = emico3(:,1)

c h-CS:

       emics0(:,0) = emics0(:,1)

c h-HCOP:
 
       emihcop(:,0) = emihcop(:,1)

c i-H3p

       emih3p(:,0) = emih3p(:,1)

c Calcul des colonnes densites:

       call CODENS (irec)

c--------+---------+---------+---------+---------+---------+---------+-*-------+

 4005  format (//)
 4101  format (i8)
 4004  format (3i4,3d15.6)
 4006  format (3i4,5d15.6)

       return
       end
