
c Copyright (C) 2002 - Observatoire de Paris/Meudon
c                      Universite Paris 7
c                      CNRS (France)
c                      Contact : Jacques.Lebourlot@obspm.fr
c
c This program is free software; you can redistribute it and/or
c modify it under the terms of the GNU General Public License version 2
c as published by the Free Software Foundation.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c GNU General Public License for more details.
c
c You should have received a copy of the GNU General Public License
c along with this program; if not, write to the Free Software
c Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.


c      %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
       subroutine ABONDA (iimax, irec)
c      %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

       use constantes
       use prepvar
       use auxiliaries
       use inoutput
       USE H2_DATA
       USE HD_DATA
       USE SP_DATA
       USE CHEM_DATA
       USE PROFIL

       implicit double precision (a-h,o-z)

c  definition des variables locales.
c  (les variables transmises sont dans INCLUDE).

       character (LEN=8)  :: yspec
       character (LEN=2)  :: ii2c

c--------+---------+---------+---------+---------+---------+---------+-*-------+

 1001    iimax = iimax + 1
         print *, ' De quelle espece voulez-vous l abondance? (fin: -1)'
         read (*,5) yspec
         if (irec == 1) then
           write (8,5) yspec
         endif
   5     format(a8)

         if (yspec == '-1') then
           iimax = iimax - 1
           goto 1002
         endif

         ii2 = 0
         do jj=1,nspec
           if (speci(jj) == yspec) then
             ii2 = jj
             exit
           endif
         end do
         if (ii2 /= 0 .and. ii2 /= i_h2gr) then
           do j=0,npo
             y(iimax,j) = abnua(ii2,j)
           end do
           texty(iimax) = TRIM('Ab__'//speci(ii2))
         else if (ii2 == i_h2gr) then
           do mm=1,npg
             do j=0,npo
               y(iimax,j) = abnua(ii2+mm-1,j)
             end do
             texty(iimax) = 'Ab_H2:'//ii2c(mm)
             iimax = iimax + 1
           end do
           iimax = iimax - 1
         else
           do j=0,npo
             y(iimax,j) = 0.0d0
           end do
           texty(iimax) = TRIM('Ab__'//yspec)
         endif

         if (yspec == 'h2') then
 2101      print *
           print *, '   Retour au choix des especes'
           print *, ' 0-oui'
           print *, '   Voulez-vous les populations relatives?'
           print *, ' 1-oui pour la bande X'
           print *, ' 2-oui pour la bande B'
           print *, ' 3-oui pour la bande C'
           print *, '   Souhaitez-vous les rapports O/P'
           print *, ' 4-oui'
           read  *,ii4
           ii3 = 0

           if (irec == 1) then
              write (8,*) ii4
           endif

           if (ii4 == 0) then

              goto 1001 !retour au choix des especes

           else if (ii4 == 1) then

             print *, '1: lev,   2: v J,   3: v'
             read *, ii3
             if (irec == 1) then
                write (8,*) ii3
             endif

             if (ii3 == 1) then

               print *, 'lev: numero du niveau desire'
               read  *, lev
               if (irec == 1) then
                write (8,*) lev
               endif
               ivl = nvlev(lev)
               ijl = njlev(lev)

             else if (ii3 == 2) then

               print *, 'Entrez le v,j du niveau demande'
               read  *, ivl, ijl
               if (irec == 1) then
                write (8,*) ivl, ijl
               endif
               lev = level(ivl,ijl)

             else if (ii3 == 3) then

               lev = 0
               print *, 'v: niveau vibrationnel demande'
               read *, ivl
               if (irec == 1) then
                 write (8,*) ivl
               endif

             else

               print *, ' Choix:', ii3, ' impossible'
               goto 2101

             endif

             iimax = iimax + 1
             if (lev > 0) then
               do j=0,npo
                 y(iimax,j) = xreh2(lev,j)
               end do
               texty(iimax) = 'h2X_v'//ii2c(ivl)//'J'//ii2c(ijl)
             else
               do j=0,npo
                 y(iimax,j) = h2v(ivl,j)
               end do
               texty(iimax) = 'h2X_v'//ii2c(ivl)
             endif

           else if (ii4 == 2) then

             print *, 'Entrez le v,j du niveau demande'
             read  *, ivl, ijl
             if (irec == 1) then
              write (8,*) ivl, ijl
             endif

             iimax = iimax + 1
             do j=0, npo
                y(iimax,j) = h2bnua(ivl,ijl,j)
             enddo
             texty(iimax) = 'h2B_v'//ii2c(ivl)//'J'//ii2c(ijl)

           else if (ii4 == 3) then

             print *, 'Entrez le v,j du niveau demande'
             read  *, ivl, ijl
             if (irec == 1) then
              write (8,*) ivl, ijl
             endif

             iimax = iimax + 1
             do j=0, npo
                y(iimax,j) = h2cnua(ivl,ijl,j)
             enddo
             texty(iimax) = 'h2C_v'//ii2c(ivl)//'J'//ii2c(ijl)

           else if (ii4 == 4) then

             print *, '1: Rap O/P total, 2: Rap O/P v>=1'
             print *, '0-retour'
             read *, ii5
               if (irec == 1) then
                  write (8,*) ii5
               endif

             iimax = iimax + 1
             if (ii5 == 1) then
               do j=0,npo
                 oh2 = 0.0d0
                 ph2 = 0.0d0
                 do levl=1,l0h2
                   ivl = nvlev(levl)
                   ijl = njlev(levl)
                   if (mod(ijl,2) == 0) then
                     ph2 = ph2 + xreh2(levl,j)
                   else
                     oh2 = oh2 + xreh2(levl,j)
                   endif
                 end do
                   y(iimax,j) = oh2/ph2
               end do
               texty(iimax) = 'Rap_OsP_t '

             else if (ii5 == 2) then
               do j=0,npo
                 oh2 = 0.0d0
                 ph2 = 0.0d0
                 do levl=1,l0h2
                   ivl = nvlev(levl)
                   ijl = njlev(levl)
                   if (ivl >= 1) then
                     if (mod(ijl,2) == 0) then
                       ph2 = ph2 + xreh2(levl,j)
                     else
                       oh2 = oh2 + xreh2(levl,j)
                     endif
                   endif
                 end do
                 y(iimax,j) = oh2/ph2
               end do
               texty(iimax) = 'Rap_OsP_v '

             else if ((ii5 /= 1) .and. (ii5 /= 2)) then
                 goto 2101

             endif

             goto 2101
           endif
           goto 2101
         endif


         if (yspec == 'hd') then
 2011      print *
           print *, '   Voulez-vous les populations relatives?'
 2012      print *, '     0: non,   1: lev,   2: v J '
           read *, ii3
           if (irec == 1) then
             write (8,*) ii3
           endif

           if (ii3 == 0) then
             goto 1001
           else if (ii3 == 1) then
             print *, '        lev: numero du niveau desire'
             read *, lev
             if (irec == 1) then
               write (8,*) lev
             endif
             ivl = nvhd(lev)
             ijl = njhd(lev)
           else if(ii3 == 2) then
             print *, '        v J: niveau demande'
             read *, ivl, ijl
             if (irec == 1) then
               write (8,*) ivl, ijl
             endif
             lev = levhd(ivl,ijl)
           else
             print *, '   *** valeur impossible'
             goto 2012
           endif

           iimax = iimax + 1

           do 32 j=0,npo
             y(iimax,j) = xrehd(lev,j)
   32      continue
           texty(iimax) = 'hd_v0_J'//ii2c(ijl)

           goto 2011

         endif


         if (yspec == 'co') then
           print *
           print *, '   Voulez-vous les populations relatives des J?'
 2003      print *, '          Entrez la valeur de J (-1: termine)'
           read *, ii3
           if (irec == 1) then
             write (8,*) ii3
           endif
           if (ii3 >= 0) then
             iimax = iimax + 1
             do j=0,npo
               y(iimax,j) = xreco0(ii3+1,j)
             end do
             texty(iimax) = 'co_J='//ii2c(ii3)
             goto 2003
           endif
         endif

         if (yspec == 'c*o') then
           print *
           print *, '   Voulez-vous les populations relatives des J?'
 2004      print *, '          Entrez la valeur de J (-1: termine)'
           read *, ii3
           if (irec == 1) then
             write (8,*) ii3
           endif
           if (ii3 >= 0) then
             iimax = iimax + 1
             do j=0,npo
               y(iimax,j) = xreco1(ii3+1,j)
             end do
             texty(iimax) = 'c*o_J='//ii2c(ii3)
             goto 2004
           endif
         endif

         if (yspec == 'co*') then
           print *
           print *, '   Voulez-vous les populations relatives des J?'
 2005      print *, '          Entrez la valeur de J (-1: termine)'
           read *, ii3
           if (irec == 1) then
             write (8,*) ii3
           endif
           if (ii3 >= 0) then
             iimax = iimax + 1
             do j=0,npo
               y(iimax,j) = xreco2(ii3+1,j)
             end do
             texty(iimax) = 'co*_J='//ii2c(ii3)
             goto 2005
           endif
         endif

         if (yspec == 'c*o*') then
           print *
           print *, '   Voulez-vous les populations relatives des J?'
 2006      print *, '          Entrez la valeur de J (-1: termine)'
           read *, ii3
           if (irec == 1) then
             write (8,*) ii3
           endif
           if (ii3 >= 0) then
             iimax = iimax + 1
             do j=0,npo
               y(iimax,j) = xreco3(ii3+1,j)
             end do
             texty(iimax) = 'c*o*_J='//ii2c(ii3)
             goto 2006
           endif
         endif

         if (yspec == 'cs') then
           print *
           print *, '   Voulez-vous les populations relatives des J?'
 2103      print *, '          Entrez la valeur de J (-1: termine)'
           read *, ii3
           if (irec == 1) then
             write (8,*) ii3
           endif
           if (ii3 >= 0) then
             iimax = iimax + 1
             do  j=0,npo
               y(iimax,j) = xrecs0(ii3+1,j)
             end do
             texty(iimax) = 'cs_J='//ii2c(ii3)
             goto 2103
           endif
         endif

      if ((yspec == 'hco+') .or. (yspec == 'hcop')) then
         print *
         print *, '   Voulez-vous les populations relatives des J?'
 2104    print *, '          Entrez la valeur de J (-1: termine)'
         read *, ii3
         if (irec == 1) then
            write (8,*) ii3
         endif
         if (ii3 >= 0) then
            iimax = iimax + 1
            do  j=0,npo
               y(iimax,j) = xrehcop(ii3+1,j)
            end do
            texty(iimax) = 'hcop_J='//ii2c(ii3)
            goto 2104
         endif
      endif

      if (yspec == 'h2o') then
         print *
         print *, '   Voulez-vous les populations relatives niveaux?'
 2105    print *, '          Entrez le numero du niveau (-1: termine)'
         read *, ii3
         if (irec == 1) then
            write (8,*) ii3
         endif
         if (ii3 >= 0) then
            iimax = iimax + 1
            do  j=0,npo
               y(iimax,j) = xreh2o(ii3,j)
            end do
            texty(iimax) = 'h2o_J='//ii2c(ii3)
            goto 2105
         endif
      endif

      if ((yspec == 'h3+') .or. (yspec == 'h3p')) then
         print *
 2106    print *, '   Voulez-vous les populations relatives des J, K?'
         print *, '   1- Oui;  0- Non'
         print *, '   2- Tous les niveaux'
         read  *, ii3
         if (irec == 1) then
            write(8,*) ii3
         endif
         if (ii3 == 0) goto 1001 ! retour choix especes
         if (ii3 == 1) then
            print *, 'Entrez la valeur de: J K'
            read *, ij, ik
            if (irec == 1) then
               write (8,*) ij, ik
            endif
            if (levh3p(ij,ik) > 0) then
               iimax = iimax + 1
               do j=0,npo
                  y(iimax,j) = xreh3p(levh3p(ij,ik),j)
               end do
               texty(iimax) = 'h3p_J='//ii2c(ij)//",K="//ii2c(ik)
               goto 2106
            else
               PRINT *,"Niveau inexistant, ou non calcule"
               goto 2106
            endif
         endif
         if (ii3 == 2) then
            do ii = 1, nlvh3p
               iimax = iimax+1
               do j=0,npo
                  y(iimax,j) = xreh3p(ii,j)
               enddo
               ij = elevh3p(ii)%J
               ik = elevh3p(ii)%K
               texty(iimax) = 'h3p_J='//ii2c(ij)//",K="//ii2c(ik)
            enddo
            goto 2106
         endif
      endif

         if (yspec == 'c' .OR. yspec == 'C') then
           print *
           print *, '   Voulez-vous les populations relatives des J?'
 2008      print *, '   Valeurs possibles 1 a 5 (-1: termine)'
           print *, '           1 - 3P J = 0'
           print *, '           2 - 3P J = 1'
           print *, '           3 - 3P J = 2'
           print *, '           4 - 1D J = 2'
           print *, '           5 - 1S J = 0'
           read *, ii3
           if (irec == 1) then
             write (8,*) ii3
           endif
           if (ii3 > 0 .AND. ii3 < 6) then
             iimax = iimax + 1
             do j=0,npo
               y(iimax,j) = xrecat(ii3,j)
             end do
           else if (ii3 == -1) then
             continue
           else
             print *, '  Valeur impossible'
             goto 2008
           endif
           if (ii3 /= -1) then
             texty(iimax) = 'C_lev='//ii2c(ii3)
             goto 2008
           endif
         endif

         if (yspec == 'n' .OR. yspec == 'N') then
           print *
           print *, '   Voulez-vous les populations relatives des J?'
 2018      print *, '   Valeurs possibles 1 a 5 (-1: termine)'
           print *, '           1 - 4So J = 3/2'
           print *, '           2 - 2Do J = 5/2'
           print *, '           3 - 2Do J = 3/2'
           print *, '           4 - 2Po J = 1/2'
           print *, '           5 - 2Po J = 3/2'
           read *, ii3
           if (irec == 1) then
             write (8,*) ii3
           endif
           if (ii3 > 0 .AND. ii3 < 6) then
             iimax = iimax + 1
             do j=0,npo
               y(iimax,j) = xrenat(ii3,j)
             end do
           else if (ii3 == -1) then
             continue
           else
             print *, '  Valeur impossible'
             goto 2018
           endif
           if (ii3 /= -1) then
             texty(iimax) = 'N_lev='//ii2c(ii3)
             goto 2018
           endif
         endif

         if (yspec == 'o' .OR. yspec == 'O') then
           print *
           print *, '   Voulez-vous les populations relatives des J?'
 2007      print *, '   Valeurs possibles 1 a 5 (-1: termine)'
           print *, '           1 - 3P J = 2'
           print *, '           2 - 3P J = 1'
           print *, '           3 - 3P J = 0'
           print *, '           4 - 1D J = 2'
           print *, '           5 - 1S J = 0'
           read *, ii3
           if (irec == 1) then
             write (8,*) ii3
           endif
           if (ii3 > 0 .AND. ii3 < 6) then
             iimax = iimax + 1
             do j=0,npo
               y(iimax,j) = xreoat(ii3,j)
             end do
           else if (ii3 == -1) then
             continue
           else
             print *, '  Valeur impossible'
             goto 2007
           endif
           if (ii3 /= -1) then
             texty(iimax) = 'O_lev='//ii2c(ii3)
             goto 2007
           endif
         endif

         if (yspec == 's' .OR. yspec == 'S') then
           print *
           print *, '   Voulez-vous les populations relatives des J?'
 2017      print *, '   Valeurs possibles 1 a 5 (-1: termine)'
           print *, '           1 - 3P J = 2'
           print *, '           2 - 3P J = 1'
           print *, '           3 - 3P J = 0'
           print *, '           4 - 1D J = 2'
           print *, '           5 - 1S J = 0'
           read *, ii3
           if (irec == 1) then
             write (8,*) ii3
           endif
           if (ii3 > 0 .AND. ii3 < 6) then
             iimax = iimax + 1
             do j=0,npo
               y(iimax,j) = xresat(ii3,j)
             end do
           else if (ii3 == -1) then
             continue
           else
             print *, '  Valeur impossible'
             goto 2017
           endif
           if (ii3 /= -1) then
             texty(iimax) = 'S_lev='//ii2c(ii3)
             goto 2017
           endif
         endif

         if (yspec == 'si' .OR. yspec == 'Si') then
           print *
           print *, '   Voulez-vous les populations relatives des J?'
 2027      print *, '   Valeurs possibles 1 a 5 (-1: termine)'
           print *, '           1 - 3P J = 0'
           print *, '           2 - 3P J = 1'
           print *, '           3 - 3P J = 2'
           print *, '           4 - 1D J = 2'
           print *, '           5 - 1S J = 0'
           read *, ii3
           if (irec == 1) then
             write (8,*) ii3
           endif
           if (ii3 > 0 .AND. ii3 < 6) then
             iimax = iimax + 1
             do j=0,npo
               y(iimax,j) = xresiat(ii3,j)
             end do
           else if (ii3 == -1) then
             continue
           else
             print *, '  Valeur impossible'
             goto 2027
           endif
           if (ii3 /= -1) then
             texty(iimax) = 'Si_lev='//ii2c(ii3)
             goto 2027
           endif
         endif

         if (yspec == 'c+' .OR. yspec == 'C+') then
           print *
           print *, '   Voulez-vous les populations relatives des J?'
 2009      print *, '   Valeurs possibles 1 a 5 (-1: termine)'
           print *, '           1 - 2P J = 1/2'
           print *, '           2 - 2P J = 3/2'
           print *, '           3 - 4P J = 1/2'
           print *, '           4 - 4P J = 3/2'
           print *, '           5 - 4P J = 5/2'
           read *, ii3
           if (irec == 1) then
             write (8,*) ii3
           endif
           if (ii3 > 0 .AND. ii3 < 6) then
             iimax = iimax + 1
             do j=0,npo
               y(iimax,j) = xrecpl(ii3,j)
             end do
           else if (ii3 == -1) then
             continue
           else
             print *, '  Valeur impossible'
             goto 2009
           endif
           if (ii3 /= -1) then
             texty(iimax) = 'C+_lev='//ii2c(ii3)
             goto 2009
           endif
         endif

         if (yspec == 'n+' .OR. yspec == 'N+') then
           print *
           print *, '   Voulez-vous les populations relatives des J?'
 2037      print *, '   Valeurs possibles 1 a 5 (-1: termine)'
           print *, '           1 - 3P J = 0'
           print *, '           2 - 3P J = 1'
           print *, '           3 - 3P J = 2'
           print *, '           4 - 1D J = 2'
           print *, '           5 - 1S J = 0'
           read *, ii3
           if (irec == 1) then
             write (8,*) ii3
           endif
           if (ii3 > 0 .AND. ii3 < 6) then
             iimax = iimax + 1
             do j=0,npo
               y(iimax,j) = xrenpl(ii3,j)
             end do
           else if (ii3 == -1) then
             continue
           else
             print *, '  Valeur impossible'
             goto 2037
           endif
           if (ii3 /= -1) then
             texty(iimax) = 'N+_lev='//ii2c(ii3)
             goto 2037
           endif
         endif

         if (yspec == 'o+' .OR. yspec == 'O+') then
           print *
           print *, '   Voulez-vous les populations relatives des J?'
 2047      print *, '   Valeurs possibles 1 a 5 (-1: termine)'
           print *, '           1 - 4So J = 3/2'
           print *, '           2 - 2Do J = 5/2'
           print *, '           3 - 2Do J = 3/2'
           print *, '           4 - 2Po J = 3/2'
           print *, '           5 - 2Po J = 1/2'
           read *, ii3
           if (irec == 1) then
             write (8,*) ii3
           endif
           if (ii3 > 0 .AND. ii3 < 6) then
             iimax = iimax + 1
             do j=0,npo
               y(iimax,j) = xreopl(ii3,j)
             end do
           else if (ii3 == -1) then
             continue
           else
             print *, '  Valeur impossible'
             goto 2047
           endif
           if (ii3 /= -1) then
             texty(iimax) = 'O+_lev='//ii2c(ii3)
             goto 2047
           endif
         endif

         if (yspec == 's+' .OR. yspec == 'S+') then
           print *
           print *, '   Voulez-vous les populations relatives des J?'
 2013      print *, '   Valeurs possibles 1 a 3 (-1: termine)'
           print *, '           1 - 4So J = 3/2'
           print *, '           2 - 2So J = 3/2'
           print *, '           3 - 2So J = 5/2'
           print *, '           4 - 2Po J = 1/2'
           print *, '           5 - 2Po J = 3/2'
           read *, ii3
           if (irec == 1) then
             write (8,*) ii3
           endif
           if (ii3 > 0 .AND. ii3 < 6) then
             iimax = iimax + 1
             do j=0,npo
               y(iimax,j) = xrespl(ii3,j)
             end do
           else if (ii3 == -1) then
             continue
           else
             print *, '  Valeur impossible'
             goto 2013
           endif
           if (ii3 /= -1) then
             texty(iimax) = 'S+_lev='//ii2c(ii3)
             goto 2013
           endif
         endif

         if (yspec == 'si+' .OR. yspec == 'Si+') then
           print *
           print *, '   Voulez-vous les populations relatives des J?'
 2023      print *, '   Valeurs possibles 1 a 3 (-1: termine)'
           print *, '           1 - 2P J = 1/2'
           print *, '           2 - 2P J = 3/2'
           print *, '           3 - 4P J = 1/2'
           print *, '           4 - 4P J = 3/2'
           print *, '           5 - 4P J = 5/2'
           read *, ii3
           if (irec == 1) then
             write (8,*) ii3
           endif
           if (ii3 > 0 .AND. ii3 < 6) then
             iimax = iimax + 1
             do j=0,npo
               y(iimax,j) = xresip(ii3,j)
             end do
           else if (ii3 == -1) then
             continue
           else
             print *, '  Valeur impossible'
             goto 2023
           endif
           if (ii3 /= -1) then
             texty(iimax) = 'Si+_lev='//ii2c(ii3)
             goto 2023
           endif
         endif

         goto 1001

 1002    continue

       return
       end

       function ii2c(ii)

       implicit none
       integer, intent (in) :: ii
       character (LEN=2)    :: ii2c
       integer              :: icd, icu

       icd = 48 + ii/10
       icu = 48 + ii - 10*(ii/10)
       ii2c = char(icd)//char(icu)

       return
       end
