
c Copyright (C) 2002 - Observatoire de Paris/Meudon
c                      Universite Paris 7
c                      CNRS (France)
c                      Contact : Jacques.Lebourlot@obspm.fr
c
c This program is free software; you can redistribute it and/or
c modify it under the terms of the GNU General Public License version 2
c as published by the Free Software Foundation.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c GNU General Public License for more details.
c
c You should have received a copy of the GNU General Public License
c along with this program; if not, write to the Free Software
c Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.


c      %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
       subroutine COLDEN (iimax, irec)
c      %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

       use constantes
       use prepvar
       use inoutput
       USE H2_DATA
       USE HD_DATA
       USE SP_DATA
       USE CHEM_DATA
       USE PROFIL

        implicit double precision (a-h,o-z)

c  definition des variables locales.
c  (les variables transmises sont dans INCLUDE).

        character (LEN=8)  :: yspec
        character (LEN=2)    :: ii2c

c--------+---------+---------+---------+---------+---------+---------+-*-------+

 1001    iimax = iimax + 1
         print *, '   De quelle espece voulez-vous la colonne densite?'
         print *, '           (fin: -1)'
         read (*,5) yspec
         if (irec == 1) then
           write (8,5) yspec
         endif
   5     format(a8)

         if (yspec == '-1') then
           iimax = iimax -1
           goto 1002
         endif

         do jj=1,nspec
           if (speci(jj) == yspec) then
             ii2 = jj
           endif
         end do
         do j=0,npo
           y(iimax,j) = codesp(ii2,j)
         end do
         texty(iimax) = TRIM('CD__'//speci(ii2))

         if (yspec == 'h2') then
 2006      print *
           print *, 'Retour'
           print *, '0'
           print *, 'Voulez-vous les populations relatives?'
           print *, '1-de la bande X'
           print *, '2-de la bande B'
           print *, '3-de la bande C'
           print *, "Souhaitez-vous un diagramme d'excitation?"
           print *, '4-oui'
           print *, 'Souhaitez-vous le rapport O/P'
           print *, '5-oui'
           read  *, ii4
           ii3 = 0
           if (irec == 1) then
              write(8,*) ii4
           endif

           if ((ii4 > 0) .and. (ii4 < 4)) then
             if (ii4 == 1) then
                print *, '0: retour,   1: lev,   2: v J,   3: v'
                read *, ii3
                if (irec == 1) then
                 write (8,*) ii3
                endif
             endif

             if (ii3 == 1) then
              print *, '       lev: numero du niveau demande'
              read *, lev
              if (irec == 1) then
               write (8,*) lev
              endif
              ijl = njlev(lev)
              ivl = nvlev(lev)
             else if ((ii3 == 2) .or. (ii4 == 2)
     1         .or. (ii4 == 3)) then
              print *,'Entrez le v j du niveau souhaite'
              read *, ivl, ijl
              if (irec == 1) then
                write(8,*) ivl,ijl
              endif
              if (ii4 == 1) then
                lev = level(ivl,ijl)
              endif
             else if(ii3 == 3) then
              print *, 'v: niveau vibrationnel demande'
              read *, ivl
              if (irec == 1) then
                write (8,*) ivl
              endif
              lev = 0
             else
              print *, 'Vous avez du faire une erreur'
              goto 2006
             endif

             iimax = iimax + 1


            if (ii4 == 1) then
              if (lev > 0) then
                do 585 j=0,npo
                  y(iimax,j) = codeh2(lev,j)
  585           continue
                texty(iimax) = 'CDh2_v'//ii2c(ivl)//'J'//ii2c(ijl)
                goto 2006
              else
                do 31 j=0,npo
                  y(iimax,j) = codh2v(ivl,j)
   31           continue
                texty(iimax) = 'CDh2_v='//ii2c(ivl)
              endif

            else if (ii4 == 2) then
              do 32 j=0,npo
                y(iimax,j)=codeh2b(ivl,ijl,j)
   32         continue
              texty(iimax) = 'NH2Bv'//ii2c(ivl)//'J'//ii2c(ijl)
              goto 2006

            else if (ii4 == 3) then
              do 33 j=0,npo
               y(iimax,j)=codeh2c(ivl,ijl,j)
  33          continue
              texty(iimax) = 'NH2Cv'//ii2c(ivl)//'J'//ii2c(ijl)
              goto 2006

           endif

           else if (ii4 == 4) then
c            iimax=iimax-1
             call EXCIT(iimax,irec)
             goto 2006

           else if (ii4 == 5) then
             do j=0,npo
               y(iimax,j) = cdoph2(1,j)
             end do
             texty(iimax) = "OP_i_tot"

             iimax = iimax + 1

             do j=0,npo
              y(iimax,j) = cdoph2(2,j)
             end do
             texty(iimax) = "OP_i_emi"

             iimax = iimax + 1

             do j=0,npo
              y(iimax,j) = cdoph2(3,j)
             end do
             texty(iimax) = "OP_i_vib"
             goto 2006

           endif

         endif

         if (yspec == 'hd') then
 3006      print *
           print *, '   Voulez-vous les populations relatives?'
 3010      print *, '     0: non,   1: lev,   2: v J '
           read *, ii3
           if (irec == 1) then
             write (8,*) ii3
           endif

           if (ii3 == 0) then
             goto 1001
           else if (ii3 == 1) then
             print *, '       lev: numero du niveau demande'
             read *, lev
             if (irec == 1) then
               write (8,*) lev
             endif
             ijl = njhd(lev)
             ivl = nvhd(lev)
           else if (ii3 == 2) then
             print *, '       v J: niveau demande'
             read *, ivl, ijl
             if (irec == 1) then
               write (8,*) ivl, ijl
             endif
             lev = levhd(ivl,ijl)
           else
             print *, '   *** valeur impossible'
             goto 3010
           endif

           iimax = iimax + 1

             do 3585 j=0,npo
               y(iimax,j) = codehd(lev,j)
 3585        continue
             texty(iimax) = 'CDhd_v'//ii2c(ivl)//'J'//ii2c(ijl)

           goto 3006

         endif


         if (yspec == 'co') then
           print *
           print *, '   Voulez-vous les populations relatives des J?'
 2007      print *, '          Entrez la valeur de J (-1: termine)'
           read *, ii3
           if (irec == 1) then
             write (8,*) ii3
           endif
           if (ii3 >= 0) then
             iimax = iimax + 1
             do j=0,npo
               y(iimax,j) = cdeco0(ii3+1,j)
             end do
             texty(iimax) = 'CD_co_J='//ii2c(ii3)
             goto 2007
           endif
           print *, "Do you want an excitation diagram?"
           print *, '1-yes, 0-no'
           read  *, ii3
           if (irec == 1) then
              write(8,*) ii3
           endif
           if (ii3 == 1) then
             fichier = TRIM(out_dir)//TRIM(modele)//'.co_e'
             open (unit=52, file=fichier, status="unknown")
             do i=1,nlvco0
               write (52,'(i4,1p,2e15.6)') i, elkco0(i)
     1             , cdeco0(i,npo)/gstco0(i)
             end do
             close (unit=52)
           endif
         endif

         if (yspec == 'c*o') then
           print *
           print *, '   Voulez-vous les populations relatives des J?'
 2017      print *, '          Entrez la valeur de J (-1: termine)'
           read *, ii3
           if (irec == 1) then
             write (8,*) ii3
           endif
           if (ii3 >= 0) then
             iimax = iimax + 1
             do j=0,npo
               y(iimax,j) = cdeco1(ii3+1,j)
             end do
             texty(iimax) = 'CD_c*o_J='//ii2c(ii3)
             goto 2017
           endif
         endif

         if (yspec == 'co*') then
           print *
           print *, '   Voulez-vous les populations relatives des J?'
 2027      print *, '          Entrez la valeur de J (-1: termine)'
           read *, ii3
           if (irec == 1) then
             write (8,*) ii3
           endif
           if (ii3 >= 0) then
             iimax = iimax + 1
             do j=0,npo
               y(iimax,j) = cdeco2(ii3+1,j)
             end do
             texty(iimax) = 'CD_co*_J='//ii2c(ii3)
             goto 2027
           endif
         endif

         if (yspec == 'c*o*') then
           print *
           print *, '   Voulez-vous les populations relatives des J?'
 2037      print *, '          Entrez la valeur de J (-1: termine)'
           read *, ii3
           if (irec == 1) then
             write (8,*) ii3
           endif
           if (ii3 >= 0) then
             iimax = iimax + 1
             do j=0,npo
               y(iimax,j) = cdeco3(ii3+1,j)
             end do
             texty(iimax) = 'CD_c*o*_J='//ii2c(ii3)
             goto 2037
           endif
         endif

         if (yspec == 'cs') then
           print *
           print *, '   Voulez-vous les populations relatives des J?'
 2107      print *, '          Entrez la valeur de J (-1: termine)'
           read *, ii3
           if (irec == 1) then
             write (8,*) ii3
           endif
           if (ii3 >= 0) then
             iimax = iimax + 1
             do  j=0,npo
               y(iimax,j) = codecs(ii3+1,j)
             end do
             texty(iimax) = 'CD_cs_J='//ii2c(ii3)
             goto 2107
           endif
         endif

         if ((yspec == 'hco+') .or. (yspec == 'hcop')) then
           print *
           print *, '   Voulez-vous les populations relatives des J?'
 2108      print *, '          Entrez la valeur de J (-1: termine)'
           read *, ii3
           if (irec == 1) then
             write (8,*) ii3
           endif
           if (ii3 >= 0) then
             iimax = iimax + 1
             do  j=0,npo
               y(iimax,j) = codehcop(ii3+1,j)
             end do
             texty(iimax) = 'CD_hcop_J='//ii2c(ii3)
             goto 2108
           endif
         endif

         if (yspec == 'h2o') then
           print *
           print *, '   Do you want relative populations?'
 2130      print *, '          Enter level (-1: termine)'
           read *, ii3
           if (irec == 1) then
             write (8,*) ii3
           endif
           if (ii3 >= 0) then
             iimax = iimax + 1
             do  j=0,npo
               y(iimax,j) = codeh2o(ii3+1,j)
             end do
             texty(iimax) = 'CD_h2o_J='//ii2c(ii3)
             goto 2130
           endif
           print *, "Do you want an excitation diagram?"
           print *, '1-yes, 0-no'
           read  *, ii3
           if (irec == 1) then
              write(8,*) ii3
           endif
           if (ii3 == 1) then
             fichier = TRIM(out_dir)//TRIM(modele)//'.h2o_e'
             open (unit=52, file=fichier, status="unknown")
             do i=1,nlvh2o
               write (52,'(i4,1p,2e15.6)') i, elkh2o(i)
     1             , codeh2o(i,npo)/gsth2o(i)
             end do
             close (unit=52)
           endif
         endif

      if ((yspec == 'h3+') .or. (yspec == 'h3p')) then
         print *
 2106    print *, '   Voulez-vous les populations relatives des J, K?'
         print *, '   1- Oui;  0- Non'
         print *, '   2- Tout'
         read  *, ii3
         if (irec == 1) then
            write(8,*) ii3
         endif

         IF (ii3 == 1) THEN
            print *, 'Entrez la valeur de: J K'
            read *, ij, ik
            if (irec == 1) then
               write (8,*) ij, ik
            endif
            if (levh3p(ij,ik) > 0) then
               iimax = iimax + 1
               do j=0,npo
                  y(iimax,j) = codeh3p(levh3p(ij,ik),j)
               end do
               texty(iimax) = 'CD_h3p_J='//ii2c(ij)//",K="//ii2c(ik)
               goto 2106
            else
               PRINT *,"Niveau inexistant, ou non calcule"
               goto 2106
            endif
         ELSE IF (ii3 == 2) THEN
            Do ilev = 1, nlvh3p
               iimax = iimax + 1
               do j=0,npo
                  y(iimax,j) = codeh3p(ilev,j)
               end do
               ij = elevh3p(ilev)%J
               ik = elevh3p(ilev)%K
               texty(iimax) = 'CD_h3p_J='//ii2c(ij)//",K="//ii2c(ik)
            ENDDO
            GOTO 1001 ! retour choix des especes
         ELSE
            GOTO 1001 ! retour choix des especes
         ENDIF
      endif

         if (yspec == 'c' .OR. yspec == 'C') then
           print *
           print *, '   Voulez-vous les populations relatives des J?'
 2110      print *, '   Valeurs possibles 1 a 5 (-1: termine)'
           print *, '           1 - 3P J = 0'
           print *, '           2 - 3P J = 1'
           print *, '           3 - 3P J = 2'
           print *, '           4 - 1D J = 2'
           print *, '           5 - 1S J = 0'
           read *, ii3
           if (irec == 1) then
             write (8,*) ii3
           endif
           if (ii3 > 0 .AND. ii3 < 6) then
             iimax= iimax+1
             do j=0,npo
              y(iimax,j) = codecat(ii3,j)
             enddo
           else if (ii3 == -1) then
             continue
           else
             print *,'Valeur impossible'
             goto 2110
           endif
           if (ii3 /= -1) then
             texty(iimax) = 'CD_C_l='//ii2c(ii3)
             goto 2110
           endif
         endif

         if (yspec == 'n' .OR. yspec == 'N') then
           print *
           print *, '   Voulez-vous les populations relatives des J?'
 2120      print *, '   Valeurs possibles 1 a 5 (-1: termine)'
           print *, '           1 - 4So J = 3/2'
           print *, '           2 - 2Do J = 5/2'
           print *, '           3 - 2Do J = 3/2'
           print *, '           4 - 2Po J = 1/2'
           print *, '           5 - 2Po J = 3/2'
           read *, ii3
           if (irec == 1) then
             write (8,*) ii3
           endif
           if (ii3 > 0 .AND. ii3 < 6) then
             iimax= iimax+1
             do j=0,npo
              y(iimax,j) = codenat(ii3,j)
             enddo
           else if (ii3 == -1) then
             continue
           else
             print *,'Valeur impossible'
             goto 2120
           endif
           if (ii3 /= -1) then
             texty(iimax) = 'CD_N_l='//ii2c(ii3)
             goto 2120
           endif
         endif

         if (yspec == 'o' .OR. yspec == 'O') then
           print *
           print *, '   Voulez-vous les populations relatives des J?'
 2109      print *, '   Valeurs possibles 1 a 5 (-1: termine)'
           print *, '           1 - 3P J = 2'
           print *, '           2 - 3P J = 1'
           print *, '           3 - 3P J = 0'
           print *, '           4 - 1D J = 2'
           print *, '           5 - 1S J = 0'
           read *, ii3
           if (irec == 1) then
             write (8,*) ii3
           endif
           if (ii3 > 0 .AND. ii3 < 6) then
             iimax= iimax+1
             do j=0,npo
              y(iimax,j) = codeoat(ii3,j)
             enddo
           else if (ii3 == -1) then
             continue
           else
             print *,'Valeur impossible'
             goto 2109
           endif
           if (ii3 /= -1) then
             texty(iimax) = 'CD_O_l='//ii2c(ii3)
             goto 2109
           endif
         endif

         if (yspec == 's' .OR. yspec == 'S') then
           print *
           print *, '   Voulez-vous les populations relatives des J?'
 2119      print *, '   Valeurs possibles 1 a 5 (-1: termine)'
           print *, '           1 - 3P J = 2'
           print *, '           2 - 3P J = 1'
           print *, '           3 - 3P J = 0'
           print *, '           4 - 1D J = 2'
           print *, '           5 - 1S J = 0'
           read *, ii3
           if (irec == 1) then
             write (8,*) ii3
           endif
           if (ii3 > 0 .AND. ii3 < 6) then
             iimax= iimax+1
             do j=0,npo
              y(iimax,j) = codesat(ii3,j)
             enddo
           else if (ii3 == -1) then
             continue
           else
             print *,'Valeur impossible'
             goto 2119
           endif
           if (ii3 /= -1) then
             texty(iimax) = 'CD_S_l='//ii2c(ii3)
             goto 2119
           endif
         endif

         if (yspec == 'si' .OR. yspec == 'Si') then
           print *
           print *, '   Voulez-vous les populations relatives des J?'
 2129      print *, '   Valeurs possibles 1 a 5 (-1: termine)'
           print *, '           1 - 3P J = 0'
           print *, '           2 - 3P J = 1'
           print *, '           3 - 3P J = 2'
           print *, '           4 - 1D J = 2'
           print *, '           5 - 1S J = 0'
           read *, ii3
           if (irec == 1) then
             write (8,*) ii3
           endif
           if (ii3 > 0 .AND. ii3 < 6) then
             iimax= iimax+1
             do j=0,npo
              y(iimax,j) = codesiat(ii3,j)
             enddo
           else if (ii3 == -1) then
             continue
           else
             print *,'Valeur impossible'
             goto 2129
           endif
           if (ii3 /= -1) then
             texty(iimax) = 'CD_Si_l='//ii2c(ii3)
             goto 2129
           endif
         endif

         if (yspec == 'c+' .OR. yspec == 'C+') then
           print *
           print *, '   Voulez-vous les populations relatives des J?'
 2111      print *, '   Valeurs possibles 1 a 5 (-1: termine)'
           print *, '           1 - 2P J = 1/2'
           print *, '           2 - 2P J = 3/2'
           print *, '           3 - 4P J = 1/2'
           print *, '           4 - 4P J = 3/2'
           print *, '           5 - 4P J = 5/2'
           read *, ii3
           if (irec == 1) then
             write (8,*) ii3
           endif
           if (ii3 > 0 .AND. ii3 < 6) then
             iimax= iimax+1
             do j=0,npo
              y(iimax,j) = codecpl(ii3,j)
             enddo
           else if (ii3 == -1) then
             continue
           else
             print *,'Valeur impossible'
             goto 2111
           endif
           if (ii3 /= -1) then
             texty(iimax) = 'CD_C+_l='//ii2c(ii3)
             goto 2111
           endif
         endif

         if (yspec == 'n+' .OR. yspec == 'N+') then
           print *
           print *, '   Voulez-vous les populations relatives des J?'
 2121      print *, '   Valeurs possibles 1 a 5 (-1: termine)'
           print *, '           1 - 3P J = 0'
           print *, '           2 - 3P J = 1'
           print *, '           3 - 3P J = 2'
           print *, '           4 - 1D J = 2'
           print *, '           5 - 1S J = 0'
           read *, ii3
           if (irec == 1) then
             write (8,*) ii3
           endif
           if (ii3 > 0 .AND. ii3 < 6) then
             iimax= iimax+1
             do j=0,npo
              y(iimax,j) = codenpl(ii3,j)
             enddo
           else if (ii3 == -1) then
             continue
           else
             print *,'Valeur impossible'
             goto 2121
           endif
           if (ii3 /= -1) then
             texty(iimax) = 'CD_N+_l='//ii2c(ii3)
             goto 2121
           endif
         endif

         if (yspec == 'o+' .OR. yspec == 'O+') then
           print *
           print *, '   Voulez-vous les populations relatives des J?'
 2141      print *, '   Valeurs possibles 1 a 5 (-1: termine)'
           print *, '           1 - 4So J = 3/2'
           print *, '           2 - 2Do J = 5/2'
           print *, '           3 - 2Do J = 3/2'
           print *, '           4 - 2Po J = 3/2'
           print *, '           5 - 2Po J = 1/2'
           read *, ii3
           if (irec == 1) then
             write (8,*) ii3
           endif
           if (ii3 > 0 .AND. ii3 < 6) then
             iimax= iimax+1
             do j=0,npo
              y(iimax,j) = codeopl(ii3,j)
             enddo
           else if (ii3 == -1) then
             continue
           else
             print *,'Valeur impossible'
             goto 2141
           endif
           if (ii3 /= -1) then
             texty(iimax) = 'CD_O+_l='//ii2c(ii3)
             goto 2141
           endif
         endif

         if (yspec == 's+' .OR. yspec == 'S+') then
           print *
           print *, '   Voulez-vous les populations relatives des J?'
 2113      print *, '   Valeurs possibles 1 a 3 (-1: termine)'
           print *, '           1 - 4So J = 3/2'
           print *, '           2 - 2Do J = 3/2'
           print *, '           3 - 2Do J = 5/2'
           print *, '           4 - 2Po J = 1/2'
           print *, '           5 - 2Po J = 3/2'
           read *, ii3
           if (irec == 1) then
             write (8,*) ii3
           endif
           if (ii3 > 0 .AND. ii3 < 6) then
             iimax= iimax+1
             do j=0,npo
              y(iimax,j) = codespl(ii3,j)
             enddo
           else if (ii3 == -1) then
             continue
           else
             print *,'Valeur impossible'
             goto 2113
           endif
           if (ii3 /= -1) then
             texty(iimax) = 'CD_S+_l='//ii2c(ii3)
             goto 2113
           endif
         endif

         if (yspec == 'si+' .OR. yspec == 'Si+') then
           print *
           print *, '   Voulez-vous les populations relatives des J?'
 2112      print *, '   Valeurs possibles 1 a 3 (-1: termine)'
           print *, '           1 - 2P J = 1/2'
           print *, '           2 - 2P J = 3/2'
           print *, '           3 - 4P J = 1/2'
           print *, '           4 - 4P J = 3/2'
           print *, '           5 - 4P J = 5/2'
           read *, ii3
           if (irec == 1) then
             write (8,*) ii3
           endif
           if (ii3 > 0 .AND. ii3 < 6) then
             iimax= iimax+1
             do j=0,npo
              y(iimax,j) = codesip(ii3,j)
             enddo
           else if (ii3 == -1) then
             continue
           else
             print *,'Valeur impossible'
             goto 2112
           endif
           if (ii3 /= -1) then
             texty(iimax) = 'CD_Si+_l='//ii2c(ii3)
             goto 2112
           endif
         endif

         goto 1001

 1002    continue

       return
       end
