
c Copyright (C) 2002 - Observatoire de Paris/Meudon
c                      Universite Paris 7
c                      CNRS (France)
c                      Contact : Jacques.Lebourlot@obspm.fr
c 
c This program is free software; you can redistribute it and/or
c modify it under the terms of the GNU General Public License version 2
c as published by the Free Software Foundation.
c 
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c GNU General Public License for more details.
c 
c You should have received a copy of the GNU General Public License
c along with this program; if not, write to the Free Software
c Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.


c      %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
       subroutine EXCIT (iimax, irec)
c      %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

       use constantes
       use prepvar
       use inoutput
       USE H2_DATA
       USE CHEM_DATA
       USE PROFIL

       implicit double precision (a-h,o-z)

       integer jop(12)
       double precision avj(12)
       integer ans

c--------+---------+---------+---------+---------+---------+---------+-*-------+

       print *, " Which excitation diagram do you whish?"
       print *, " 1- up to a specific point ?"
       print *, " 2- In a given interval ?"
       print *, " 3- Over the whole cloud ?"
       read *, ans
       if (irec == 1) then
         write (8,*) ans
       endif       

       if (ans == 3) then
         taulim = tau(2)
         jj = 0
         do j=1,npo
           if (tau(j) > taulim) then
             jj = jj + 1
             jop(jj) = j - 1
             taulim = taulim * 10.0_dp
           endif
         end do
         if (jop(jj) < npo) then
           jj = jj + 1
           jop(jj) = npo
         endif

       else if (ans == 2) then
         avmax = tau(npo) * tautav
         print *, " Give lower Av"
         print *, " Av max is:", avmax
         read  *, avchermin ! Limite inferieure de Av
         if (irec == 1) then
           write(8,*) avchermin
         endif
         print *, " Give upper Av"
         print *, " Av max is:", avmax
         read *,avchermax ! Limite superieure de Av
         if (irec == 1) then
           write(8,*) avchermax
         endif

         ! Recherche du point correspondant au Av minimal
         taucher = avchermin / tautav
         i = 1
         DO WHILE( (tau(i) < taucher) .OR. (i > npo) )
            i = i + 1
         ENDDO
         taupre = tau(i-1)
         ! le tau cherche est compris entre tau(i-1) et tau(i)
         ! On determine duquel des deux il est le plus proche
         delta1 = abs(taupre - taucher)
         delta2 = abs(tau(i) - taucher)
         if (delta1 < delta2) then 
           iopt_min = i-1
         else 
           iopt_min = i
         endif
         PRINT *,'Av min found = ', tau(iopt_min) * tautav

         ! Recherche du point correspondant au Av maximal
         taucher = avchermax / tautav

         i = 1
         DO WHILE ( (tau(i) < taucher) .OR. (i > npo) )
           i = i + 1
         ENDDO
         ! le tau cherche est compris entre tau(i-1) et tau(i)
         ! On determine duquel des deux il est le plus proche
         taupre = tau(i-1)
         delta1 = abs(taupre - taucher)
         delta2 = abs(tau(i) - taucher)
         if (delta1 < delta2) then 
           iopt_max = i-1
         else 
           iopt_max = i
         endif
         PRINT *,'Av max found = ', tau(iopt_max) * tautav

         ! On va sortir jjmax diag d'excitation tous les deltatau 
         ! entre Avmin et Avmax
         jjmax = 10
         deltatau = (tau(iopt_max) - tau(iopt_min)) / (jjmax -1)

         ! premier diagramme a Avmin
         jj = 1
         jop(jj) = iopt_min

         ! on cherche les 9 points suivants
         taucher = tau(iopt_min) + deltatau * jj ! tau recherche
         iopt_deb = iopt_min + 1  
         jj=2
         do j=iopt_deb,iopt_max+1
           if (tau(j) > taucher)  then
             delta1 = abs(taupre - taucher)
             delta2 = abs(tau(j) - taucher)
             if (delta1 < delta2) then 
               jop(jj) = j-1
             else 
               jop(jj) = j
             endif

             ! Calcule sur prochain tau a chercher
             ! REM : Dans le cas d'un intervalle Avmin, Avmax
             ! ayant moins de jjmax points, il se peut qu'on reecrive
             ! plusieurs fois les memes Av. Ce test est fait pour les
             ! supprimer
             if (tau(jop(jj)) == (tau(jop(jj-1)))) then
               jj = jj + 1
               taucher = tau(iopt_min) + deltatau * (jj-1)
               jj = jj - 1
             else
               jj = jj + 1
               taucher = tau(iopt_min) + deltatau * (jj-1)
             endif
           endif
         enddo
         jj = jj-1 ! on a incremente une fois de trop jj


       else if (ans == 1) then
         jj = 1
         avmax = tau(npo) * tautav
         print *, " At which point do you want the excitation diag ?"
         print *, " Enter a value lower than", avmax
         read *, avcher
         if (irec == 1) then
           write (8,*) avcher
         endif
         taucher = avcher / tautav

         ! Recherche du tau souhaite
         i = 1
         DO WHILE( (tau(i) < taucher) .OR. (i > npo) )
           i = i + 1
         ENDDO
         taupre = tau(i-1)

         delta1 = abs(taupre - taucher)
         delta2 = abs(tau(i) - taucher)
         if (delta1 < delta2) then 
           jop(jj) = i-1
         else 
           jop(jj) = i
         endif
           
       endif   

       fichier = TRIM(out_dir)//TRIM(modele)//'.exc'
       open (18, file=fichier, status = "unknown")

       do j=1,jj
         avj(j) = tau(jop(j)) * tautav
       enddo   

       write(18,1002) (avj(j),j=1,jj)
 1002  format(2x,'num', 4x,'v',4x,'j',3x,'energie K',2x,'Av',
     1        1p,E9.3,2x,9(1p,E9.3,3x))

       do lev=1,l0h2
         ju = njlev(lev)
         if (ju <= njh2) then
           if (mod(ju,2) == 1) then
             gg = (2.0*ju+1.0) * 3.0
           else
             gg = 2.0*ju+1.0
           endif
           write(18,1001) lev, nvlev(lev), ju,
     1                    elhm(lev), (codeh2(lev,jop(j))/gg, j=1,jj)
         endif
       end do

       print *,' Results written in:', fichier
       close (18)

 1001  format (3i5,1p,13e12.3)

       return
       end
