
c Copyright (C) 2002 - Observatoire de Paris/Meudon
c                      Universite Paris 7
c                      CNRS (France)
c                      Contact : Jacques.Lebourlot@obspm.fr
c
c This program is free software; you can redistribute it and/or
c modify it under the terms of the GNU General Public License version 2
c as published by the Free Software Foundation.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c GNU General Public License for more details.
c
c You should have received a copy of the GNU General Public License
c along with this program; if not, write to the Free Software
c Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.


c      %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
       subroutine EMISSI (iimax, irec)
c      %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

       use constantes
       use prepvar
       use inoutput
       USE H2_DATA
       USE HD_DATA
       USE SP_DATA
       USE STR_DATA
       USE CHEM_DATA
       USE PROFIL
       USE INTEMI

        implicit double precision (a-h,o-z)

c  definition des variables locales.
c  (les variables transmises sont dans INCLUDE).

        character (LEN=8)  :: yspec
        character (LEN=2)    :: ii2c
        real (kind=DP), allocatable, dimension(:) :: xi

c--------+---------+---------+---------+---------+---------+---------+-*-------+

         if (.NOT. ALLOCATED(xi)) then
           ALLOCATE (xi(0:npo))
         endif

         print *, '   Voulez-vous des emissivites locales ou integrees?'
         print *, '   0: locales,  1: integrees'
         read *, iloc
         if (irec == 1) then
           write (8,*) iloc
         endif

         if (iloc == 1) then

c----------------------------------------------------------------------
c EMISSIVITES INTEGREES
c----------------------------------------------------------------------

           call EMIINT (iimax, irec)

         else if (iloc == 0) then

           print *, '   Voulez-vous les profondeurs optiques?'
           print *, '   0: non,  1: oui'
           read *, ioptde
           if (irec == 1) then
             write (8,*) ioptde
           endif

c---------------------------------------------------------------------
c choix de l'espece
c---------------------------------------------------------------------

           print *
 2008      print *, 'Quelle espece vous interresse?  (fin: -1)'
           read (*,5) yspec
           if (irec == 1) then
             write (8,5) yspec
           endif
   5       format(a8)

           if (yspec == '-1') then
             goto 1002
           endif

c---------------------------------------------------------------------
c EMISSIVITE Locale de C
c---------------------------------------------------------------------

           if (yspec == 'c' .OR. yspec == 'C') then

             print *, '  1 - 3P J = 0'
             print *, '  2 - 3P J = 1'
             print *, '  3 - 3P J = 2'
             print *, '  4 - 1D J = 2'
             print *, '  5 - 1S J = 0'
             do
               print *, '  Enter upper level (end 0)'
               read *, ju
               if (irec == 1) then
                 write (8,*) ju
               endif
               if (ju < 1 .OR. ju > nlvcat) then
                 exit
               endif
               print *, '  Enter lower level'
               read *, jl
               if (irec == 1) then
                 write (8,*) jl
               endif
               if (jl < 1 .OR. jl > nlvcat) then
                 exit
               endif
               do ii=1,ntrcat
                 if (iupcat(ii) == ju .AND. jlocat(ii) == jl) then
                   exit
                 endif
               end do
               iimax = iimax + 1
               do j=0,npo
                 y(iimax,j) = emicat(ii,j)
               end do
               texty(iimax) = 'EmL_C_'//ii2c(ii)
               if (ioptde == 1) then
                 iimax = iimax + 1
                 do j=0,npo
                   y(iimax,j) = opdcat(ii,j)
                 end do
                 texty(iimax) = 'OpD_C_'//ii2c(ii)
               endif
             end do

c---------------------------------------------------------------------
c EMISSIVITE Locale de N
c---------------------------------------------------------------------

           else if (yspec == 'n' .OR. yspec == 'N') then

             print *, '  1 - 4So J = 3/2'
             print *, '  2 - 2Do J = 5/2'
             print *, '  3 - 2Do J = 3/2'
             print *, '  4 - 2Po J = 1/2'
             print *, '  5 - 2Po J = 3/2'
             do
               print *, '  Enter upper level (end 0)'
               read *, ju
               if (irec == 1) then
                 write (8,*) ju
               endif
               if (ju < 1 .OR. ju > nlvnat) then
                 exit
               endif
               print *, '  Enter lower level'
               read *, jl
               if (irec == 1) then
                 write (8,*) jl
               endif
               if (jl < 1 .OR. jl > nlvnat) then
                 exit
               endif
               do ii=1,ntrnat
                 if (iupnat(ii) == ju .AND. jlonat(ii) == jl) then
                   exit
                 endif
               end do
               iimax = iimax + 1
               do j=0,npo
                 y(iimax,j) = eminat(ii,j)
               end do
               texty(iimax) = 'EmL_N_'//ii2c(ii)
               if (ioptde == 1) then
                 iimax = iimax + 1
                 do j=0,npo
                   y(iimax,j) = opdnat(ii,j)
                 end do
                 texty(iimax) = 'OpD_N_'//ii2c(ii)
               endif
             end do

c---------------------------------------------------------------------
c EMISSIVITE Locale de O
c---------------------------------------------------------------------

           else if (yspec == 'o' .OR. yspec == 'O') then

             print *, '  1 - 3P J = 2'
             print *, '  2 - 3P J = 1'
             print *, '  3 - 3P J = 0'
             print *, '  4 - 1D J = 2'
             print *, '  5 - 1S J = 0'
             do
               print *, '  Enter upper level (end 0)'
               read *, ju
               if (irec == 1) then
                 write (8,*) ju
               endif
               if (ju < 1 .OR. ju > nlvoat) then
                 exit
               endif
               print *, '  Enter lower level'
               read *, jl
               if (irec == 1) then
                 write (8,*) jl
               endif
               if (jl < 1 .OR. jl > nlvoat) then
                 exit
               endif
               do ii=1,ntroat
                 if (iupoat(ii) == ju .AND. jlooat(ii) == jl) then
                   exit
                 endif
               end do
               iimax = iimax + 1
               do j=0,npo
                 y(iimax,j) = emioat(ii,j)
               end do
               texty(iimax) = 'EmL_O_'//ii2c(ii)
               if (ioptde == 1) then
                 iimax = iimax + 1
                 do j=0,npo
                   y(iimax,j) = opdoat(ii,j)
                 end do
                 texty(iimax) = 'OpD_O_'//ii2c(ii)
               endif
             end do

c---------------------------------------------------------------------
c EMISSIVITE Locale de S
c---------------------------------------------------------------------

           else if (yspec == 's' .OR. yspec == 'S') then

             print *, '  1 - 3P J = 2'
             print *, '  2 - 3P J = 1'
             print *, '  3 - 3P J = 0'
             print *, '  4 - 1D J = 2'
             print *, '  5 - 1S J = 0'
             do
               print *, '  Enter upper level (end 0)'
               read *, ju
               if (irec == 1) then
                 write (8,*) ju
               endif
               if (ju < 1 .OR. ju > nlvsat) then
                 exit
               endif
               print *, '  Enter lower level'
               read *, jl
               if (irec == 1) then
                 write (8,*) jl
               endif
               if (jl < 1 .OR. jl > nlvsat) then
                 exit
               endif
               do ii=1,ntrsat
                 if (iupsat(ii) == ju .AND. jlosat(ii) == jl) then
                   exit
                 endif
               end do
               iimax = iimax + 1
               do j=0,npo
                 y(iimax,j) = emisat(ii,j)
               end do
               texty(iimax) = 'EmL_S_'//ii2c(ii)
               if (ioptde == 1) then
                 iimax = iimax + 1
                 do j=0,npo
                   y(iimax,j) = opdsat(ii,j)
                 end do
                 texty(iimax) = 'OpD_S_'//ii2c(ii)
               endif
             end do

c---------------------------------------------------------------------
c EMISSIVITE Locale de Si
c---------------------------------------------------------------------

           else if (yspec == 'si' .OR. yspec == 'Si') then

             print *, '  1 - 3P J = 0'
             print *, '  2 - 3P J = 1'
             print *, '  3 - 3P J = 2'
             print *, '  4 - 1D J = 2'
             print *, '  5 - 1S J = 0'
             do
               print *, '  Enter upper level (end 0)'
               read *, ju
               if (irec == 1) then
                 write (8,*) ju
               endif
               if (ju < 1 .OR. ju > nlvsiat) then
                 exit
               endif
               print *, '  Enter lower level'
               read *, jl
               if (irec == 1) then
                 write (8,*) jl
               endif
               if (jl < 1 .OR. jl > nlvsiat) then
                 exit
               endif
               do ii=1,ntrsiat
                 if (iupsiat(ii) == ju .AND. jlosiat(ii) == jl) then
                   exit
                 endif
               end do
               iimax = iimax + 1
               do j=0,npo
                 y(iimax,j) = emisiat(ii,j)
               end do
               texty(iimax) = 'EmL_Si_'//ii2c(ii)
               if (ioptde == 1) then
                 iimax = iimax + 1
                 do j=0,npo
                   y(iimax,j) = opdsiat(ii,j)
                 end do
                 texty(iimax) = 'OpD_Si_'//ii2c(ii)
               endif
             end do

c---------------------------------------------------------------------
c EMISSIVITE Locale de C+
c---------------------------------------------------------------------

           else if (yspec == 'c+' .OR. yspec == 'C+') then

             print *, '  1 - 2P J = 1/2'
             print *, '  2 - 2P J = 3/2'
             print *, '  3 - 4P J = 1/2'
             print *, '  4 - 4P J = 3/2'
             print *, '  5 - 4P J = 5/2'
             do
               print *, '  Enter upper level (end 0)'
               read *, ju
               if (irec == 1) then
                 write (8,*) ju
               endif
               if (ju < 1 .OR. ju > nlvcpl) then
                 exit
               endif
               print *, '  Enter lower level'
               read *, jl
               if (irec == 1) then
                 write (8,*) jl
               endif
               if (jl < 1 .OR. jl > nlvcpl) then
                 exit
               endif
               do ii=1,ntrcpl
                 if (iupcpl(ii) == ju .AND. jlocpl(ii) == jl) then
                   exit
                 endif
               end do
               iimax = iimax + 1
               do j=0,npo
                 y(iimax,j) = emicpl(ii,j)
               end do
               texty(iimax) = 'EmL_C+_'//ii2c(ii)
               if (ioptde == 1) then
                 iimax = iimax + 1
                 do j=0,npo
                   y(iimax,j) = opdcpl(ii,j)
                 end do
                 texty(iimax) = 'OpD_C+_'//ii2c(ii)
               endif
             end do

c---------------------------------------------------------------------
c EMISSIVITE Locale de N+
c---------------------------------------------------------------------

           else if (yspec == 'n+' .OR. yspec == 'N+') then

             print *, '  1 - 3P J = 0'
             print *, '  2 - 3P J = 1'
             print *, '  3 - 3P J = 2'
             print *, '  4 - 1D J = 2'
             print *, '  5 - 1S J = 0'
             do
               print *, '  Enter upper level (end 0)'
               read *, ju
               if (irec == 1) then
                 write (8,*) ju
               endif
               if (ju < 1 .OR. ju > nlvnpl) then
                 exit
               endif
               print *, '  Enter lower level'
               read *, jl
               if (irec == 1) then
                 write (8,*) jl
               endif
               if (jl < 1 .OR. jl > nlvnpl) then
                 exit
               endif
               do ii=1,ntrnpl
                 if (iupnpl(ii) == ju .AND. jlonpl(ii) == jl) then
                   exit
                 endif
               end do
               iimax = iimax + 1
               do j=0,npo
                 y(iimax,j) = eminpl(ii,j)
               end do
               texty(iimax) = 'EmL_N+_'//ii2c(ii)
               if (ioptde == 1) then
                 iimax = iimax + 1
                 do j=0,npo
                   y(iimax,j) = opdnpl(ii,j)
                 end do
                 texty(iimax) = 'OpD_N+_'//ii2c(ii)
               endif
             end do

c---------------------------------------------------------------------
c EMISSIVITE Locale de O+
c---------------------------------------------------------------------

           else if (yspec == 'o+' .OR. yspec == 'O+') then

             print *, '  1 - 4So J = 3/2'
             print *, '  2 - 2Do J = 5/2'
             print *, '  3 - 2Do J = 3/2'
             print *, '  4 - 2Po J = 3/2'
             print *, '  5 - 2Po J = 1/2'
             do
               print *, '  Enter upper level (end 0)'
               read *, ju
               if (irec == 1) then
                 write (8,*) ju
               endif
               if (ju < 1 .OR. ju > nlvopl) then
                 exit
               endif
               print *, '  Enter lower level'
               read *, jl
               if (irec == 1) then
                 write (8,*) jl
               endif
               if (jl < 1 .OR. jl > nlvopl) then
                 exit
               endif
               do ii=1,ntropl
                 if (iupopl(ii) == ju .AND. jloopl(ii) == jl) then
                   exit
                 endif
               end do
               iimax = iimax + 1
               do j=0,npo
                 y(iimax,j) = emiopl(ii,j)
               end do
               texty(iimax) = 'EmL_O+_'//ii2c(ii)
               if (ioptde == 1) then
                 iimax = iimax + 1
                 do j=0,npo
                   y(iimax,j) = opdopl(ii,j)
                 end do
                 texty(iimax) = 'OpD_O+_'//ii2c(ii)
               endif
             end do

c---------------------------------------------------------------------
c EMISSIVITE Locale de S+
c---------------------------------------------------------------------

           else if (yspec == 's+' .OR. yspec == 'S+') then

             print *, '  1 - 4So J = 3/2'
             print *, '  2 - 2Do J = 3/2'
             print *, '  3 - 2Do J = 5/2'
             print *, '  4 - 2Po J = 1/2'
             print *, '  5 - 2Po J = 3/2'
             do
               print *, '  Enter upper level (end 0)'
               read *, ju
               if (irec == 1) then
                 write (8,*) ju
               endif
               if (ju < 1 .OR. ju > nlvspl) then
                 exit
               endif
               print *, '  Enter lower level'
               read *, jl
               if (irec == 1) then
                 write (8,*) jl
               endif
               if (jl < 1 .OR. jl > nlvspl) then
                 exit
               endif
               do ii=1,ntrspl
                 if (iupspl(ii) == ju .AND. jlospl(ii) == jl) then
                   exit
                 endif
               end do
               iimax = iimax + 1
               do j=0,npo
                 y(iimax,j) = emispl(ii,j)
               end do
               texty(iimax) = 'EmL_S+_'//ii2c(ii)
               if (ioptde == 1) then
                 iimax = iimax + 1
                 do j=0,npo
                   y(iimax,j) = opdSpl(ii,j)
                 end do
                 texty(iimax) = 'OpD_S+_'//ii2c(ii)
               endif
             end do

c---------------------------------------------------------------------
c EMISSIVITE Locale de Si+
c---------------------------------------------------------------------

           else if (yspec == 'si+' .OR. yspec == 'Si+') then

             print *, '  1 - 2P J = 1/2'
             print *, '  2 - 2P J = 3/2'
             print *, '  3 - 4P J = 1/2'
             print *, '  4 - 4P J = 3/2'
             print *, '  5 - 4P J = 5/2'
             do
               print *, '  Enter upper level (end 0)'
               read *, ju
               if (irec == 1) then
                 write (8,*) ju
               endif
               if (ju < 1 .OR. ju > nlvsip) then
                 exit
               endif
               print *, '  Enter lower level'
               read *, jl
               if (irec == 1) then
                 write (8,*) jl
               endif
               if (jl < 1 .OR. jl > nlvsip) then
                 exit
               endif
               do ii=1,ntrsip
                 if (iupsip(ii) == ju .AND. jlosip(ii) == jl) then
                   exit
                 endif
               end do
               iimax = iimax + 1
               do j=0,npo
                 y(iimax,j) = emisip(ii,j)
               end do
               texty(iimax) = 'EmL_Si+_'//ii2c(ii)
               if (ioptde == 1) then
                 iimax = iimax + 1
                 do j=0,npo
                   y(iimax,j) = opdSpl(ii,j)
                 end do
                 texty(iimax) = 'OpD_Si+_'//ii2c(ii)
               endif
             end do

c---------------------------------------------------------------------
c EMISSIVITE Locale de H2
c---------------------------------------------------------------------

           else if (yspec == 'h2' .OR. yspec == 'H2') then

             print *, '  N oubliez pas de noter la correspondance entre'
             print *, '    le numero de la transition et les ref.'
             print *, '    des niveaux de depart et d arrivee!'

             icont = 0

 722         print *,'Vous souhaitez les emissivites a partir'
             print *,'1-de la bande X'
             print *,'2-de la bande B'
             print *,'3-de la bande C'
             print *,'0-retour'
             read *,ii4
             if (irec == 1) then
               write (8,*) ii4
             endif

             if ((ii4 <= 0) .or. (ii4 > 3)) then
               goto 2008

c ----------- Transition a partir de la bande X
             else if (ii4 == 1) then
 2020          print *, '  0: termine, 1: lev, 2: v J, 3: v, 4: total'
               read *, ii2
               if (irec == 1) then
                 write (8,*) ii2
               endif
               if (ii2 == 0) then
                 goto 2008
               else if (ii2 == 1) then
                 print *,'levu  levl: upper -> lower'
                 read *, levu, levl
                 if (irec == 1) then
                   write (8,*) levu, levl
                 endif
                 nju = njlev(levu)
                 nvu = nvlev(levu)
                 njl = njlev(levl)
                 nvl = nvlev(levl)
               else if (ii2 == 2) then
                 print *, 'vu Ju  vl Jl: upper -> lower'
                 read *, nvu, nju, nvl, njl
                 if (irec == 1) then
                   write (8,*) nvu, nju, nvl, njl
                 endif
                 levu = level(nvu,nju)
                 levl = level(nvl,njl)
               else if (ii2 == 3) then
                 print *, '  vu : somme sur vl Jl'
                 read *, nvu
                 if (irec == 1) then
                   write (8,*) nvu
                 endif
               else if (ii2 == 4) then
                 continue
               else
                 print *, '    *** valeur impossible'
                 goto 2020
               endif

               if (ii2 <= 2) then
                 jj = nju - njl
                 if (jj == 0 .or. iabs(jj) == 2) then
                   icont = icont + 1
                   print *, '  Transition numero:', icont
                   iimax = iimax + 1
                   jj = jj / 2
                   do j=0,npo
                     y(iimax,j) = rvfjh2(levu,jj,nvl,j)
                   end do
                   texty(iimax) = 'Emh2L_n='//ii2c(icont)
                 else
                   print *, 'cette transition n exite pas'
                 endif

               else if (ii2 == 3) then
                 iimax = iimax + 1
                 do j=0,npo
                   y(iimax,j) = rvfvh2(nvu,j)
                 end do
                 texty(iimax) = 'Emh2L_v='//ii2c(nvu)
               else
                 iimax = iimax + 1
                 do j=0,npo
                   y(iimax,j) = rvfh2t(j)
                 end do

                 texty(iimax) = 'Emh2L_T=    '

               endif

c ---------- Transitions a partir de la bande B

             else if (ii4 == 2) then !transition a partir de bande B
               print *,'Entrez les vj de la transition sous la forme:'
               print *,'vu ju vl jl'
               read *,nvu, nju, nvl, njl
               if (irec == 1) then
                 write (8,*) nvu, nju, nvl, njl
               endif
               fichier = TRIM(data_dir)//'uvh2b29.dat'
               open (10, file = fichier, status = 'old')
               read (10,*) nraib !nbre de raies dans le fichier
               i = 0
               j = 0
               ndj = nju - njl
                DO WHILE ((i /= 1) .and. (j < nraib))
                  read (10,4112) num, ira1, ivl, ijl, ivu, idj
     1                , pra1, pra2, pra3, pra4
                  j = j+1
                  print *,j,nraib
                  if ((ivl == nvl) .and. (ijl == njl) .and.
     1                 (ivu == nvu) .and. (idj == ndj)) then
                    i = 1
                  endif
                enddo
                if (i == 0) then
                   print *,"Cette raie n'existe pas"
                   close(10)
                   goto 722
                 endif
                 close(10)

                iimax=iimax+1
                aeinbb =  0.66703d16 * pra1 / pra2**2
     1             * ((2.0_dp*njl+1.0_dp) / (2.0_dp*nju+1.0_dp))
                do 634 iopt=0,npo
                  y(iimax,iopt) = (hcsurk * xk)/pra2 * 1.0d-08
     1             * aeinbb * h2bnua(nvu,nju,iopt)
     2             * abnua(i_h2,iopt)
                  print *,y(iimax,iopt),h2bnua(nvu,nju,iopt),
     1              abnua(i_h2,iopt)
 634            continue
                texty(iimax)= 'EH2Bl '//ii2c(nvu)//ii2c(nju)
     1                           //'_'//ii2c(nvl)//ii2c(njl)

c ------------ Transition a partir de la bande C

             else if (ii4 == 3) then !transition a partir de bande C
                print *,'Entrez les vj de la transition sous la forme:'
                print *,'vu ju vl jl'
                read *,nvu, nju, nvl, njl
                if (irec == 1) then
                   write (8,*) nvu, nju, nvl, njl
                endif
                fichier = TRIM(data_dir)//'uvh2c29.dat'
                open (10, file = fichier, status = 'old')
                read (10,*) nraic !nbre de raies dans le fichier
                i = 0
                j = 0
                ndj = nju - njl
                DO WHILE ((i /= 1) .and. (j < nraic))
                  read (10,4112) num, ira1, ivl, ijl, ivu, idj
     1                , pra1, pra2, pra3, pra4
                  j = j+1
                  print *,j,nraic
                  if ((ivl == nvl) .and. (ijl == njl) .and.
     1                 (ivu == nvu) .and. (idj == ndj)) then
                    i = 1
                  endif
                enddo

                if (i == 0) then
                  print *,"Cette raie n'existe pas"
                  close(10)
                  goto 722
                endif
                close(10)

                iimax=iimax+1
                aeincc =  0.66703d16 * pra1 / pra2**2
     1             * ((2.0_dp*njl+1.0_dp) / (2.0_dp*nju+1.0_dp))
                do 638 iopt=0,npo
                  y(iimax,iopt) = (hcsurk * xk)/pra2 * 1.0d-08
     1             * aeincc * h2cnua(nvu,nju,iopt)
     2             * abnua(i_h2,iopt)
 638            continue
                texty(iimax)= 'EH2Cl '//ii2c(nvu)//ii2c(nju)
     1                           //'_'//ii2c(nvl)//ii2c(njl)
             endif

             goto 722

c---------------------------------------------------------------------
c EMISSIVITE Locale de HD
c---------------------------------------------------------------------

           else if (yspec == 'hd' .OR. yspec == 'HD') then

             print *, '  N oubliez pas de noter la correspondance entre'
             print *, '    le numero de la transition et les ref.'
             print *, '    des niveaux de depart et d arrivee!'

             icont = 0

 3020        print *, '  0: termine, 1: lev, 2: v J, 3: total'
             read *, ii2
             if (irec == 1) then
               write (8,*) ii2
             endif

             if (ii2 == 0) then
               goto 2008
             else if (ii2 == 1) then
               print *, '   levu  levl: upper -> lower'
               read *, levu, levl
               if (irec == 1) then
                 write (8,*) levu, levl
               endif
               nju = njhd(levu)
               nvu = nvhd(levu)
               njl = njhd(levl)
               nvl = nvhd(levl)
             else if (ii2 == 2) then
               print *, '  vu Ju  vl Jl: upper -> lower'
               read *, nvu, nju, nvl, njl
               if (irec == 1) then
                 write (8,*) nvu, nju, nvl, njl
               endif
               levu = levhd(nvu,nju)
               levl = levhd(nvl,njl)
             else if (ii2 == 3) then
               continue
             else
               print *, '    *** valeur impossible'
               goto 3020
             endif

             if (ii2 <= 2) then

               jj = nju - njl

               if (jj == 0 .or. iabs(jj) == 1 .or. iabs(jj) == 2)
     1             then

                 icont = icont + 1
                 print *, '  Transition numero:', icont

                 iimax = iimax + 1
                 do 1630 j=0,npo
                   y(iimax,j) = rvfjhd(levu,jj,nvl,j)
 1630            continue
                 texty(iimax) = 'EmhdL_n='//ii2c(icont)
               else
                 print *, 'cette transition n exite pas'
               endif

             else if (ii2 == 3) then

               iimax = iimax + 1
               do 1632 j=0,npo
                 y(iimax,j) = rvfhdt(j)
 1632          continue

               texty(iimax) = 'EmhdL_T=    '

             endif

             goto 3020

c---------------------------------------------------------------------
c emissivite locale de CO
c---------------------------------------------------------------------

           else if (yspec == 'co' .OR. yspec == 'CO') then

 2021        print *, '   Entrer une valeur de J.  (-1: termine)'
             read *, ii2
             if (irec == 1) then
               write (8,*) ii2
             endif

             if (ii2 >= 0) then
               iimax = iimax + 1
               do j=0,npo
                 y(iimax,j) = emico0(ii2+1,j)
                 if (ioptde == 1) then
                   y(iimax+1,j) = opdco0(ii2+1,j)
                 endif
               end do
               texty(iimax) = 'EmcoL_J='//ii2c(ii2)
               if (ioptde == 1) then
                 texty(iimax+1) = 'ODcoL_J='//ii2c(ii2)
                 iimax = iimax + 1
               endif
               goto 2021
             endif

c--------------------------------------------------------------------
c emissivite locale du CO1
c--------------------------------------------------------------------

           else if (yspec == 'c*o' .OR. yspec == 'C*O') then

 2022        print *, '   Entrer une valeur de J.  (-1: termine)'
             read *, ii2
             if (irec == 1) then
               write (8,*) ii2
             endif

             if (ii2 >= 0) then
               iimax = iimax + 1
               do j=0,npo
                 y(iimax,j) = emico1(ii2+1,j)
                 if (ioptde == 1) then
                   y(iimax+1,j) = opdco1(ii2+1,j)
                 endif
               end do
               texty(iimax) = 'Emc*oL_J='//ii2c(ii2)
               if (ioptde == 1) then
                 texty(iimax+1) = 'ODc*oL_J='//ii2c(ii2)
                 iimax = iimax + 1
               endif
               goto 2022
             endif

c----------------------------------------------------------------------
c emissivite locale du CO2
c----------------------------------------------------------------------

           else if (yspec == 'co*' .OR. yspec == 'CO*') then

 2023        print *, '   Entrer une valeur de J.  (-1: termine)'
             read *, ii2
             if (irec == 1) then
               write (8,*) ii2
             endif

             if (ii2 >= 0) then
               iimax = iimax + 1
               do j=0,npo
                 y(iimax,j) = emico2(ii2+1,j)
                 if (ioptde == 1) then
                   y(iimax+1,j) = opdco2(ii2+1,j)
                 endif
               end do
               texty(iimax) = 'Emco*L_J='//ii2c(ii2)
               if (ioptde == 1) then
                 texty(iimax+1) = 'ODco*L_J='//ii2c(ii2)
                 iimax = iimax + 1
               endif
               goto 2023
             endif

c---------------------------------------------------------------------
c emissivite locale du CO3
c---------------------------------------------------------------------

           else if (yspec == 'c*o*' .OR. yspec == 'C*O*') then

 2024        print *, '   Entrer une valeur de J.  (-1: termine)'
             read *, ii2
             if (irec == 1) then
               write (8,*) ii2
             endif

             if (ii2 >= 0) then
               iimax = iimax + 1
               do j=0,npo
                 y(iimax,j) = emico3(ii2+1,j)
                 if (ioptde == 1) then
                   y(iimax+1,j) = opdco3(ii2+1,j)
                 endif
               end do
               texty(iimax) = 'Emc*o*L_J='//ii2c(ii2)
               if (ioptde == 1) then
                 texty(iimax+1) = 'ODc*o*L_J='//ii2c(ii2)
                 iimax = iimax + 1
               endif
               goto 2024
             endif

           else if (yspec == 'cs') then

   21        print *, '   Entrer une valeur de J.  (-1: termine)'
             read *, ii2
             if (irec == 1) then
               write (8,*) ii2
             endif

             if (ii2 >= 0) then
               iimax = iimax + 1
               do  j=0,npo
                 y(iimax,j) = emics0(ii2+1,j)
                 if (ioptde == 1) then
                   y(iimax+1,j) = opdcs0(ii2+1,j)
                 endif
               end do
               texty(iimax) = 'EmcsL_J='//ii2c(ii2)
               if (ioptde == 1) then
                 texty(iimax+1) = 'ODcsL_J='//ii2c(ii2)
                 iimax = iimax + 1
               endif
               goto 21
             endif

c-------------------------------------------------------------------------
c EMISSIVITE locale DE HCO+
c-------------------------------------------------------------------------
           else if ((yspec == 'hco+') .or. (yspec == 'hcop')) then

 210         print *, '   Entrer une valeur de J.  (-1: termine)'
             read *, ii2
             if (irec == 1) then
               write (8,*) ii2
             endif

             if (ii2 >= 0) then
               iimax = iimax + 1
               do  j=0,npo
                 y(iimax,j) = emihcop(ii2+1,j)
                 if (ioptde == 1) then
                   y(iimax+1,j) = opdhcop(ii2+1,j)
                 endif
               end do
               texty(iimax) = 'EmhcopL_J='//ii2c(ii2)
               if (ioptde == 1) then
                 texty(iimax+1) = 'ODhcopL_J='//ii2c(ii2)
                 iimax = iimax + 1
               endif
               goto 210
             endif

c-------------------------------------------------------------------------
c EMISSIVITE locale DE H2O
c-------------------------------------------------------------------------
           else if (yspec == 'h2o') then

 211         print *, '   Enter a transition  (-1: termine)'
             read *, ii2
             if (irec == 1) then
               write (8,*) ii2
             endif

             if (ii2 >= 0) then
               iimax = iimax + 1
               do  j=0,npo
                 y(iimax,j) = emih2o(ii2+1,j)
                 if (ioptde == 1) then
                   y(iimax+1,j) = opdh2o(ii2+1,j)
                 endif
               end do
               texty(iimax) = 'Emh2oL_J='//ii2c(ii2)
               if (ioptde == 1) then
                 texty(iimax+1) = 'ODh2oL_J='//ii2c(ii2)
                 iimax = iimax + 1
               endif
               goto 211
             endif
c-------------------------------------------------------------------------
c EMISSIVITE locale DE H3+
c-------------------------------------------------------------------------
         else if ((yspec == 'h3+') .or. (yspec == 'h3p')) then

 212     PRINT *," n- Ju Ku Jl Kl lam(cm)"
         DO ii = 1, ntrh3p
            levu = iuph3p(ii)
            levl = jloh3p(ii)
            ju  = elevh3p(levu)%j
            ku  = elevh3p(levu)%k
            jl  = elevh3p(levl)%j
            kl  = elevh3p(levl)%k
            xlam = hcsurk / wlkh3p(ii)
            PRINT *,ii,elevh3p(levu)%j,elevh3p(levu)%k,
     2              elevh3p(levl)%j,elevh3p(levl)%K,xlam
         ENDDO
         PRINT *,"0- FIN"
         PRINT *,"-1 - Tout"
         READ  *, itr
         if (irec .eq. 1) then
            write (8,*) itr
         endif

         IF (itr .eq. -1) THEN
            DO itr = 1, ntrh3p
               iimax = iimax + 1
               do  j=0,npo
                   y(iimax,j) = emih3p(itr,j)
                   if (ioptde == 1) then
                      y(iimax+1,j) = opdh3p(levh3p(ju,ku),j)
                   endif
               end do
               lu = iuph3p(itr)
               ll = jloh3p(itr)
               texty(iimax) = 'Emh3pL_lu='//ii2c(lu)//',ll='//ii2c(ll)
               if (ioptde == 1) then
               texty(iimax+1) = 'ODh3pL_lu='//ii2c(lu)//',ll='//ii2c(ll)
               iimax = iimax + 1
               endif
            ENDDO
            goto 2008 ! retour choix espece

         ELSE IF ((itr > 0) .AND. (itr /= ntrh3p)) THEN
            iimax = iimax + 1
            do  j=0,npo
                y(iimax,j) = emih3p(itr,j)
                if (ioptde == 1) then
                   y(iimax+1,j) = opdh3p(levh3p(ju,ku),j)
               endif
            end do
            lu = iuph3p(itr)
            ll = jloh3p(itr)
            texty(iimax) = 'Emh3pL_lu='//ii2c(lu)//',ll='//ii2c(ll)
            if (ioptde == 1) then
               texty(iimax+1) = 'ODh3pL_lu='//ii2c(lu)//',ll='//ii2c(ll)
               iimax = iimax + 1
            endif
            goto 212 ! retour choix transition
         ELSE
            goto 2008 ! retour choix espece
         ENDIF

c-------------------------------------------------------------------
c Espece pour laquelle les populations ne sont pas calculees
c-------------------------------------------------------------------

           else

             print *
             print *, 'Desole, cette selection est impossible!'
             goto 2008

           endif

           goto 2008

         else

           print *, 'Desole, cette selection est impossible!'

         endif

 1002    continue

 4112  format (i8,i3,1x,2i3,1x,2i3,2x,1pd9.3,2x,1pd12.6,2(2x,1pd9.3))

       return
       end
