
c Copyright (C) 2002 - Observatoire de Paris/Meudon
c                      Universite Paris 7
c                      CNRS (France)
c                      Contact : Jacques.Lebourlot@obspm.fr
c
c This program is free software; you can redistribute it and/or
c modify it under the terms of the GNU General Public License version 2
c as published by the Free Software Foundation.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c GNU General Public License for more details.
c
c You should have received a copy of the GNU General Public License
c along with this program; if not, write to the Free Software
c Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.


c      %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
       subroutine EMIINT (iimax, irec)
c      %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

       use constantes
       use prepvar
       use inoutput
       USE H2_DATA
       USE HD_DATA
       USE SP_DATA
       USE STR_DATA
       USE CHEM_DATA
       USE PROFIL
       USE INTEMI

        implicit double precision (a-h,o-z)

        real (KIND=DP), dimension (0:noptm) :: emil
        real (KIND=DP), dimension (0:noptm) :: emii

c  definition des variables locales.
c  (les variables transmises sont dans INCLUDE).

        character (LEN=8)  :: yspec
        character (LEN=17) :: tampon
        character (LEN=50) :: fichout
        character (LEN=2)  :: ii2c
        real (kind=DP), allocatable, dimension(:) :: xi, xj

c--------+---------+---------+---------+---------+---------+---------+-*-------+

       tampon(1:8) = '        '
       if (.NOT. ALLOCATED(xi)) then
         ALLOCATE (xi(0:npo))
         ALLOCATE (xj(0:npo))
       endif

       print *
       print *, 'Entrez le nom du fichier de raies :'
       read (*,5) fichout
       fichout = TRIM(ADJUSTL(fichout))
       if (irec == 1) then
         write (8,5) fichout
       endif

       fichier = TRIM(out_dir)//fichout
       print *,"Le fichier de raies sera ecrit dans:"
       print *, fichier
       open (35, file = fichier, status = 'new')

       print *
       print *, 'Entrer l angle de visee'
       read *, xmu
       if (irec == 1) then
         write (8,*) xmu
       endif
       xmu = cos(xmu)
       write (35,'("# mu:",1pe14.6)') xmu

       print *
 2108  print *, 'Quelle espece vous interresse?  (fin: -1)'
       read (*,6) yspec
       yspec = TRIM(ADJUSTL(yspec))
       do i=1,nspec
         if (yspec /= TRIM(ADJUSTL(speci(i)))) then
           cycle
         else
           exit
         endif
       end do
       if (i >= nspec .AND. yspec /= '-1') then
         print *, "  WARNING:", yspec, " is not in chemistry!"
         goto 2108
       endif
       if (irec == 1) then
         write (8,6) yspec
       endif
   5   format(a50)
   6   format(a8)

       if (yspec == '-1') then
         print *, "  Fin des raies"
         goto 1002
       endif
       ii = 999

c--------------------------------------------------------------------
c EMISSIVITE INTEGREE DE C
c--------------------------------------------------------------------

c  ATTENTION : le numero de la transition doit etre en accord
c              avec le module STR_DATA

       if (yspec == 'c' .OR. yspec == 'C') then

         do while (ii /= 0)
           print *, '   Transition?  (0: fin)'
           print *, '       1: 2-1 -> 609.75 micron'
           print *, '       2: 3-2 -> 370.37 micron'
           print *, '       3: 3-1 -> 230.41 micron'
           print *, '       4: 4-3 -> 9850.26 Angstrom'
           print *, '       5: 4-2 -> 9824.13 Angstrom'
           print *, '       6: 4-1 -> 9808.32 Angstrom'
           print *, '       7: 5-4 -> 8727.13 Angstrom'
           print *, '       8: 5-3 -> 4627.346 Angstrom'
           print *, '       9: 5-2 -> 4621.570 Angstrom'
           read *, ii
           if (ii < 1 .AND. ii > 9) then
             ii = 0
           end if
           if (irec == 1) then
             write (8,*) ii
           endif

           if (ii /= 0) then
             iupl = iupcat(ii)
             jlol = jlocat(ii)
             gi = gstcat(iupl)
             gj = gstcat(jlol)
             xi = abnua(i_c,0:npo) * xrecat(iupl,0:npo)
             xj = abnua(i_c,0:npo) * xrecat(jlol,0:npo)
             tampon = 'Emis C '//ii2c(iupl)//'->'//ii2c(jlol)
             call LDVInt (xmu, amcat, aijcat(ii), gi, gj
     1                    , wlkcat(ii), xi, xj, tampon)
           endif

         end do

c--------------------------------------------------------------------
c EMISSIVITE INTEGREE DE N
c--------------------------------------------------------------------

c  ATTENTION : le numero de la transition doit etre en accord
c              avec le module STR_DATA

       else if (yspec == 'n' .OR. yspec == 'N') then

         do while (ii /= 0)
           print *, '   Transition?  (0: fin)'
           print *, '       1: 3-2 -> 1.147 mm (261.21 GHz)'
           print *, '       2: 4-3 -> 1.04104 micron'
           print *, '       3: 5-3 -> 1.04100 micron'
           print *, '       4: 4-2 -> 1.04010 micron'
           print *, '       5: 5-2 -> 1.04006 micron'
           print *, '       6: 2-1 -> 5200.257 Angstrom'
           print *, '       7: 3-1 -> 5197.902 Angstrom'
           print *, '       8: 4-1 -> 3466.543 Angstrom'
           print *, '       9: 5-1 -> 3466.497 Angstrom'
           read *, ii
           if (ii < 1 .AND. ii > 9) then
             ii = 0
           end if
           if (irec == 1) then
             write (8,*) ii
           endif

           if (ii /= 0) then
             iupl = iupnat(ii)
             jlol = jlonat(ii)
             gi = gstnat(iupl)
             gj = gstnat(jlol)
             xi = abnua(i_n,0:npo) * xrenat(iupl,0:npo)
             xj = abnua(i_n,0:npo) * xrenat(jlol,0:npo)
             tampon = 'Emis N '//ii2c(iupl)//'->'//ii2c(jlol)
             call LDVInt (xmu, amnat, aijnat(ii), gi, gj
     1                    , wlknat(ii), xi, xj, tampon)
           endif

         end do

c--------------------------------------------------------------------
c EMISSIVITE INTEGREE DE O
c--------------------------------------------------------------------

c  ATTENTION : le numero de la transition doit etre en accord
c              avec le module STR_DATA

       else if (yspec == 'o' .OR. yspec == 'O') then

         do while (ii /= 0)
           print *, '   Transition?  (0: fin)'
           print *, '       1: 3-2 -> 145.53 micron'
           print *, '       2: 2-1 -> 63.19  micron'
           print *, '       3: 3-1 -> 44.06  micron'
           print *, '       4: 4-3 -> 6391.73 Angstrom'
           print *, '       5: 4-2 -> 6363.78 Angstrom'
           print *, '       6: 4-1 -> 6300.30 Angstrom'
           print *, '       7: 5-4 -> 5577.34 Angstrom'
           print *, '       8: 5-2 -> 2972.29 Angstrom'
           print *, '       9: 5-1 -> 2958.37 Angstrom'
           read *, ii
           if (ii < 1 .AND. ii > 9) then
             ii = 0
           end if
           if (irec == 1) then
             write (8,*) ii
           endif

           if (ii /= 0) then
             iupl = iupoat(ii)
             jlol = jlooat(ii)
             gi = gstoat(iupl)
             gj = gstoat(jlol)
             xi = abnua(i_o,0:npo) * xreoat(iupl,0:npo)
             xj = abnua(i_o,0:npo) * xreoat(jlol,0:npo)
             tampon = 'Emis O '//ii2c(iupl)//'->'//ii2c(jlol)
             call LDVInt (xmu, amoat, aijoat(ii), gi, gj
     1                    , wlkoat(ii), xi, xj, tampon)
           endif

         end do

c--------------------------------------------------------------------
c EMISSIVITE INTEGREE DE S
c--------------------------------------------------------------------

c  ATTENTION : le numero de la transition doit etre en accord
c              avec le module STR_DATA

       else if (yspec == 's' .OR. yspec == 'S') then

         do while (ii /= 0)
           print *, '   Transition?  (0: fin)'
           print *, '       1: 3-2 -> 56.31 micron'
           print *, '       2: 2-1 -> 25.25 micron'
           print *, '       3: 3-1 -> 17.43 micron'
           print *, '       4: 4-3 -> 1.15407 micron'
           print *, '       5: 4-2 -> 1.13089 micron'
           print *, '       6: 4-1 -> 1.08241 micron'
           print *, '       7: 5-4 -> 7725.05 Angstrom'
           print *, '       8: 5-2 -> 4589.26 Angstrom'
           print *, '       9: 5-1 -> 4507.31 Angstrom'
           read *, ii
           if (ii < 1 .AND. ii > 9) then
             ii = 0
           end if
           if (irec == 1) then
             write (8,*) ii
           endif

           if (ii /= 0) then
             iupl = iupsat(ii)
             jlol = jlosat(ii)
             gi = gstsat(iupl)
             gj = gstsat(jlol)
             xi = abnua(i_s,0:npo) * xresat(iupl,0:npo)
             xj = abnua(i_s,0:npo) * xresat(jlol,0:npo)
             tampon = 'Emis S '//ii2c(iupl)//'->'//ii2c(jlol)
             call LDVInt (xmu, amsat, aijsat(ii), gi, gj
     1                    , wlksat(ii), xi, xj, tampon)
           endif

         end do

c--------------------------------------------------------------------
c EMISSIVITE INTEGREE DE Si
c--------------------------------------------------------------------

c  ATTENTION : le numero de la transition doit etre en accord
c              avec le module STR_DATA

       else if (yspec == 'si' .OR. yspec == 'Si') then

         do while (ii /= 0)
           print *, '   Transition?  (0: fin)'
           print *, '       1: 2-1 -> 129.682 micron'
           print *, '       2: 3-2 -> 68.472 micron'
           print *, '       3: 3-1 -> 44.812 micron'
           print *, '       4: 4-3 -> 1.6459 micron'
           print *, '       5: 4-2 -> 1.6073 micron'
           print *, '       6: 4-1 -> 1.5876 micron'
           print *, '       7: 5-4 -> 1.0994 micron'
           print *, '       8: 5-3 -> 6589.61 Angstrom'
           print *, '       9: 5-2 -> 6526.78 Angstrom'
           read *, ii
           if (ii < 1 .AND. ii > 9) then
             ii = 0
           end if
           if (irec == 1) then
             write (8,*) ii
           endif

           if (ii /= 0) then
             iupl = iupsiat(ii)
             jlol = jlosiat(ii)
             gi = gstsiat(iupl)
             gj = gstsiat(jlol)
             xi = abnua(i_si,0:npo) * xresiat(iupl,0:npo)
             xj = abnua(i_si,0:npo) * xresiat(jlol,0:npo)
             tampon = 'Emis Si '//ii2c(iupl)//'->'//ii2c(jlol)
             call LDVInt (xmu, amsiat, aijsiat(ii), gi, gj
     1                    , wlksiat(ii), xi, xj, tampon)
           endif

         end do

c--------------------------------------------------------------------
c EMISSIVITE INTEGREE DE C+
c----------------------------------------------------------------------

       else if (yspec == 'c+' .OR. yspec == 'C+') then

         do while (ii /= 0)
           print *, '   Transition?  (0: fin)'
           print *, '       1: 2-1 -> 157.68 micron'
           print *, '       2: 3-2 -> 2328.12 Angstrom'
           print *, '       3: 4-2 -> 2326.93 Angstrom'
           print *, '       4: 5-2 -> 2325.40 Angstrom'
           print *, '       5: 3-1 -> 2324.69 Angstrom'
           print *, '       6: 4-1 -> 2323.50 Angstrom'
           read *, ii
           if (ii < 1 .AND. ii > 6) then
             ii = 0
           end if
           if (irec == 1) then
             write (8,*) ii
           endif

           if (ii /= 0) then
             iupl = iupcpl(ii)
             jlol = jlocpl(ii)
             gi = gstcpl(iupl)
             gj = gstcpl(jlol)
             xi = abnua(i_cp,0:npo) * xrecpl(iupl,0:npo)
             xj = abnua(i_cp,0:npo) * xrecpl(jlol,0:npo)
             tampon = 'Emis C+ '//ii2c(iupl)//'->'//ii2c(jlol)
             call LDVInt (xmu, amcpl, aijcpl(ii), gi, gj
     1                    , wlkcpl(ii), xi, xj, tampon)
           endif

         end do

c--------------------------------------------------------------------
c EMISSIVITE INTEGREE DE N+
c----------------------------------------------------------------------

       else if (yspec == 'n+' .OR. yspec == 'N+') then

         do while (ii /= 0)
           print *, '   Transition?  (0: fin)'
           print *, '       1: 2-1 -> 205.34 micron'
           print *, '       2: 3-2 -> 121.80 micron'
           print *, '       3: 3-1 -> 76.45 micron'
           print *, '       4: 4-3 -> 6583.45 Angstrom'
           print *, '       5: 4-2 -> 6548.05 Angstrom'
           print *, '       6: 4-1 -> 6527.23 Angstrom'
           print *, '       7: 5-4 -> 5754.59 Angstrom'
           print *, '       8: 5-3 -> 3070.55 Angstrom'
           print *, '       9: 5-2 -> 3062.83 Angstrom'
           read *, ii
           if (ii < 1 .AND. ii > 9) then
             ii = 0
           end if
           if (irec == 1) then
             write (8,*) ii
           endif

           if (ii /= 0) then
             iupl = iupnpl(ii)
             jlol = jlonpl(ii)
             gi = gstnpl(iupl)
             gj = gstnpl(jlol)
             xi = abnua(i_np,0:npo) * xrenpl(iupl,0:npo)
             xj = abnua(i_np,0:npo) * xrenpl(jlol,0:npo)
             tampon = 'Emis N+ '//ii2c(iupl)//'->'//ii2c(jlol)
             call LDVInt (xmu, amnpl, aijnpl(ii), gi, gj
     1                    , wlknpl(ii), xi, xj, tampon)
           endif

         end do

c--------------------------------------------------------------------
c EMISSIVITE INTEGREE DE O+
c----------------------------------------------------------------------

       else if (yspec == 'o+' .OR. yspec == 'O+') then

         do while (ii /= 0)
           print *, '   Transition?  (0: fin)'
           print *, '       1: 5-4 -> 5.03 mm (59.66 GHz)'
           print *, '       2: 3-2 -> 0.4995 mm (600.18 GHz)'
           print *, '       3: 4-3 -> 7330.73 Angstrom'
           print *, '       4: 5-3 -> 7329.67 Angstrom'
           print *, '       5: 4-2 -> 7319.99 Angstrom'
           print *, '       6: 5-2 -> 7318.92 Angstrom'
           print *, '       7: 2-1 -> 3728.815 Angstrom'
           print *, '       8: 3-1 -> 3726.032 Angstrom'
           print *, '       9: 4-1 -> 2470.341 Angstrom'
           print *, '      10: 5-1 -> 2470.219 Angstrom'
           read *, ii
           if (ii < 1 .AND. ii > 10) then
             ii = 0
           end if
           if (irec == 1) then
             write (8,*) ii
           endif

           if (ii /= 0) then
             iupl = iupopl(ii)
             jlol = jloopl(ii)
             gi = gstopl(iupl)
             gj = gstopl(jlol)
             xi = abnua(i_op,0:npo) * xreopl(iupl,0:npo)
             xj = abnua(i_op,0:npo) * xreopl(jlol,0:npo)
             tampon = 'Emis O+ '//ii2c(iupl)//'->'//ii2c(jlol)
             call LDVInt (xmu, amopl, aijopl(ii), gi, gj
     1                    , wlkopl(ii), xi, xj, tampon)
           endif

         end do

c----------------------------------------------------------------------
c EMISSIVITE INTEGREE DE S+
c----------------------------------------------------------------------

       else if (yspec == 's+' .OR. yspec == 'S+') then

         do while (ii /= 0)
           print *, '   Transition?  (0: fin)'
           print *, '       1: 3-2 -> 0.31456 mm (953.04 GHz)'
           print *, '       2: 5-4 -> 0.21409 mm (1400.33 GHz)'
           print *, '       3: 4-3 -> 1.0373 micron'
           print *, '       4: 4-2 -> 1.0339 micron'
           print *, '       5: 5-3 -> 1.0323 micron'
           print *, '       6: 5-2 -> 1.0290 micron'
           print *, '       7: 2-1 -> 6730.82 Angstrom'
           print *, '       8: 3-1 -> 6716.44 Angstrom'
           print *, '       9: 4-1 -> 4076.35 Angstrom'
           print *, '      10: 5-1 -> 4068.60 Angstrom'
           read *, ii
           if (ii < 1 .AND. ii > 10) then
             ii = 0
           end if
           if (irec == 1) then
             write (8,*) ii
           endif

           if (ii /= 0) then
             iupl = iupspl(ii)
             jlol = jlospl(ii)
             gi = gstspl(iupl)
             gj = gstspl(jlol)
             xi = abnua(i_sp,0:npo) * xrespl(iupl,0:npo)
             xj = abnua(i_sp,0:npo) * xrespl(jlol,0:npo)
             tampon = 'Emis S+ '//ii2c(iupl)//'->'//ii2c(jlol)
             call LDVInt (xmu, amspl, aijspl(ii), gi, gj
     1                    , wlkspl(ii), xi, xj, tampon)
           endif

         end do

c----------------------------------------------------------------------
c EMISSIVITE INTEGREE DE Si+
c----------------------------------------------------------------------

       else if (yspec == 'si+' .OR. yspec == 'Si+') then

         do while (ii /= 0)
           print *, '   Transition?  (0: fin)'
           print *, '       1: 2-1 -> 34.814 micron'
           print *, '       2: 3-2 -> 2350.17 Angstrom'
           print *, '       3: 4-2 -> 2344.20 Angstrom'
           print *, '       4: 5-2 -> 2334.60 Angstrom'
           print *, '       5: 3-1 -> 2334.40 Angstrom'
           print *, '       6: 4-1 -> 2328.52 Angstrom'
           read *, ii
           if (ii < 1 .AND. ii > 6) then
             ii = 0
           end if
           if (irec == 1) then
             write (8,*) ii
           endif

           if (ii /= 0) then
             iupl = iupsip(ii)
             jlol = jlosip(ii)
             gi = gstsip(iupl)
             gj = gstsip(jlol)
             xi = abnua(i_sip,0:npo) * xresip(iupl,0:npo)
             xj = abnua(i_sip,0:npo) * xresip(jlol,0:npo)
             tampon = 'Emis Si+ '//ii2c(iupl)//'->'//ii2c(jlol)
             call LDVInt (xmu, amsip, aijsip(ii), gi, gj
     1                    , wlksip(ii), xi, xj, tampon)
           endif

         end do

c----------------------------------------------------------------------
c EMISSIVITE INTEGREE DE H2
c----------------------------------------------------------------------

       else if (yspec == 'h2' .OR. yspec == 'H2') then
 723     print *,'Vous souhaitez les emissivites integrees',
     1       ' a partir'
         print *,'1-de la bande X'
         print *,'2-de la bande B (old style)'
         print *,'3-de la bande C (old style)'
         print *,'0-retour'
         read *,ii4
         if (irec == 1) then
           write (8,*) ii4
         endif

         if (ii4 == 0) then
           goto 2108

         else if (ii4 == 1) then
           print *, 'N oubliez pas de noter la correspondance
     1                  entre'
           print *, 'le numero de la transition et les ref.'
           print *, 'des niveaux de depart et d arrivee!'

           print *, '  1: lev, 2: v J'
           print *, '  0: termine'
           read *, ii2
           if (irec == 1) then
            write (8,*) ii2
           endif

           if (ii2 == 0) then
             goto 2108
           else if (ii2 == 1) then
             print *, '   levu  levl: upper -> lower'
             read *, levu, levl
             if (irec == 1) then
               write (8,*) levu, levl
             endif
             nju = njlev(levu)
             nvu = nvlev(levu)
             njl = njlev(levl)
             nvl = nvlev(levl)
           else if (ii2 == 2) then
             print *, '  vu Ju  vl Jl: upper -> lower'
             read *, nvu, nju, nvl, njl
             if (irec == 1) then
               write (8,*) nvu, nju, nvl, njl
             endif
             levu = level(nvu,nju)
             levl = level(nvl,njl)
           else
             print *, 'Vous avez du faire une erreur'
             goto 723
           endif

           jj = nju - njl
           if (jj == 0 .or. iabs(jj) == 2) then
             gi = 2.0_dp * nju + 1.0_dp
             gj = 2.0_dp * njl + 1.0_dp
             xi = abnua(i_h2,0:npo) * xreh2(levu,0:npo)
             xj = abnua(i_h2,0:npo) * xreh2(levl,0:npo)
             tampon = 'Emis H2 '//ii2c(levu)//'->'//ii2c(levl)
             wlkl = (elhm(levu) - elhm(levl))
             call LDVInt (xmu, amh2, -evlqua(levl,levu), gi, gj
     1                    , wlkl, xi, xj, tampon)
            else
              print *, 'cette transition n existe pas'
            endif

c ----------------------------------------------------------------
c calcul des emissivites integrees des transitions Lyman et Werner
c ----------------------------------------------------------------
c Transitions Lyman

c --- Lecture des parametres de la raie
            else if (ii4 == 2) then
               print *,'entrez les vj de la transition sous',
     1                 ' la forme'
               print *,'nvu, nju, nvl, njl'
               read *,nvu, nju, nvl, njl
               if (irec == 1) then
                 write(8,*) nvu, nju, nvl, njl
               endif
               fichier = TRIM(data_dir)//'uvh2b29.dat'
               open(10, file=fichier, status='old')
               read(10,*) nraib
               ndj=nju-njl
               i = 0; j = 0
               DO WHILE ((i /= 1) .and. (j < nraib))
                 read (10,4112) num, ira1, ivl, ijl, ivu, idj
     1                , pra1, pra2, pra3, pra4
                 j = j+1
c                 print *,j,nraib
                 if ((ivl == nvl) .and. (ijl == njl) .and.
     1               (ivu == nvu) .and. (idj == ndj)) then
                    i = 1
                 endif
               enddo
                if (i == 0) then
                  print *,"Cette raie n'existe pas"
                  close(10)
                  goto 723
                endif
                close(10)

c --- calcul de l'absorption a cette longueur d'onde
               iimax=iimax+1
               wlth=pra2 !lg onde en Angstroms
               xlong=1.0d4 / wlth !inverse de lg onde en micrometres-1
               if (xlong >= 5.9) then
                couex2= cc1 + cc2 * xlong + cc3 * (xlong *
     1           xlong / ((xlong * xlong - y0 * y0)**2 + xgam *
     2           xgam * xlong * xlong)) + cc4 * (0.539 * (xlong-5.9)**2
     3           + 0.0564 * (xlong-5.9)**3)
                extpou = 1 + couex2/rrr
               else
                 couex1= cc1 + cc2 * xlong + cc3 * (xlong
     1            * xlong / ((xlong * xlong - y0 * y0)**2 + xgam
     2            * xgam * xlong * xlong))
                 extpou = 1 + couex1/rrr
               endif

c --- calcul de l'emissivite locale
               aeinbb= 0.66703d16 * pra1 / pra2**2
     1           * ((2.0_dp*njl+1.0_dp) / (2.0_dp*nju+1.0_dp))
               do 485 iopt=0, npo
                 emil(iopt)=(hcsurk*xk) /pra2 * 1.0d-08
     1             * aeinbb * h2bnua(nvu,nju,iopt)
     2             * abnua(i_h2,iopt)
 485           continue

c --- calcul de l'emissivite integree
               cdcte = tautav * cdunit / (4.0_dp * xpi * rrr)
c               cdcte = tautav * cdunit / (2.0_dp * xpi * rrr)
               emii(0)=0.0d0
               do 486 iopt = 1,npo
                 x1 = tau(iopt) * extpou
                 emii(iopt) = emii(iopt-1)
     1                + cdcte
     2                * (tau(iopt)-tau(iopt-1)) * 0.5_dp
     3                * (emil(iopt) / densh(iopt)
     4                + emil(iopt-1) / densh(iopt-1))
     5                * exp(-x1)
 486           continue

c --- ecriture dans fichier de sortie
               do  iopt=0, npo
                 y(iimax,iopt) = emii(iopt)
               enddo
               texty(iimax)= 'EH2BI'//ii2c(nvu)//ii2c(nju)
     1                         //'_'//ii2c(nvl)//ii2c(njl)

c Transitions Werner

c --- Lecture des parametres de la raie
            else if (ii4 == 3) then
               print *,'entrez les vj de la transition sous
     1                        la forme'
               print *,'nvu, nju, nvl, njl'
               read *,nvu, nju, nvl, njl
               if (irec == 1) then
                 write(8,*) nvu, nju, nvl, njl
               endif
               fichier = TRIM(data_dir//'uvh2c29.dat')
               open(10, file=fichier, status='old')
               read(10,*) nraic
               ndj=nju-njl
               i = 0; j = 0
               DO WHILE ((i /= 1) .and. (j < nraic))
                 read (10,4112) num, ira1, ivl, ijl, ivu, idj
     1                , pra1, pra2, pra3, pra4
                 j = j+1
c                 print *,j,nraic
                 if ((ivl == nvl) .and. (ijl == njl) .and.
     1               (ivu == nvu) .and. (idj == ndj)) then
                    i = 1
                 endif
               enddo
                if (i == 0) then
                  print *,"Cette raie n'existe pas"
                  close(10)
                  goto 723
                endif
                close(10)

c --- incrementation
               iimax=iimax+1

c --- calcul de l'absorption a cette longueur d'onde
               wlth=pra2 !lg onde en Angstroms
               xlong=1.0d4 / wlth !inverse de lg onde en micrometres-1
               if (xlong >= 5.9) then
                couex2= cc1 + cc2 * xlong + cc3 * (xlong *
     1           xlong / ((xlong * xlong - y0 * y0)**2 + xgam *
     2           xgam * xlong * xlong)) + cc4 * (0.539 * (xlong-5.9)**2
     3           + 0.0564 * (xlong-5.9)**3)
                extpou = 1 + couex2/rrr
               else
                 couex1= cc1 + cc2 * xlong + cc3 * (xlong
     1            * xlong / ((xlong * xlong - y0 * y0)**2 + xgam
     2            * xgam * xlong * xlong))
                 extpou = 1 + couex1/rrr
               endif

c --- calcul de l'emissivite locale
               aeincc= 0.66703d16 * pra1 / pra2**2
     1           * ((2.0_dp*njl+1.0_dp) / (2.0_dp*nju+1.0_dp))
               do 490 iopt=0, npo
                 emil(iopt)=(hcsurk*xk) /pra2 * 1.0d-08
     1             * aeincc * h2cnua(nvu,nju,iopt)
     2             * abnua(i_h2,iopt)
 490           continue

c --- calcul de l'emissivite integree
               cdcte = tautav * cdunit / (4.0_dp * xpi * rrr)
c               cdcte = tautav * cdunit / (2.0_dp * xpi * rrr)
               emii(0)=0.0d0
               do 491 iopt=1,npo
                 x1 = tau(iopt) * extpou
                 emii(iopt) = emii(iopt-1)
     1                + cdcte
     2                * (tau(iopt)-tau(iopt-1)) * 0.5_dp
     3                * (emil(iopt) / densh(iopt)
     4                + emil(iopt+1) / densh(iopt+1))
     5                * exp(-x1)
 491           continue

c --- ecriture dans fichier de sortie
               do 492 iopt=0, npo
                 y(iimax,iopt) = emii(iopt)
 492           continue
                texty(iimax)= 'EH2CI'//ii2c(nvu)//ii2c(nju)
     1                          //'_'//ii2c(nvl)//ii2c(njl)
            endif
               goto 723

c----------------------------------------------------------------------
c EMISSIVITE INTEGREE DE HD
c----------------------------------------------------------------------

         else if (yspec == 'hd' .OR. yspec == 'HD') then

           print *, '  N oubliez pas de noter la correspondance entre'
           print *, '    le numero de la transition et les ref.'
           print *, '    des niveaux de depart et d arrivee!'

 3120      print *, '  1: lev, 2: v J'
           print *, '  0: termine'
           read *, ii2
           if (irec == 1) then
             write (8,*) ii2
           endif

           if (ii2 == 0) then
             goto 2108
           else if (ii2 == 1) then
             print *, '   levu  levl: upper -> lower'
             read *, levu, levl
             if (irec == 1) then
               write (8,*) levu, levl
             endif
             nju = njhd(levu)
             nvu = nvhd(levu)
             njl = njhd(levl)
             nvl = nvhd(levl)
           else if (ii2 == 2) then
             print *, '  vu Ju  vl Jl: upper -> lower'
             read *, nvu, nju, nvl, njl
             if (irec == 1) then
               write (8,*) nvu, nju, nvl, njl
             endif
             levu = levhd(nvu,nju)
             levl = levhd(nvl,njl)
           else
             print *, '    *** valeur impossible'
             goto 3120
           endif

           jj = nju - njl
           if (jj == 0 .or. iabs(jj) == 1 .or. iabs(jj) == 2)
     1         then

             gi = 2.0_dp * nju + 1.0_dp
             gj = 2.0_dp * njl + 1.0_dp
             xi = abnua(i_hd,0:npo) * xrehd(levu,0:npo)
             xj = abnua(i_hd,0:npo) * xrehd(levl,0:npo)
             tampon = 'Emis HD '//ii2c(lvu)//'->'//ii2c(levl)
             wlkl = (elhd(levu) - elhd(levl))
             call LDVInt (xmu, amhd, -evdihd(levl,levu), gi, gj
     1                    , wlkl, xi, xj, tampon)

           else
             print *, 'cette transition n existe pas'
           endif

             goto 3120

c----------------------------------------------------------------------
c EMISSIVITE INTEGREE DE CO
c----------------------------------------------------------------------

       else if (yspec == 'co' .OR. yspec == 'CO') then

         do while (ii /= 0)
           print *, '   Transition (Jup)?  (0: fin)'
           read *, ii
           if (ii > ntrco0) then
             ii = 0
           end if
           if (irec == 1) then
             write (8,*) ii
           endif

           if (ii /= 0) then
             iupl = iupco0(ii)
             jlol = jloco0(ii)
             gi = gstco0(iupl)
             gj = gstco0(jlol)
             xi = abnua(i_co0,0:npo) * xreco0(iupl,0:npo)
             xj = abnua(i_co0,0:npo) * xreco0(jlol,0:npo)
             tampon = 'Emis CO '//ii2c(iupl)//'->'//ii2c(jlol)
             call LDVInt (xmu, amco0, aijco0(ii), gi, gj
     1                    , wlkco0(ii), xi, xj, tampon)
           endif

         end do

c----------------------------------------------------------------------
c EMISSIVITE INTEGREE DE C13O
c----------------------------------------------------------------------

       else if (yspec == 'c*o' .OR. yspec == 'C*O') then

         do while (ii /= 0)
           print *, '   Transition (Jup)?  (0: fin)'
           read *, ii
           if (ii > ntrco0) then
             ii = 0
           end if
           if (irec == 1) then
             write (8,*) ii
           endif

           if (ii /= 0) then
             iupl = iupco1(ii)
             jlol = jloco1(ii)
             gi = gstco1(iupl)
             gj = gstco1(jlol)
             xi = abnua(i_co1,0:npo) * xreco1(iupl,0:npo)
             xj = abnua(i_co1,0:npo) * xreco1(jlol,0:npo)
             tampon = 'Emis C*O '//ii2c(iupl)//'->'//ii2c(jlol)
             call LDVInt (xmu, amco1, aijco1(ii), gi, gj
     1                    , wlkco1(ii), xi, xj, tampon)
           endif

         end do

c----------------------------------------------------------------------
c EMISSIVITE INTEGREE DE CO18
c----------------------------------------------------------------------

       else if (yspec == 'co*' .OR. yspec == 'CO*') then

         do while (ii /= 0)
           print *, '   Transition (Jup)?  (0: fin)'
           read *, ii
           if (ii > ntrco0) then
             ii = 0
           end if
           if (irec == 1) then
             write (8,*) ii
           endif

           if (ii /= 0) then
             iupl = iupco2(ii)
             jlol = jloco2(ii)
             gi = gstco2(iupl)
             gj = gstco2(jlol)
             xi = abnua(i_co2,0:npo) * xreco2(iupl,0:npo)
             xj = abnua(i_co2,0:npo) * xreco2(jlol,0:npo)
             tampon = 'Emis CO* '//ii2c(iupl)//'->'//ii2c(jlol)
             call LDVInt (xmu, amco2, aijco2(ii), gi, gj
     1                    , wlkco2(ii), xi, xj, tampon)
           endif

         end do

c----------------------------------------------------------------------
c EMISSIVITE INTEGREE DE C13O18
c----------------------------------------------------------------------

       else if (yspec == 'c*o*' .OR. yspec == 'C*O*') then

         do while (ii /= 0)
           print *, '   Transition (Jup)?  (0: fin)'
           read *, ii
           if (ii > ntrco0) then
             ii = 0
           end if
           if (irec == 1) then
             write (8,*) ii
           endif

           if (ii /= 0) then
             iupl = iupco3(ii)
             jlol = jloco3(ii)
             gi = gstco3(iupl)
             gj = gstco3(jlol)
             xi = abnua(i_co3,0:npo) * xreco3(iupl,0:npo)
             xj = abnua(i_co3,0:npo) * xreco3(jlol,0:npo)
             tampon = 'Emis C*O* '//ii2c(iupl)//'->'//ii2c(jlol)
             call LDVInt (xmu, amco3, aijco3(ii), gi, gj
     1                    , wlkco3(ii), xi, xj, tampon)
           endif

         end do

c----------------------------------------------------------------------
c EMISSIVITE INTEGREE DE CS
c----------------------------------------------------------------------

       else if (yspec == 'cs' .OR. yspec == 'CS') then

         do while (ii /= 0)
           print *, '   Transition (Jup)?  (0: fin)'
           read *, ii
           if (ii > ntrcs0) then
             ii = 0
           end if
           if (irec == 1) then
             write (8,*) ii
           endif

           if (ii /= 0) then
             iupl = iupcs0(ii)
             jlol = jlocs0(ii)
             gi = gstcs0(iupl)
             gj = gstcs0(jlol)
             xi = abnua(i_cs,0:npo) * xrecs0(iupl,0:npo)
             xj = abnua(i_cs,0:npo) * xrecs0(jlol,0:npo)
             tampon = 'Emis CS '//ii2c(iupl)//'->'//ii2c(jlol)
             call LDVInt (xmu, amcs0, aijcs0(ii), gi, gj
     1                    , wlkcs0(ii), xi, xj, tampon)
           endif

         end do

c----------------------------------------------------------------------
c EMISSIVITE INTEGREE DE HCOP
c----------------------------------------------------------------------

       else if (yspec == 'hco+' .OR. yspec == 'HCO+') then

         do while (ii /= 0)
           print *, '   Transition (Jup)?  (0: fin)'
           read *, ii
           if (ii > ntrhcop) then
             ii = 0
           end if
           if (irec == 1) then
             write (8,*) ii
           endif

           if (ii /= 0) then
             iupl = iuphcop(ii)
             jlol = jlohcop(ii)
             gi = gsthcop(iupl)
             gj = gsthcop(jlol)
             xi = abnua(i_hcop,0:npo) * xrehcop(iupl,0:npo)
             xj = abnua(i_hcop,0:npo) * xrehcop(jlol,0:npo)
             tampon = 'Emis HCO+ '//ii2c(iupl)//'->'//ii2c(jlol)
             call LDVInt (xmu, amhcop, aijhcop(ii), gi, gj
     1                    , wlkhcop(ii), xi, xj, tampon)
           endif

         end do

c----------------------------------------------------------------------
c EMISSIVITE INTEGREE DE H2O
c----------------------------------------------------------------------

       else if (yspec == 'h2o') then

         do while (ii /= 0)
           print *, '   Transition?  (0: fin)'
           read *, ii
           if (ii > ntrh2o) then
             ii = 0
           end if
           if (irec == 1) then
             write (8,*) ii
           endif

           if (ii /= 0) then
             iupl = iuph2o(ii)
             jlol = jloh2o(ii)
             gi = gsth2o(iupl)
             gj = gsth2o(jlol)
             xi = abnua(i_h2o,0:npo) * xreh2o(iupl,0:npo)
             xj = abnua(i_h2o,0:npo) * xreh2o(jlol,0:npo)
             tampon = 'Emis H2O '//ii2c(iupl)//'->'//ii2c(jlol)
             call LDVInt (xmu, amh2o, aijh2o(ii), gi, gj
     1                    , wlkh2o(ii), xi, xj, tampon)
           endif

         end do
!----------------------------------------------------------------------
! EMISSIVITE INTEGREE DE H3+
!----------------------------------------------------------------------

       else if (yspec == 'h3+' .OR. yspec == 'h3p') then

 2107    PRINT *," n- Ju Ku Jl Kl lam(cm)"
         DO ii = 1, ntrh3p
            levu = iuph3p(ii)
            levl = jloh3p(ii)
            ju  = elevh3p(levu)%j
            ku  = elevh3p(levu)%k
            jl  = elevh3p(levl)%j
            kl  = elevh3p(levl)%k
            xlam = hcsurk / wlkh3p(ii)
            PRINT *,ii,elevh3p(levu)%j,elevh3p(levu)%k,
     1                 elevh3p(levl)%j,elevh3p(levl)%K,xlam
         ENDDO
         PRINT *,"0- FIN"
         READ  *, ii
         if (irec == 1) then
            write (8,*) ii
         endif

         IF (ii /= 0) THEN
            levu = iuph3p(ii)
            levl = jloh3p(ii)
            gi   = elevh3p(levu)%g
            gj   = elevh3p(levl)%g
            xi   = abnua(i_h3p,0:npo) * xreh3p(levu,0:npo)
            xj   = abnua(i_h3p,0:npo) * xreh3p(levl,0:npo)
            ju   = elevh3p(levu)%j
            ku   = elevh3p(levu)%k
            jl   = elevh3p(levl)%j
            kl   = elevh3p(levl)%k
            tampon = 'Emii H3+ lu='//ii2c(levu)//',ll='//ii2c(levl)
            call LDVInt (xmu, amh3p, aijh3p(ii), gi, gj
     1                      , wlkh3p(ii), xi, xj, tampon)
            goto 2107
         ELSE
            goto 2108
         ENDIF


       else

         print *
         print *, 'Desole, cette selection est impossible!'
         goto 2108

       endif

       goto 2108

 1002  continue

       close (35)
 4112  format (i8,i3,1x,2i3,1x,2i3,2x,1pd9.3,2x,1pd12.6,2(2x,1pd9.3))

       return
       end
