
c Copyright (C) 2002 - Observatoire de Paris/Meudon
c                      Universite Paris 7
c                      CNRS (France)
c                      Contact : Jacques.Lebourlot@obspm.fr
c
c This program is free software; you can redistribute it and/or
c modify it under the terms of the GNU General Public License version 2
c as published by the Free Software Foundation.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c GNU General Public License for more details.
c
c You should have received a copy of the GNU General Public License
c along with this program; if not, write to the Free Software
c Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.


c      %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
       subroutine CHOFRO (iimax, irec)
c      %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

       use constantes
       use prepvar
       USE PROFIL
       USE CHEM_DATA
       USE STR_DATA

        implicit double precision (a-h,o-z)

c--------+---------+---------+---------+---------+---------+---------+-*-------+

        print *
 2004   print *, '   Processus de chauffage et/ou refroidissement'
        print *, '      1: chauffage       2: refroidissement'
        print *, '      3: processus mixtes (H2, gaz-grains, ...)'
        print *, '               (fin: -1)'
        read *, ii2
        if (irec == 1) then
          write (8,*) ii2
        endif

        if (ii2 == -1) then
          goto 1005
        endif

        if (ii2 == 1) then

 1001     print *, '     1: (Unused)       ,   2: Photons sur grains'
          print *, '     3: H2 sur grains,     4: Photons sur gas'
          print *, '     5: Rayons cosmiques,  6: Photons secondaires'
          print *, '     7: Equil. chimique,   8: Chauffage turbulent'
          print *, '     9: Chauffage total,  -1: fin'
          read *, ii3
          if (irec == 1) then
            write (8,*) ii3
          endif

          if (ii3 == -1) then
            goto 2004
          endif

          if (ii3 == 1) then

            print *, "Unused !"

          else if (ii3 == 2) then

            iimax = iimax + 1
            do j=0,npo
              y(iimax,j) = chophg(j)
            end do
            texty(iimax) = 'Cho_Ph_Gr     '

          else if (ii3 == 3) then

            iimax = iimax + 1
            do j=0,npo
              y(iimax,j) = choh2g(j)
            end do
            texty(iimax) = 'Cho_H2_Gr     '

          else if (ii3 == 4) then

            iimax = iimax + 1
            do j=0,npo
              y(iimax,j) = chopht(j)
            end do
            texty(iimax) = 'Cho_photons   '

          else if (ii3 == 5) then

            iimax = iimax + 1
            do j=0,npo
              y(iimax,j) = chorc(j)
            end do
            texty(iimax) = 'Cho_RC        '

          else if (ii3 == 6) then

            iimax = iimax + 1
            do j=0,npo
              y(iimax,j) = chophs(j)
            end do
            texty(iimax) = 'Cho_ph_sec    '

          else if (ii3 == 7) then

            iimax = iimax + 1
            do j=0,npo
              y(iimax,j) = chochi(j)
            end do
            texty(iimax) = 'Cho_eq_chi    '

          else if (ii3 == 8) then

            iimax = iimax + 1
            do j=0,npo
              y(iimax,j) = chotur(j)
            end do
            texty(iimax) = 'Cho_turb      '

          else if (ii3 == 9) then

            iimax = iimax + 1
            do j=0,npo
              y(iimax,j) = chotot(j)
            end do
            texty(iimax) = 'Cho_total     '

          else

            print *, '     ****  WARNING: valeur impossible!  ****'
            goto 1001

          endif

          goto 1001

        else if (ii2 == 2) then

 1006     print *, '  1: C I,   2: N I,    3: O I,   4: S I,   5: Si I'
          print *, '  6: C II,  7: N II,   8: O II,  9: S II, 10: Si II'
          print *, ' 11: CO,   12: 13CO,  13: C18O, 14: 13C18O'
          print *, ' 15: H2O,  16: OH,    17: Fe+,  18: CS,   19: HCO+'
          print *, ' 20: H3+'
          print *, ' 21: Refroidissement total'
          print *, ' -1: Fin'
          read *, ii3
          if (irec == 1) then
            write (8,*) ii3
          endif

          if (ii3 < 1 .OR. ii3 > 21) then
            goto 2004
          endif

          if (ii3 == 1) then

            iimax = iimax + 1
            do j=0,npo
              y(iimax,j) = refcat(j)
            end do
            texty(iimax) = 'Ref_C_tot     '

          else if (ii3 == 2) then

            iimax = iimax + 1
            do j=0,npo
              y(iimax,j) = refnat(j)
            end do
            texty(iimax) = 'Ref_N_tot     '

          else if (ii3 == 3) then

            iimax = iimax + 1
            do j=0,npo
              y(iimax,j) = refoat(j)
            end do
            texty(iimax) = 'Ref_O_tot     '

          else if (ii3 == 4) then

            iimax = iimax + 1
            do j=0,npo
              y(iimax,j) = refsat(j)
            end do
            texty(iimax) = 'Ref_S_tot     '

          else if (ii3 == 5) then

            iimax = iimax + 1
            do j=0,npo
              y(iimax,j) = refsiat(j)
            end do
            texty(iimax) = 'Ref_Si_tot     '

          else if (ii3 == 6) then

            iimax = iimax + 1
            do j=0,npo
              y(iimax,j) = refcpl(j)
            end do
            texty(iimax) = 'Ref_C+_tot    '

          else if (ii3 == 7) then

            iimax = iimax + 1
            do j=0,npo
              y(iimax,j) = refnpl(j)
            end do
            texty(iimax) = 'Ref_N+_tot    '

          else if (ii3 == 8) then

            iimax = iimax + 1
            do j=0,npo
              y(iimax,j) = refopl(j)
            end do
            texty(iimax) = 'Ref_O+_tot    '

          else if (ii3 == 9) then

            iimax = iimax + 1
            do j=0,npo
              y(iimax,j) = refspl(j)
            end do
            texty(iimax) = 'Ref_S+_tot    '

          else if (ii3 == 10) then

            iimax = iimax + 1
            do j=0,npo
              y(iimax,j) = refsip(j)
            end do
            texty(iimax) = 'Ref_Si+_tot    '

          else if (ii3 == 11) then

            iimax = iimax + 1
            do j=0,npo
              y(iimax,j) = refco0(j)
            end do
            texty(iimax) = 'Ref_CO_tot    '

          else if (ii3 == 12) then

            iimax = iimax + 1
            do j=0,npo
              y(iimax,j) = refco1(j)
            end do
            texty(iimax) = 'Ref_C*O_tot   '

          else if (ii3 == 13) then

            iimax = iimax + 1
            do j=0,npo
              y(iimax,j) = refco2(j)
            end do
            texty(iimax) = 'Ref_CO*_tot   '

          else if (ii3 == 14) then

            iimax = iimax + 1
            do j=0,npo
              y(iimax,j) = refco3(j)
            end do
            texty(iimax) = 'Rf_C*O*_tot   '

          else if (ii3 == 15) then

            iimax = iimax + 1
            do j=0,npo
              y(iimax,j) = refh2o(j)
            end do
            texty(iimax) = 'Ref_H2O_tot   '

          else if (ii3 == 16) then

            iimax = iimax + 1
            do j=0,npo
              y(iimax,j) = refoh(j)
            end do
            texty(iimax) = 'Ref_OH_tot    '

          else if (ii3 == 17) then

            iimax = iimax + 1
            do j=0,npo
              y(iimax,j) = reffep(j)
            end do
            texty(iimax) = 'Ref_Fe+_tot   '

          else if (ii3 == 18) then

            iimax = iimax + 1
            do j=0,npo
              y(iimax,j) = refcs0(j)
            end do
            texty(iimax) = 'Ref_CS_tot    '

          else if (ii3 == 19) then

            iimax = iimax + 1
            do j=0,npo
              y(iimax,j) = refhcop(j)
            enddo
            texty(iimax) = 'Ref_HCOP_tot    '

          else if (ii3 == 20) then

            iimax = iimax + 1
            do j=0,npo
              y(iimax,j) = refh3p(j)
            enddo
            texty(iimax) = 'Ref_H3P_tot    '

          else if (ii3 == 21) then

            iimax = iimax + 1
            do j=0,npo
              y(iimax,j) = reftot(j)
            end do
            texty(iimax) = 'Ref_total     '

          else

            print *, '     ****  WARNING: valeur impossible!  ****'
            goto 1006

          endif

          goto 1006

        else if (ii2 == 3) then

 1003     print *, '     1: H2,    2: couplage gaz-grains'
          print *, '          (fin: -1)'
          read *, ii3
          if (irec == 1) then
            write (8,*) ii3
          endif

          if (ii3 == -1) then
            goto 2004
          endif

          if (ii3 == 1) then

            iimax = iimax + 1
            do j=0,npo
              y(iimax,j) = max(0.0d0,-rfjh2t(j))
            end do
            texty(iimax) = 'Cho_casc_H2   '

            iimax = iimax + 1
            do j=0,npo
              y(iimax,j) = max(0.0d0,rfjh2t(j))
            end do
            texty(iimax) = 'Ref_casc_H2   '

          else if (ii3 == 2) then

            iimax = iimax + 1
            do j=0,npo
              y(iimax,j) = max(0.0d0,choeqg(j))
            end do
            texty(iimax) = 'Cho_gas_gr    '

            iimax = iimax + 1
            do j=0,npo
              y(iimax,j) = max(0.0d0,-choeqg(j))
            end do
            texty(iimax) = 'Ref_gas_gr    '

          else

            print *, '   *** valeur impossible'
            goto 1003

          endif

          goto 1003

        else

          print *, '     ****  WARNING: valeur impossible!  ****'
          goto 2004

        endif

 1005   continue

      return
      end
