
c Copyright (C) 2002 - Observatoire de Paris/Meudon
c                      Universite Paris 7
c                      CNRS (France)
c                      Contact : Jacques.Lebourlot@obspm.fr
c 
c This program is free software; you can redistribute it and/or
c modify it under the terms of the GNU General Public License version 2
c as published by the Free Software Foundation.
c 
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c GNU General Public License for more details.
c 
c You should have received a copy of the GNU General Public License
c along with this program; if not, write to the Free Software
c Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.


c      %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
       subroutine AUTRE (iimax, irec)
c      %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

       use constantes
       use prepvar
       use auxiliaries
       use inoutput
       USE RF_TOOLS
       USE SP_DATA
       USE CHEM_DATA
       USE PROFIL

        implicit double precision (a-h,o-z)

        character (LEN=25) :: fichout
        character (LEN=2)  :: ii2c
        character (LEN=8)  :: yspec
        INTEGER            :: voie_disso

c--------+---------+---------+---------+---------+---------+---------+-*-------+

 2005  print *, '  1: Temperature Gaz,    2: Temperature Grains'
       print *, '  3: Densite H (n(H) + 2 n(H2))'
       print *, '  4: Densite num tot (n(H) + n(H2) + n(He))'
       print *, '  5: Degre d''ionisation, 6: Pression'
       print *, '  7: l (distance en cm), 8: Photodissociation'
       print *, '  9: formation destruction de H2, CO et HD'
       print *, ' 10: Charge des grains'
       print *, ' 11: Carte Td - H2:'
       print *, ' 12: Rayonnement (densite de photons et d enrgie)'
       print *, ' -1: fin'
       read *, ii2
       if (irec == 1) then
         write (8,*) ii2
       endif

       if (ii2 == -1) then
         goto 1002
       endif

       if (ii2 == 1) then

         iimax = iimax + 1
         do j=0,npo
           y(iimax,j) = tgaz(j)
         end do
         texty(iimax) = 'Temp_Gaz      '

       else if (ii2 == 2) then

         do mm=1,npg
           iimax = iimax + 1
           do j=0,npo
             y(iimax,j) = tdust(mm,j)
           end do
           texty(iimax) = 'Td_'//ii2c(mm)
         end do

       else if (ii2 == 3) then

         iimax = iimax + 1
         do j=0,npo
           y(iimax,j) = densh(j)
         end do
         texty(iimax) = 'Dens_H        '

       else if (ii2 == 4) then

         iimax = iimax + 1
         do j=0,npo
           y(iimax,j) = abnua(i_h,j) + abnua(i_h2,j) + abnua(i_he,j)
         end do
         texty(iimax) = 'Dens_Tot      '

       else if (ii2 == 5) then

         iimax = iimax + 1
         do j=0,npo
           y(iimax,j) = abnua(nspec,j) / densh(j)
         end do
         texty(iimax) = 'Ionisation    '

       else if (ii2 == 6) then

         iimax = iimax + 1
         do j=0,npo
           y(iimax,j) = (abnua(i_h,j) + abnua(i_h2,j) + abnua(i_he,j))
     1                * tgaz(j)
         end do
         texty(iimax) = 'Pression      '

       else if (ii2 == 7) then

         iimax = iimax + 1
         cte = tautav * cdunit * 0.5_dp / rrr
         y(iimax,0) = 0.0_dp
         do j=1,npo
           y(iimax,j) = y(iimax,j-1) + cte * (tau(j) - tau(j-1))
     1                * (1.0_dp / densh(j-1) + 1.0_dp / densh(j))
         end do
         texty(iimax) = 'Taille_(cm)   '

       else if (ii2 == 8) then

2006    print *, ' which species ?'
         print *, '-1: fin'
         read (*,6) yspec
         if (irec == 1) then
           write (8,6) yspec
         endif
   6     format(a8)

         if (yspec == "-1") then
            goto 2005
            
         else
           voie_disso = 0
           do jj=1,nphot_i
             if (ndiesp(jj) == yspec) then
               voie_disso = voie_disso + 1
             endif
           end do
           ii3 = 0
           do jj=1,nphot_i
             if (ndiesp(jj) == yspec) then
               ii3 = jj
               exit
             endif
           end do
           print*,'nbre de voies de disso: ',voie_disso
           if (voie_disso == 1) then
             if (ii3 /= 0) then
               iimax = iimax + 1
               y(iimax,0) = 0.0_dp
               do j=1,npo
                 y(iimax,j) = pdiesp(ii3,j)
               end do
               texty(iimax) = 'Pd_'//yspec
               goto 2006
             endif
           else
             if (voie_disso > 1) then
               if (ii3 /= 0) then
                 iimax = iimax + 1
                 y(iimax,0) = 0.0_dp
                 do j=1,npo
                   do k=2,voie_disso
                     pdiesp(ii3,j)=pdiesp(ii3,j)+pdiesp(ii3+(k-1),j)
                   enddo
                   y(iimax,j) = pdiesp(ii3,j)
                 end do
                 texty(iimax) = 'Pd_'//yspec
                 goto 2006
               endif                
             else
               print *, '  No cross-section for ', yspec
               goto 2006
                   
             endif
           endif
         endif


       else if (ii2 == 9) then

         print *, ' 1: H2, 2: CO, 3: HD'
         read *, ii3
         if (irec == 1) then
           write (8,*) ii3
         endif

         if (ii3 == 1) then

           iimax = iimax + 1
           y(iimax,0) = 0.0_dp
           do j=1,npo
             y(iimax,j) = timh21(j)
           end do
           texty(iimax) = 'FH2chi        '

           iimax = iimax + 1
           y(iimax,0) = 0.0_dp
           do j=1,npo
             y(iimax,j) = timh22(j)
           end do
           texty(iimax) = 'DH2chi        '

           iimax = iimax + 1
           y(iimax,0) = 0.0_dp
           do j=1,npo
             y(iimax,j) = timh23(j)
           end do
           texty(iimax) = 'FH2grain      '

           iimax = iimax + 1
           y(iimax,0) = 0.0_dp
           do j=1,npo
             y(iimax,j) = timh24(j)
           end do
           texty(iimax) = 'DH2phot       '

           print *, " Evaporation from grain? (y: 1, n: 0)"
           read *, ii4
           if (irec == 1) then
             write (8,*) ii4
           endif

           if (ii4 == 1) then
             do mm=1,npmg
               iimax = iimax + 1
               y(iimax,0) = 0.0_dp
               do j=1,npo
                 y(iimax,j) = t_25(mm,j)
               end do
               texty(iimax) = 'EvaH2gr       '
             end do
           endif

         else if (ii3 == 2) then

           iimax = iimax + 1
           y(iimax,0) = 0.0_dp
           do j=1,npo
             y(iimax,j) = timco1(j)
           end do
           texty(iimax) = 'FCOchi        '

           iimax = iimax + 1
           y(iimax,0) = 0.0_dp
           do j=1,npo
             y(iimax,j) = timco2(j)
           end do
           texty(iimax) = 'DCOchi        '

           iimax = iimax + 1
           y(iimax,0) = 0.0_dp
           do j=1,npo
             y(iimax,j) = timco3(j)
           end do
           texty(iimax) = 'DCOphot       '

         else  if (ii3 == 3) then

           iimax = iimax + 1
           y(iimax,0) = 0.0_dp
           do j=1,npo
             y(iimax,j) = timhd1(j)
           end do
           texty(iimax) = 'FHDchi        '

           iimax = iimax + 1
           y(iimax,0) = 0.0_dp
           do j=1,npo
             y(iimax,j) = timhd2(j)
           end do
           texty(iimax) = 'DHDchi        '

           iimax = iimax + 1
           y(iimax,0) = 0.0_dp
           do j=1,npo
             y(iimax,j) = timhd3(j)
           end do
           texty(iimax) = 'FHDgrain      '

           iimax = iimax + 1
           y(iimax,0) = 0.0_dp
           do j=1,npo
             y(iimax,j) = timhd4(j)
           end do
           texty(iimax) = 'DHDphot       '

         else

           print *, 'cette valeur n''est pas encore prevue'
           goto 2005

         endif

       else if (ii2 == 10) then

         iimax = iimax + 1
         do j=1,npo
           y(iimax,j) = zmoy(1,j)
         end do
         texty(iimax) = 'R_gr_max   '

         iimax = iimax + 1
         do j=1,npo
           y(iimax,j) = zmoy(npg/2,j)
         end do
         texty(iimax) = 'R_gr_moy   '

         iimax = iimax + 1
         do j=1,npo
           y(iimax,j) = zmoy(npg,j)
         end do
         texty(iimax) = 'R_gr_min   '

       else if (ii2 == 11) then

         print *
         print *, '   entrer le nom du fichier a fabriquer:'
         read (*,5) fichout
         fichout = TRIM(ADJUSTL(fichout))
         if (irec == 1) then
           write (8,5) fichout
         endif
         print *, fichout
   5     format(a25)

         fichier = TRIM(out_dir)//fichout
         open (24, file=fichier, status="unknown")
         write (24, 1235)
 1235    format("# r_g T_d ab_H2g frac_H2g t_res effic")
           do j=1,npo
             do mm=1,npg
               abdm = surfgr(mm) * densh(j) /(dsite*dsite)
               tres = abnua(i_h2gr+mm-1,j) / t_25(mm,j)
               effi = exp(-60.0d0/tres)
               write(24,1234) x(j), adust(mm), tdust(mm,j)
     1       , abnua(i_h2gr+mm-1,j), abnua(i_h2gr+mm-1,j) / abdm
     2       , tres, effi
             end do
             write(24,*)
           end do
         close (24)

 1234    format(1p,7e12.5)

       else if (ii2 == 12) then

         iimax = iimax + 1
         do j=0,npo
           y(iimax,j) = fluph(j)
         end do
         texty(iimax) = 'Flu_PHOT      '
         iimax = iimax + 1
         do j=0,npo
           y(iimax,j) = int_rad(j)
         end do
         texty(iimax) = 'U_(erg.cm-3)  '

       else

         print *, 'cette valeur n''est pas encore prevue'
         goto 2005

       endif

       goto 2005

 1002  continue

       return
       end
