
c Copyright (C) 2002 - Observatoire de Paris/Meudon
c                      Universite Paris 7
c                      CNRS (France)
c                      Contact : Jacques.Lebourlot@obspm.fr
c
c This program is free software; you can redistribute it and/or
c modify it under the terms of the GNU General Public License version 2
c as published by the Free Software Foundation.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c GNU General Public License for more details.
c
c You should have received a copy of the GNU General Public License
c along with this program; if not, write to the Free Software
c Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.


         subroutine ANALYS

         use constantes
       use prepvar
       USE H2_DATA
       USE SP_DATA
       USE STR_DATA
       USE CHEM_DATA
       USE PROFIL

         implicit double precision (a-h,o-z)

         dimension ab1(nqm), ab2(nqm), ab3(nqm)
         dimension fabric(nqm), destru(nqm)

         character (LEN=8) :: yspec

         do iopt=0,npo
           abnua(nspec+1,iopt) = 1.0d0
           abnua(nspec+2,iopt) = 1.0d0
           abnua(nspec+3,iopt) = 1.0d0
           abnua(nspec+4,iopt) = 1.0d0
           abnua(nspec+5,iopt) = 1.0d0
           abnua(nspec+6,iopt) = 1.0d0
         end do

         print *, '*****************************************'
         print *, '    Analyse de la chimie dans le nuage   '
         print *, '*****************************************'
         print *,'Souhaitez-vous tracer les evolutions des reactions?'
         print *,'1-oui, 0-non'
         read *,ii0
         if (ii0 == 1) then
            call EVOLREACT
         endif

         print *, '-----------------------------------------'
         print *, '     analyse de la chimie en un point    '
         print *, '-----------------------------------------'
 2004    print *, "En quel point souhaitez-vous analyser la chimie ?"
         print *, "valeur maximale: (iopt):",npo
         print *, "pour terminer l'analyse: -1"
         read *, iopt

         if (iopt == -1) then
           goto 2003
         endif

         print *
         print *, 'Point ',iopt
         print *, 'Ce point correspond a tau:', tau(iopt)
         av = tau(iopt) * tautav
         print *, '   Av =', av, "  T = ", tgaz(iopt)
         print *, 'Cette position vous satisfait-elle ?'
         print *, '1- oui   0- non'
         read  *, answ
         if (answ /= 1) then
            goto 2004
         else
            continue
         endif

         print *, 'Quel seuil voulez-vous? (tout = 0)'
         read *, seuil

         temp = tgaz(iopt)
         dens = densh(iopt)

         h2para = 0.0_dp
         h2orth = 0.0_dp
         do lev=1,nlevh2
           jj = njlev(lev)
           if (mod(jj,2) == 0) then
             h2para = h2para + xreh2(lev,iopt)
           else
             h2orth = h2orth + xreh2(lev,iopt)
           endif
         end do

         call XKFILL (iopt, dens)

 2002    continue

         print *
         print *, 'Quelle espece voulez-vous analyser? (fin: -1)'
         read (*,5) yspec
   5     format(a8)

         if (yspec == '-1') then
           goto 2003
         endif

         do jj=1,nspec
           if (speci(jj) == yspec) then
             isp = jj
           endif
         end do

         fabric(1:neqt) = 0.0d0
         destru(1:neqt) = 0.0d0

         nrxi = ikmat(isp,0)

          do k=1,nrxi
            ind = ikmat(isp,k)
            j1 = react(ind,1)
            j2 = react(ind,2)
            j3 = react(ind,3)
            ab1(k) = abnua(j1,iopt)
            ab2(k) = abnua(j2,iopt)
            ab3(k) = abnua(j3,iopt)
          end do

c             Formation et destruction

         if = 0
         id = 0
         ftot = 0.0d0
         dtot = 0.0d0
         do k=1,nrxi
           toto = xkmat(isp,k)
           if (toto > 0.0_dp) then
             if = if + 1
             fabric(k) = toto * ab1(k) * ab2(k)
             ftot = ftot + fabric(k)
           else if (toto < 0.0d0) then
             id = id + 1
             destru(k) = -toto * ab1(k) * ab2(k)
             dtot = dtot + destru(k)
           endif
         end do

         print *
         print *, '-----------------------------------------------'
         print *, '        analyse de la chimie de ',yspec
         print *, '-----------------------------------------------'
         print *
         print *, "Av= ", av, " T =", tgaz(iopt), " (K)"
         write (6,1003) ftot, dtot, abnua(isp,iopt)
         print *
         fpc = ftot
         dpc = dtot
         if (seuil /= 0.0d0) then
           ftot = ftot / seuil
           dtot = dtot / seuil
         else
           ftot = 0.0d0
           dtot = 0.0d0
         endif

         print *, '-- Processus de fabrication de  ',yspec,':'

         do 40 ii=1,nrxi
           fmax = 0.0d0
           do jj=1,nrxi
             if (fabric(jj) > fmax) then
               fmax = fabric(jj)
               jmax = jj
             endif
           end do

           if (fmax < ftot .or. fmax == 0.0d0) goto 100

           ind = ikmat(isp,jmax)

           write (6,1001) (speci(react(ind,j)), j=1,7), fmax
     1        , fmax / abnua(isp,iopt), 100.0d0*fmax/fpc, ind
           fabric(jmax) = 0.0d0
   40    continue

  100    print *, ' '
         print *, '-- Processus de destruction de  ',yspec,':'

         do 50 ii=1,nrxi
           dmax = 0.0d0
           do jj=1,nrxi
             if (destru(jj) > dmax) then
               dmax = destru(jj)
               jmax = jj
             endif
           end do

           if (dmax < dtot .or. dmax == 0.0d0) goto 200

           ind = ikmat(isp,jmax)

           write (6,1001) (speci(react(ind,j)), j=1,7), dmax
     1        , dmax / abnua(isp,iopt), 100.0d0*dmax/dpc, ind
           destru(jmax) = 0.0d0
   50    continue

  200    continue
           print *, '-----------------------------------------------'

         goto 2002

 2003    continue

 1001    format (1x,a8,' + ',a8,' + ',a8,' = ',4a8,5x,1pe12.4
     1           ,'  cm-3 s-1',e12.4,' s-1',0pf8.2,' %',i4)
 1003    format (1x,'fabric:',1pe15.6,' (cm-3 s-1), destru:',e15.6,
     1              ' (cm-3 s-1), abond:',e15.6,' (cm-3)')

         return
         end

c ***********************************************************************************

        subroutine XKFILL (iopt, dens)

       use constantes
       use prepvar
       use auxiliaries
       USE RF_TOOLS
       USE H2_DATA
       USE HD_DATA
       USE SP_DATA
       USE STR_DATA
       USE CHEM_DATA
       USE PROFIL

        implicit double precision (a-h,o-z)

        dimension indy(0:nes)

c  initialisations

        avr = tau(npo) * tautav - av

        xkmat(1:nspec,1:neqt) = 0.0_dp
        indy(0:nspec) = 0

C----DENSITE TOTALE (CM-3) DES ESPECES COLLEES SUR LES GRAINS
      abongr = 0.0_dp
      do i=nn+ni+nim+1,nn+ni+nim+nng
        abongr = abongr + abnua(i,iopt)
      end do

c   Fraction de H2 (pour le flux de photons secondaires)

      frach2 = abnua(i_h2,iopt) / (abnua(i_h,iopt) + abnua(i_h2,iopt))

C---Hydrogenation:
      xkhydr = max(abongr, bsitgr * densh(iopt))

C----IR1 ET IR2 SONT LES DEUX REACTANTS DE LA REACTION
C    IP1 ET IP2 LES DEUX PREMIERS PRODUITS

C chemical reactions are reordered:
C (0) formation of H2 and HD on grains [Old Style] (nh2for)
C (1) cosmic ray processes (ncrion)
C (2) secondary photon processes (npsion)
C (3) radiative association  (nasrad)
C (4) gas phase reactions (nrest)
C (6) Endothermal reactions with H2 (nh2endo) (NEW!)
C (5) photoreactions avec fit exterieur (nphot_f)
C (7) photoreactions avec integration directe (nphot_i)
C (8) 3 body reactions
C (101...) exceptions (ncpart)

C (11) reactions on grain surface (ngsurf)
C (12) photoreactions on grain surface (ngphot)
C (13) adsorption on to grains (ngads)
C (14) neutralization (ngneut)
C (15) explosive desorption from grains (nggdes)
C (16) cosmic ray induced desorption from grains (ncrdes)
C (17) photodesorption from grains (nphdes)
C (18) evaporation from grains (ngevap)

C-------------------------------------------------------------------------
C  ESPECES SPECifIQUES : NSPEC + 1 : ELECTRON
C                        NSPEC + 2 : PHOTON
C                        NSPEC + 3 : CRP
C                        NSPEC + 4 : GRAIN

C       --------------------------
C-- 1 - reactIONS EN PHASE GAZEUSE
C       --------------------------

C-------------------------------------------------------------------------
C (0) formation of H2 and HD on grains [Old Style] (nh2for)  (cm3 s-1)
C-------------------------------------------------------------------------

      do i=1,nh2for

        ir1 = react(i,1)
        ir2 = react(i,2)
        iprod = react(i,4)

        rate = signgr * vmaxw * sqrt(temp / mol(ir1))
        rate = rate * gamm(i) * densh(iopt) / (istiny + abnua(i_h,iopt))

        kkk = indy(iprod) + 1
        indy(iprod) = kkk
        xkmat(iprod,kkk) = rate

        kkk = indy(ir1) + 1
        indy(ir1) = kkk
        xkmat(ir1,kkk) = - rate

        kkk = indy(ir2) + 1
        indy(ir2) = kkk
        xkmat(ir2,kkk) = - rate

      end do

C-------------------------------------------------------------------------
C (1) cosmic ray processes (ncrion)   (s-1)
C-------------------------------------------------------------------------
      ideb = nh2for + 1
      ifin = nh2for + ncrion
      do i=ideb,ifin

        rate = gamm(i) * zeta

        ik = react(i,0)
        do j=4,ik+1
          iprod = react(i,j)
          kkk = indy(iprod) + 1
          indy(iprod) = kkk
          xkmat(iprod,kkk) = rate
        end do

        ir1 = react(i,1)
        kkk = indy(ir1) + 1
        indy(ir1) = kkk
        xkmat(ir1,kkk) = - rate

      end do

C-------------------------------------------------------------------------
C (2) secondary photon processes (npsion)   (s-1)
C-------------------------------------------------------------------------
c  27 II 2003 - Test to use UMIST form of secondary photons reactions
c               Needed for Serena Viti chemistry

      i_UMIST = 0

      ideb = ifin + 1
      ifin = ifin + npsion
      do i=ideb,ifin

        if (i_UMIST == 1) then
          rate = gamm(i) * frach2 * zeta * bet(i) / (1.0_dp - alb)
        else
          rate = gamm(i) * frach2 * zeta * (temp/300.0d0)**alpha(i)
        endif

        ik = react(i,0)
        do j=4,ik+1
          iprod = react(i,j)
          kkk = indy(iprod) + 1
          indy(iprod) = kkk
          xkmat(iprod,kkk) = rate
        end do

        ir1 = react(i,1)
        kkk = indy(ir1) + 1
        indy(ir1) = kkk
        xkmat(ir1,kkk) = - rate

      end do

C-------------------------------------------------------------------------
C (3) radiative association  (nasrad)   (cm3 s-1)
C-------------------------------------------------------------------------
      ideb = ifin + 1
      ifin = ifin + nasrad
      do i=ideb,ifin

        rate = gamm(i) * (temp/300.0d0)**alpha(i)
     1       * exp(-bet(i)/temp)

        iprod = react(i,4)
        kkk = indy(iprod) + 1
        indy(iprod) = kkk
        xkmat(iprod,kkk) = rate

        ir1 = react(i,1)
        kkk = indy(ir1) + 1
        indy(ir1) = kkk
        xkmat(ir1,kkk) = - rate

        ir2 = react(i,2)
        kkk = indy(ir2) + 1
        indy(ir2) = kkk
        xkmat(ir2,kkk) = - rate

      end do

C-------------------------------------------------------------------------
C (4) gas phase reactions (nrest)   (cm3 s-1)
C-------------------------------------------------------------------------
      ideb = ifin + 1
      ifin = ifin + nrest
      do i=ideb,ifin

        if (bet(i) < 0.0_dp) then
          expon = exp(-bet(i)/max(temp,200.0_dp))
        else
          expon = exp(-bet(i)/temp)
        endif

        rate = gamm(i) * (temp/300.0d0)**alpha(i)
     1      * expon
c    1      * exp(-bet(i)/temp)

        ik = react(i,0)
        do j=4,ik+1
          iprod = react(i,j)
          kkk = indy(iprod) + 1
          indy(iprod) = kkk
          xkmat(iprod,kkk) = rate
        end do

        ir1 = react(i,1)
        kkk = indy(ir1) + 1
        indy(ir1) = kkk
        xkmat(ir1,kkk) = - rate

        ir2 = react(i,2)
        kkk = indy(ir2) + 1
        indy(ir2) = kkk
        xkmat(ir2,kkk) = - rate

      end do

C-------------------------------------------------------------------------
C (6) Endothermal reactions with H2 (nh2endo)   (cm3 s-1)
C-------------------------------------------------------------------------
      ideb = ifin + 1
      ifin = ifin + nh2endo
      do i=ideb,ifin

        rate = 0.0_dp
        do lev=1,l0h2
          endo_rxn = max(bet(i) - elhm(lev), 0.0_dp)
          rat_l = gamm(i) * (temp/300.0d0)**alpha(i)
     1        * exp(-endo_rxn/temp)
          rate = rate + rat_l * xreh2(lev,iopt)
        end do

        ik = react(i,0)
        do j=4,ik+1
          iprod = react(i,j)
          kkk = indy(iprod) + 1
          indy(iprod) = kkk
          xkmat(iprod,kkk) = rate
        end do

        ir1 = react(i,1)
        kkk = indy(ir1) + 1
        indy(ir1) = kkk
        xkmat(ir1,kkk) = - rate

        ir2 = react(i,2)
        kkk = indy(ir2) + 1
        indy(ir2) = kkk
        xkmat(ir2,kkk) = - rate

      end do

C-------------------------------------------------------------------------
C (5) photoreactions (external fit) (nphot_f)    (s-1)
C-------------------------------------------------------------------------
      ideb = ifin + 1
      ifin = ifin + nphot_f
      do i=ideb,ifin

        ir1 = react(i,1)
c  Le coefficient effectif (radm ou radp) a ete calcule dans le main
        rate1 = gamm(i) * exp(-bet(i) * av) * radm
        rate2 = gamm(i) * exp(-bet(i) * avr) * radp
        rate = rate1 + rate2

        ik = react(i,0)
        do j=4,ik+1
          iprod = react(i,j)
          kkk = indy(iprod) + 1
          indy(iprod) = kkk
          xkmat(iprod,kkk) = rate
        end do

        kkk = indy(ir1) + 1
        indy(ir1) = kkk
        xkmat(ir1,kkk) = - rate

      end do

C-------------------------------------------------------------------------
C (7) photoreactions (nphot_i)    (s-1)
C-------------------------------------------------------------------------
      ideb = ifin + 1
      ifin = ifin + nphot_i
      do i=ideb,ifin

        rate = pdiesp(i-ideb+1,iopt)

        ik = react(i,0)
        do j=4,ik+1
          iprod = react(i,j)
          kkk = indy(iprod) + 1
          indy(iprod) = kkk
          xkmat(iprod,kkk) = rate
        end do

        ir1 = react(i,1)
        kkk = indy(ir1) + 1
        indy(ir1) = kkk
        xkmat(ir1,kkk) = - rate

      end do

C-------------------------------------------------------------------------
C (8) 3 body reactions (n3body)
C-------------------------------------------------------------------------

      ideb = ifin + 1
      ifin = ifin + n3body
      do i=ideb,ifin

        ir1 = react(i,1)
        ir2 = react(i,2)
        ir3 = react(i,3)
        expon = exp(-bet(i)/temp)
        rate = gamm(i) * (temp/300.0d0)**alpha(i)
     1      * expon
        rate = rate * abnua(i_h,iopt)

        ik = react(i,0)
        do j=4,ik+1
          iprod = react(i,j)
          kkk = indy(iprod) + 1
          indy(iprod) = kkk
          xkmat(iprod,kkk) = rate
        end do

        kkk = indy(ir1) + 1
        indy(ir1) = kkk
        xkmat(ir1,kkk) = - rate
        kkk = indy(ir2) + 1
        indy(ir2) = kkk
        xkmat(ir2,kkk) = - rate
        kkk = indy(ir3) + 1
        indy(ir3) = kkk
        xkmat(ir3,kkk) = - rate

      end do

C-------------------------------------------------------------------------
C (101...) exceptions (ncpart)
C-------------------------------------------------------------------------
      ideb = ifin + 1
      ifin = ifin + ncpart
      do i=ideb,ifin
        ir1 = react(i,1)
        ir2 = react(i,2)

c  101: N+ + H2:
        if   (ir1 == i_h2 .and. ir2 == i_np) then
          rate = gamm(i) * (h2para * exp(-bet(i) / temp) + h2orth)
     1         * ((temp / 300.0d0)**alpha(i))

c  102: H3+ + HD:
          else  if (ir1 == i_h2 .and. ir2 == i_h2dp
     1      .and. temp>= 20.d0)   then
          rate = gamm(i) / 10**(62.481 *temp**(-0.94871d0))
         else if  (ir1 == i_h2 .and. ir2 == i_h2dp
     1      .and. temp< 20.d0) then
           rate = gamm(i) / (6.3407d35
     1         * temp **(-25.203d0))

c  103: O+ + H:
         else if   (ir1 == i_h .and. ir2 == i_op) then
          rate = (gamm(i) + alpha(i) * temp) * exp(-bet(i) / temp)

c  104: H+ + O:
         else if   (ir1 == i_o .and. ir2 ==i_hp) then
          rate = (gamm(i) + alpha(i) * temp) * exp(-bet(i) / temp)
c  105: reaction exp(-T/E)  (formation de H- : Black)
         else if (itype(i) == 105) then
          rate = gamm(i) * (temp/300.0)**alpha(i) * exp(-temp/bet(i))
        else
          rate = 0.0_dp
        endif

        iprod = react(i,4)
        kkk = indy(iprod) + 1
        indy(iprod) = kkk
        xkmat(iprod,kkk) = rate

        iprod = react(i,5)
        kkk = indy(iprod) + 1
        indy(iprod) = kkk
        xkmat(iprod,kkk) = rate

        kkk = indy(ir1) + 1
        indy(ir1) = kkk
        xkmat(ir1,kkk) = - rate

        kkk = indy(ir2) + 1
        indy(ir2) = kkk
        xkmat(ir2,kkk) = - rate

      end do

C       -------------------------
C-- 2 - REACTIONS AVEC LES GRAINS
C       -------------------------

C-------------------------------------------------------------------------
C (11) reactions on grain surface (ngsurf)
c      (y compris formation de H2)
C-------------------------------------------------------------------------
      ideb = ifin + 1
      ifin = ifin + ngsurf
      do i=ideb,ifin

        ir1 = react(i,1)
        ir2 = react(i,2)

        rate = gamm(i) * (tm1h(ir1) + tm1h(ir2)) / xkhydr

        ik = react(i,0)
        do j=4,ik+1
          iprod = react(i,j)
          kkk = indy(iprod) + 1
          indy(iprod) = kkk
          xkmat(iprod,kkk) = rate
        end do

        kkk = indy(ir1) + 1
        indy(ir1) = kkk
        xkmat(ir1,kkk) = - rate

        kkk = indy(ir2) + 1
        indy(ir2) = kkk
        xkmat(ir2,kkk) = - rate

      end do

C-------------------------------------------------------------------------
C (12) photoreactions on grain surface (ngphot)
C-------------------------------------------------------------------------
      ideb = ifin + 1
      ifin = ifin + ngphot
      do i=ideb,ifin

        rate1 = gamm(i) * exp(-bet(i)*av) * radm
        rate2 = gamm(i) * exp(-bet(i)*avr) * radp
        rate = rate1 + rate2

        ik = react(i,0)
        do j=4,ik+1
          iprod = react(i,j)
          kkk = indy(iprod) + 1
          indy(iprod) = kkk
          xkmat(iprod,kkk) = rate
        end do

        ir1 = react(i,1)
        kkk = indy(ir1) + 1
        indy(ir1) = kkk
        xkmat(ir1,kkk) = - rate

        ir2 = react(i,2)
        kkk = indy(ir2) + 1
        indy(ir2) = kkk
        xkmat(ir2,kkk) = - rate

      end do

C-------------------------------------------------------------------------
C (13) adsorption on to grains (ngads)
C-------------------------------------------------------------------------
      if (istic == 1) then
        stickH = gamm(iadhgr)

      else if (istic == 2) then
c  Sticking bidouille a partir de Sternberg et Dalgarno pour
c     avoir a peu pres 1 a basse temperature
        t2 = temp / 100.0d0
        stickH = 2.5d0
     1        / (1.0d0 + 0.4d0 * sqrt(tdust(1,iopt) + t2) + 0.2d0 * t2)

      else if (istic == 3) then
c  Sticking pompe dans Andersson & Wannier Ap J 402 585, 1993
        stickH = 1.0d0 / (temp/102.0d0 + 1.0d0)**2

      else if (istic == 4 .and. temp >= 10.0d0) then
c  Sticking sauce ' Pineau des forets & Flower, mnras
c       stickH = 1.0_dp / (temp * temp * 1.0d-4 + 1.0_dp)
        stickH = 1.0_dp * sqrt(10.d0) / sqrt(temp)
      else if (istic == 4 .and. temp. lt. 10.d0) then
         stickH = 1.0_dp

      else if (istic == 5) then
c  Sticking sauce JLB
        stickH = 1.0d0 / (temp * temp * 1.0d-4 + 1.0d0)

      endif
      gamm(iadhgr) = stickH
      if (i_d /= 0) then
        gamm(iaddgr) = stickH
      endif

      ideb = ifin + 1
      ifin = ifin + ngads
      do i=ideb,ifin
        ir1 = react(i,1)
        if (itype(i) == 13) then
c  Adsorption "ordinaire"

          rate = signgr * vmaxw * sqrt(temp / mol(ir1))
          rate = rate * gamm(i) * densh(iopt)

          iprod = react(i,4)
          kkk = indy(iprod) + 1
          indy(iprod) = kkk
          xkmat(iprod,kkk) = rate

          kkk = indy(ir1) + 1
          indy(ir1) = kkk
          xkmat(ir1,kkk) = - rate

        else if (itype(i) == 113) then
c  Adsorption de H2, taux "reel"

          ratef = vmaxw * sqrt(temp / mol(i_h2))
     1          * densh(iopt) * gamm(i) / 4.0d0

          iprod = react(i,4)
          rate = ratef * surfgr(1+iprod-i_h2gr)

          kkk = indy(iprod) + 1
          indy(iprod) = kkk
          xkmat(iprod,kkk) = rate

          kkk = indy(i_h2) + 1
          indy(i_h2) = kkk
          xkmat(i_h2,kkk) = - rate

        else if (itype(i) == 123) then
c  Adsorption de H2 "pseudo-reaction" limitante

          rate = vmaxw * sqrt(temp / mol(i_h2))
     1          * gamm(i) * dsite*dsite / 4.0d0

          iprod = react(i,4)
          kkk = indy(iprod) + 1
          indy(iprod) = kkk
          xkmat(iprod,kkk) = rate

          ir2 = react(i,2)
          kkk = indy(ir2) + 1
          indy(ir2) = kkk
          xkmat(ir2,kkk) = - rate

       endif

      end do

C-------------------------------------------------------------------------
C (14) neutralization (ngneut)
C-------------------------------------------------------------------------
      ideb = ifin + 1
      ifin = ifin + ngneut
      do i=ideb,ifin

        ir1 = react(i,1)
        rate = rxigr(ir1,iopt)

        iprod = react(i,4)
        kkk = indy(iprod) + 1
        indy(iprod) = kkk
        xkmat(iprod,kkk) = rate

        kkk = indy(ir1) + 1
        indy(ir1) = kkk
        xkmat(ir1,kkk) = - rate

      end do

C-------------------------------------------------------------------------
C (15) explosive desorption from grains (nggdes)
c    ref: Shalabiea & Greenberg 1994
C-------------------------------------------------------------------------
      ideb = ifin + 1
      ifin = ifin + nggdes
      do i=ideb,ifin

        ir1 = react(i,1)
        rat1 = gamm(i) * rdeso * densh(iopt)
        rat2 = gamm(i) * 3.0d4 * zeta * (signgr / 7.0d-21)
        rate = rat1 + rat2

        if (itype(i) == 15) then
          iprod = react(i,4)
          kkk = indy(iprod) + 1
          indy(iprod) = kkk
          xkmat(iprod,kkk) = rate

          kkk = indy(ir1) + 1
          indy(ir1) = kkk
          xkmat(ir1,kkk) = - rate
        else if (ir1 == i_h2gr) then
          do mm=1,npg
            iprod = react(i,4)
            kkk = indy(iprod) + 1
            indy(iprod) = kkk
            rateh = rate * surfgr(mm)
     1            * densh(iopt) / (dsite*dsite)
            xkmat(iprod,kkk) = rateh

            ir2 = ir1 + (mm-1)
            kkk = indy(ir2) + 1
            indy(ir2) = kkk
            xkmat(ir2,kkk) = - rate
          end do
        else
          print *, "  Not yet included, use type 15, not 115"
          stop
        end if

      end do

C-------------------------------------------------------------------------
C (16) cosmic ray induced desorption from grains (ncrdes)
c      (sans les photons secondaires)
C-------------------------------------------------------------------------
      ideb = ifin + 1
      ifin = ifin + ncrdes
      do i=ideb,ifin

c       rate = gamm(i) * fphsec * frach2 * 4.0d0 * signgr / xkhydr
c       rate = rate * densh(iopt)
        rate = 0.0_dp

        iprod = react(i,4)
        kkk = indy(iprod) + 1
        indy(iprod) = kkk
        xkmat(iprod,kkk) = rate

        ir1 = react(i,1)
        kkk = indy(ir1) + 1
        indy(ir1) = kkk
        xkmat(ir1,kkk) = - rate

      end do

C-------------------------------------------------------------------------
C (17) photodesorption from grains (nphdes)
c      (les photons secondaires sont isotropes, pas les photons incidents)
C-------------------------------------------------------------------------
c  flux de photons secondaires due aux rayons cosmiques:
c     1E3 cm-2 s-1 (Roberge, in Dalgarno's book)
c      fphsec = 1.0d3 * (zeta / 1.0d-17)

c  flux de Mathis et al de 911 a 2400 A (avec F(l) = 5e-17 erg cm-3 A-1)
c  flupho = 1e8 photon cm-2 s-1      (Tielens & Hagen, 1982, A&A 114, 245)
c     flupho = 1.0d8
c     flupho = flupho * RAD * exp(-2.0d0 * AV)

      ideb = ifin + 1
      ifin = ifin + nphdes
      do i=ideb,ifin

        ir1 = react(i,1)

        if (itype(i) == 17) then
          rate = gamm(i) * fphsec * frach2 * 4.0d0 * signgr / xkhydr
          rate = rate + gamm(i) * fluph(iopt) * signgr / xkhydr
          rate = rate * densh(iopt)
          iprod = react(i,4)
          kkk = indy(iprod) + 1
          indy(iprod) = kkk
          xkmat(iprod,kkk) = rate

          kkk = indy(ir1) + 1
          indy(ir1) = kkk
          xkmat(ir1,kkk) = - rate

        else if (itype(i) == 117) then

          ratef = gamm(i) * densh(iopt) / xkhydr
          ratef = ratef * (frach2 * fphsec + fluph(iopt) / 4.0d0)

          iprod = react(i,4)
          rate = ratef * surfgr(1+ir1-i_h2gr)

          kkk = indy(iprod) + 1
          indy(iprod) = kkk
          xkmat(iprod,kkk) = rate

          kkk = indy(ir1) + 1
          indy(ir1) = kkk
          xkmat(ir1,kkk) = - rate

        else
          print *, "  Not yet included, use type 17, not 117"
          stop
        end if


      end do

C-------------------------------------------------------------------------
C (18) evaporation from grains (ngevap)
C-------------------------------------------------------------------------
      ideb = ifin + 1
      ifin = ifin + ngevap
      do i=ideb,ifin

        ir1 = react(i,1)
        if (itype(i) == 18) then
          rate = gamm(i) * sqrt(2.0d0*xk*bet(i)/(xmh*mol(ir1)))
     1         / (xpi * dsite)
          rate = rate * exp(-bet(i)/tdust(1,iopt))

          iprod = react(i,4)
          kkk = indy(iprod) + 1
          indy(iprod) = kkk
          xkmat(iprod,kkk) = rate

          kkk = indy(ir1) + 1
          indy(ir1) = kkk
          xkmat(ir1,kkk) = - rate

        else if (itype(i) == 118) then

          rate = gamm(i) * sqrt(2.0d0*xk*bet(i)/(xmh*mol(ir1)))
     1         / (xpi * dsite)
          rate = rate * exp(-bet(i)/tdust(1+ir1-i_h2gr,iopt))

          iprod = react(i,4)
          kkk = indy(iprod) + 1
          indy(iprod) = kkk
          xkmat(iprod,kkk) = rate

          kkk = indy(ir1) + 1
          indy(ir1) = kkk
          xkmat(ir1,kkk) = - rate

        else
          print *, "  Not yet included, use type 18, not 118"
          stop
        end if

      end do

C-------------------------------------------------------------------------

        return
        end
