
c Copyright (C) 2002 - Observatoire de Paris/Meudon
c                      Universite Paris 7
c                      CNRS (France)
c                      Contact : Jacques.Lebourlot@obspm.fr
c
c This program is free software; you can redistribute it and/or
c modify it under the terms of the GNU General Public License version 2
c as published by the Free Software Foundation.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c GNU General Public License for more details.
c
c You should have received a copy of the GNU General Public License
c along with this program; if not, write to the Free Software
c Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.


c      %%%%%%%%%%%%%%%%%
       subroutine TRANSF
c      %%%%%%%%%%%%%%%%%

       use constantes
       use auxiliaries
       USE RF_TOOLS
       USE SP_DATA
       USE H2_DATA
       USE HD_DATA
       USE STR_DATA
       USE CHEM_DATA
       USE PROFIL

       implicit double precision(a-h,o-z)

c      character (LEN=30) ::  le_fich

c      parameter (nwlgin = 45)
c      real wlang(nwlgin), ray(nwlgin)

       dimension wlnMMP(45), rayMMP(45)
       dimension ttetl(nlvmax)

       real (kind=dp), dimension(5) :: tti

c  wlnMMP, rayMMP is radiation from Mathis, Metzger & Panagia
c    Mathis et al 1985, astron. astrophys. 128, 212
c    ray=u(lambda) in erg cm-3 a-1 -Energy density per Angstrom-

c  This not used at the moment (dec 05), but could be of use some day

       data wlnMMP / 5.0d2, 9.1211d+02, 9.12118d+02, 1.0d3, 1.1d3
     1            , 1.3d3, 1.43d3, 1.8d3, 2.0d3, 2.1d3, 2.16d3, 2.3d3
     2            , 2.5d3, 3.46d3, 4.35d3, 5.5d3, 7.0d3, 9.0d3, 1.2d4
     3            , 1.8d4, 2.2d4, 2.4d4, 3.4d4, 4.0d4, 5.0d4, 6.0d4
     4            , 8.0d4, 1.0d5, 1.2d5, 2.0d5, 2.5d5, 3.5d5, 4.0d5
     5            , 5.0d5, 6.0d5, 7.0d5, 8.0d5, 1.0d6, 1.5d6, 2.0d6
     6            , 3.0d6, 4.0d6, 6.0d6, 8.0d6, 1.0d7 /
       data rayMMP / 0.0d0, 0.0d0, 3.6d0, 4.9d0, 6.8d0, 6.83d0, 6.07d0
     1            , 4.13d0, 3.47d0, 3.20d0, 3.06d0, 2.75d0, 2.42d0
     2            , 4.33d0, 5.0d0, 5.23d0, 5.1d0, 4.4d0, 3.09d0
     3            , 1.35d0, 8.03d-1, 6.30d-1, 2.16d-1, 1.26d-1
     4            , 5.87d-2, 3.07d-2, 1.07d-2, 1.09d-2, 7.37d-3
     5            , 2.38d-3, 3.80d-3, 5.67d-3, 1.02d-2, 1.36d-2
     6            , 1.59d-2, 1.50d-2, 1.40d-2, 1.05d-2, 4.53d-3
     7            , 1.87d-3, 4.63d-4, 1.87d-4, 4.40d-5, 1.40d-5
     8            , 7.13d-6 /

c  initial abondances

c  Chemical species and Excitation of H2 (HD) and CO and so on
c    at cloud edge

       temp = tgaz(1)

       do j=1,nspec
         abnua(j,0) = abin(j) * densh(0)
       end do

       h2para = 0.25_dp
       h2orth = 0.75_dp
       xreh2(1,0) = 0.25_dp
       xreh2(2,0) = 0.75_dp
       do lev=3,l0h2
         xj = njlev(lev)
         xreh2(lev,0) = 10.0_dp**(-xj)
       end do
       cdth2 = 0.0_dp
       cdth2_o = 0.0_dp

c HD
       if (i_hd /= 0) then
         xrehd(1,0) = 0.25_dp
         xrehd(2,0) = 0.75_dp
         do lev=3,l0hd
           xj = njhd(lev)
           xrehd(lev,0) = 10.0_dp**(-xj)
         end do
         cdthd = 0.0_dp
         cdthd_o = 0.0_dp
       endif

c C

       emicat(:,0) = 0.0_dp
       opdcat(:,0) = 0.0_dp

       do i=1,nlvcat
         tti(i) = gstcat(i) * exp(-elkcat(i) / max(temp,500.0_dp))
       end do
       do i=1,nlvcat
         xrecat(i,0) = tti(i) / SUM(tti(1:nlvcat))
       end do

c N

       eminat(:,0) = 0.0_dp
       opdnat(:,0) = 0.0_dp

       do i=1,nlvnat
         tti(i) = gstnat(i) * exp(-elknat(i) / max(temp,500.0_dp))
       end do
       do i=1,nlvnat
         xrenat(i,0) = tti(i) / SUM(tti(1:nlvnat))
       end do

c O

       emioat(:,0) = 0.0_dp
       opdoat(:,0) = 0.0_dp

       do i=1,nlvoat
         tti(i) = gstoat(i) * exp(-elkoat(i) / max(temp,500.0_dp))
       end do
       do i=1,nlvoat
         xreoat(i,0) = tti(i) / SUM(tti(1:nlvoat))
       end do

c S

       emisat(:,0) = 0.0_dp
       opdsat(:,0) = 0.0_dp

       do i=1,nlvsat
         tti(i) = gstsat(i) * exp(-elksat(i) / max(temp,500.0_dp))
       end do
       do i=1,nlvsat
         xresat(i,0) = tti(i) / SUM(tti(1:nlvsat))
       end do

c Si

       emisiat(:,0) = 0.0_dp
       opdsiat(:,0) = 0.0_dp

       do i=1,nlvsiat
         tti(i) = gstsiat(i) * exp(-elksiat(i) / max(temp,500.0_dp))
       end do
       do i=1,nlvsiat
         xresiat(i,0) = tti(i) / SUM(tti(1:nlvsiat))
       end do

c C+

       emicpl(:,0) = 0.0_dp
       opdcpl(:,0) = 0.0_dp

       do i=1,nlvcpl
         tti(i) = gstcpl(i) * exp(-elkcpl(i) / max(temp,500.0_dp))
       end do
       do i=1,nlvcpl
         xrecpl(i,0) = tti(i) / SUM(tti(1:nlvcpl))
       end do

c N+

       eminpl(:,0) = 0.0_dp
       opdnpl(:,0) = 0.0_dp

       do i=1,nlvnpl
         tti(i) = gstnpl(i) * exp(-elknpl(i) / max(temp,500.0_dp))
       end do
       do i=1,nlvnpl
         xrenpl(i,0) = tti(i) / SUM(tti(1:nlvnpl))
       end do

c O+

       emiopl(:,0) = 0.0_dp
       opdopl(:,0) = 0.0_dp

       do i=1,nlvopl
         tti(i) = gstopl(i) * exp(-elkopl(i) / max(temp,500.0_dp))
       end do
       do i=1,nlvopl
         xreopl(i,0) = tti(i) / SUM(tti(1:nlvopl))
       end do

c S+

       emispl(:,0) = 0.0_dp
       opdspl(:,0) = 0.0_dp

       do i=1,nlvspl
         tti(i) = gstspl(i) * exp(-elkspl(i) / max(temp,500.0_dp))
       end do
       do i=1,nlvspl
         xrespl(i,0) = tti(i) / SUM(tti(1:nlvspl))
       end do

c Si+

       emisip(:,0) = 0.0_dp
       opdsip(:,0) = 0.0_dp

       do i=1,nlvsip
         tti(i) = gstsip(i) * exp(-elksip(i) / max(temp,500.0_dp))
       end do
       do i=1,nlvsip
         xresip(i,0) = tti(i) / SUM(tti(1:nlvsip))
       end do

c  CO

       fnpart = 0.0_dp
       do j=1,nlvco0
         ttetl(j) = gstco0(j) * exp(-elkco0(j) / temp)
         fnpart = fnpart + ttetl(j)
       end do
       do j=1,nlvco0
         xreco0(j,0) = ttetl(j) / fnpart
       end do
       cdtc0 = 0.0_dp
       cdtc0_o = 0.0_dp
       emico0(:,0) = 0.0_dp
       opdco0(:,0) = 0.0_dp

c  C*O

       fnpart = 0.0_dp
       do j=1,nlvco0
         ttetl(j) = gstco1(j) * exp(-elkco1(j) / temp)
         fnpart = fnpart + ttetl(j)
       end do
       do j=1,nlvco0
         xreco1(j,0) = ttetl(j) / fnpart
       end do
       cdtc1 = 0.0_dp
       cdtc1_o = 0.0_dp
       emico1(:,0) = 0.0_dp
       opdco1(:,0) = 0.0_dp

c  CO*

       fnpart = 0.0_dp
       do j=1,nlvco0
         ttetl(j) = gstco2(j) * exp(-elkco2(j) / temp)
         fnpart = fnpart + ttetl(j)
       end do
       do j=1,nlvco0
         xreco2(j,0) = ttetl(j) / fnpart
       end do
       cdtc2 = 0.0_dp
       cdtc2_o = 0.0_dp
       emico2(:,0) = 0.0_dp
       opdco2(:,0) = 0.0_dp

c  C*O*

       fnpart = 0.0_dp
       do j=1,nlvco0
         ttetl(j) = gstco3(j) * exp(-elkco3(j) / temp)
         fnpart = fnpart + ttetl(j)
       end do
       do j=1,nlvco0
         xreco3(j,0) = ttetl(j) / fnpart
       end do
       cdtc3 = 0.0_dp
       cdtc3_o = 0.0_dp
       emico3(:,0) = 0.0_dp
       opdco3(:,0) = 0.0_dp

c  CS

       fnpart = 0.0_dp
       do j=1,nlvcs0
         ttetl(j) = gstcs0(j) * exp(-elkcs0(j) / temp)
         fnpart = fnpart + ttetl(j)
       end do
       do j=1,nlvcs0
         xrecs0(j,0) = ttetl(j) / fnpart
       end do
       emics0(:,0) = 0.0_dp
       opdcs0(:,0) = 0.0_dp

c HCO+: -----------------------------------------------------------
c On calcule le fonction de partition
c on entre les valeurs initiales des pop dans les niveaux, des
c emissivites initiales et des proba d'absorption(?) aux points 1
c et 0 du nuage

       fnpart = 0.0_dp
       do  j=1,nlvhcop
         ttetl(j) = gsthcop(j) * exp(-elkhcop(j) / temp)
         fnpart = fnpart + ttetl(j)
       enddo
       do  j=1,nlvhcop
         xrehcop(j,0) = ttetl(j) / fnpart
       enddo
       emihcop(:,0) = 0.0_dp
       opdhcop(:,0) = 0.0_dp

c H2O: -----------------------------------------------------------

       fnpart = 0.0_dp
       do  j=1,nlvh2o
         ttetl(j) = gsth2o(j) * exp(-elkh2o(j) / max(temp,500.0_dp))
         fnpart = fnpart + ttetl(j)
       enddo
       do  j=1,nlvh2o
         xreh2o(j,0) = ttetl(j) / fnpart
       enddo
       emih2o(:,0) = 0.0_dp
       opdh2o(:,0) = 0.0_dp

c H3+: -----------------------------------------------------------
c On calcule le fonction de partition
c on entre les valeurs initiales des pop dans les niveaux, des
c emissivites initiales et des proba d'absorption(?) aux points 1
c et 0 du nuage

       fnpart = 0.0_dp
       do  j=1,nlvh3p
         ttetl(j) = elevh3p(j)%g * dexp(-elevh3p(j)%en / temp)
         fnpart = fnpart + ttetl(j)
       enddo
       do  j=1,nlvh3p
         xreh3p(j,0) = ttetl(j) / fnpart
       enddo
       do  j=1,ntrh3p
         emih3p(j,0) = 0.0_dp
         opdh3p(j,0) = 0.0_dp
       enddo


c  This is for Mathis field

c      nwlgin = 45
c      do iwlg=1,nwlgin
c        wlang(iwlg) = wlnMMP(iwlg)
c        ray(iwlg) = rayMMP(iwlg) * 1.0d-17
c      end do

       return
       end

c-------------------------------------------------------------------

      SUBROUTINE STAR
!=================================================================================
! - Most data from "Allen's Astrophysical Quantities" 4th ed (A. Cox Ed.) 
!   Sect 15.3.1 (p 388).
! - Some additional data from :
!   Effective temperature are from Lang, "Astrophysical Formulae",  p564
! - Some radii from Lang p 546 - Note inconsistencies between quoted temp...
! - Note a better representation (continuous) can be derived from :
!   De Jager & Nieuwenhuijzen, A & A 177, 217 (1987)
!
!  Specific stars are easily added. Has to be done in /data/star.dat
!=================================================================================
        USE constantes
        USE INOUTPUT
        USE PROFIL

        implicit none

        INTEGER                         :: i_star  
        INTEGER                         :: star_found   ! flag
        CHARACTER(LEN=15)               :: spectype1    ! spectral type in data
        CHARACTER(LEN=15)               :: spectype2    ! other eventual spelling of spectral type        

        fichier = TRIM(ADJUSTL(data_dir))//'star.dat'
        OPEN(10,file = fichier,status = "old",action="read")
        READ(10,*) ! commentaire
        READ(10,*) ! commentaire
        READ(10,*) ! commentaire
        star_found = 0
        DO i_star = 1, 100000
           READ(10,1010,END=110) spectype1, spectype2, teff, rstar
           spectype1 = TRIM(ADJUSTL(spectype1))
           spectype2 = TRIM(ADJUSTL(spectype2))
           IF ( (spectype1 == TRIM(ADJUSTL(srcpp)) ) 
     1    .OR.  (spectype2 == TRIM(ADJUSTL(srcpp)) ) ) THEN
              star_found = 1
              rstar = rstar * rsun
              EXIT
           ENDIF
        ENDDO
 110    continue
        CLOSE(10)
        
        IF (star_found /= 1) THEN
           WRITE(ISCRN,*)" ****  Warning ***** "
           WRITE(ISCRN,*)" Spectral type unknown for :"
           WRITE(ISCRN,*) srcpp
           WRITE(ISCRN,*)" *** STOP *** "
           STOP
        ENDIF

        WRITE(ISCRN,*) "Spectral type used : ", TRIM(ADJUSTL(srcpp))
        WRITE(ISCRN,*) "Teff   : ", teff
        WRITE(ISCRN,*) "radius : ", rstar

 1010   format(A15,A15,F13.4,F10.4,A15)

        return

      end subroutine STAR

c-------------------------------------------------------------------

c      %%%%%%%%%%%%%%%%%
       subroutine ABSGAZ
c      %%%%%%%%%%%%%%%%%

c  Gaz absorption coefficient in lines
c  JLB - 22 V 2003

       use constantes
       use auxiliaries
       use RF_TOOLS
       USE STR_DATA
       USE PROFIL
       USE transfer

       implicit none

       integer                            :: n, i, j
       real (kind=dp)                     :: wl0, nu0, fosc, dvie
       real (kind=dp)                     :: nu
       real (kind=dp)                     :: dopl, coef1, coef2, aux
       real (kind=dp)                              :: avoi
       real (kind=dp), dimension(:), allocatable   :: xwl, yvoi
       integer                            :: nvl, njl

       ALLOCATE (xwl(0:nwlg), yvoi(0:nwlg))
       g_absI = 0.0_dp
       g_absL = 0.0_dp
       coef1 = sqrt(xpi) * clum * e2smc2
       coef2 = tautav * cdunit / rrr

c  Outer loop on position in cloud

       do n=0,npo

c  Middle loop on lines
c  A - Atomic hydrogen

         if (jlyman == 1) then
         do i=1,nraih
           wl0 = praih(i,2) * 1.0e-8_dp
           nu0 = clum / wl0
           fosc = praih(i,1)
           dvie = praih(i,3)

c  dopl is in frequency unit
           dopl = sqrt(vturb*vturb + 2.0_dp * xk * tgaz_o(n) / xmh)
     1          / wl0
           avoi = dvie / (4.0_dp * xpi * dopl)
           do j=0,nwlg
             nu = 1.0e8_dp * clum / rf_wl%Val(j)
             xwl(j) = (nu0 - nu) / dopl
           end do

           call humlik (nwlg+1, xwl, avoi, yvoi)

           aux = coef1 * fosc / dopl
           do j=0,nwlg
             g_absL(n,j) = g_absL(n,j) + yvoi(j) * aux
     1                   * abh_o(n)
           end do

         end do
         endif

c  C - CO

         if (jfgkco0 > 0) then
         do i=1,nrco0
           njl = irco0(i)
           if (njl >= jfgkco0) then
             cycle
           endif
           wl0 = prco0(i,2) * 1.0e-8_dp
           nu0 = clum / wl0
           fosc = prco0(i,1)
           dvie = prco0(i,3)

c  dopl is in frequency unit
           dopl = sqrt(vturb*vturb + 2.0_dp * xk * tgaz_o(n)
     1          / (amco0 * xmh)) / wl0
           avoi = dvie / (4.0_dp * xpi * dopl)
           do j=0,nwlg
             nu = 1.0e8_dp * clum / rf_wl%Val(j)
             xwl(j) = (nu0 - nu) / dopl
           end do

           call humlik (nwlg+1, xwl, avoi, yvoi)

           aux = coef1 * fosc / dopl
           do j=0,nwlg
             g_absL(n,j) = g_absL(n,j) + yvoi(j) * aux
     1                   * abco0_o(n) * xco0_o(njl,n)
           end do

         end do
         endif

c  B - Molecular hydrogen (Lyman band)

         do i=1,nrh2bt
           nvl = irah2b(i,1)
           njl = irah2b(i,2)
           if (nvl > 0 .OR. njl >= jfgkh2) then
             cycle
           endif
           wl0 = prah2b(i,2) * 1.0e-8_dp
           nu0 = clum / wl0
           fosc = prah2b(i,1)
           dvie = prah2b(i,3)

c  dopl is in frequency unit
           dopl = sqrt(vturb*vturb + 2.0_dp * xk * tgaz_o(n)
     1          / (2.0_dp*xmh)) / wl0
           avoi = dvie / (4.0_dp * xpi * dopl)
           do j=0,nwlg
             nu = 1.0e8_dp * clum / rf_wl%Val(j)
             xwl(j) = (nu0 - nu) / dopl
           end do

           call humlik (nwlg+1, xwl, avoi, yvoi)

           aux = coef1 * fosc / dopl
           do j=0,nwlg
             g_absL(n,j) = g_absL(n,j) + yvoi(j) * aux
     1                  * abh2_o(n) * xh2_o(njl,n)
           end do

         end do

c  C - Molecular hydrogen (Werner band)

         do i=1,nrh2ct
           nvl = irah2c(i,1)
           njl = irah2c(i,2)
           if (nvl > 0 .OR. njl >= jfgkh2) then
             cycle
           endif
           wl0 = prah2c(i,2) * 1.0e-8_dp
           nu0 = clum / wl0
           fosc = prah2c(i,1)
           dvie = prah2c(i,3)

c  dopl is in frequency unit
           dopl = sqrt(vturb*vturb + 2.0_dp * xk * tgaz_o(n)
     1          / (2.0_dp*xmh)) / wl0
           avoi = dvie / (4.0_dp * xpi * dopl)
           do j=0,nwlg
             nu = 1.0e8_dp * clum / rf_wl%Val(j)
             xwl(j) = (nu0 - nu) / dopl
           end do

           call humlik (nwlg+1, xwl, avoi, yvoi)

           aux = coef1 * fosc / dopl
           do j=0,nwlg
             g_absL(n,j) = g_absL(n,j) + yvoi(j) * aux
     1                  * abh2_o(n) * xh2_o(njl,n)
           end do

         end do
       end do

       do n=1,npo
         g_absI(n,:) = g_absI(n-1,:)
     1               + 0.5_dp * coef2 * (tau_o(n) - tau_o(n-1))
     2               * (g_absL(n,:) / dens_o(n)
     3               + g_absL(n-1,:) / dens_o(n-1))
       end do

       DEALLOCATE (xwl, yvoi)

       return
       end

c-------------------------------------------------------------------

       subroutine humlik (n, x, y, k)

       use constantes

       real (kind=dp) r0, r1
c      parameter (r0 = 146.7, r1 = 14.67)
c  rr must <= 5.0
c      parameter (r0 = 1.51*exp(1.144*rr), r1 = 1.60*exp(0.554*rr))
       parameter (r0 = 460.4_dp, r1 = 25.5_dp)

       integer n
       real (kind=dp) x(0:n-1)
       real (kind=dp) y
       real (kind=dp) k(0:n-1)

       real (kind=dp) rrtpi
       parameter (rrtpi = 0.564189583547756_dp)
       real (kind=dp) y0, y0py0, y0q
       parameter (y0 = 1.5_dp, y0py0 = y0+y0, y0q = y0*y0)
       real (kind=dp) c(0:5), s(0:5), t(0:5)
       save c, s, t
       data c / 1.0117281_dp, -0.75197147_dp, 0.012557727_dp,
     1          0.010022008_dp, -0.00024206814_dp,
     2          0.00000050084806_dp /
       data s / 1.393237_dp, 0.23115241_dp, -0.15535147_dp,
     1          0.0062183662_dp, 0.000091908299_dp,
     2          -0.00000062752596_dp /
       data t / 0.31424038_dp, 0.94778839_dp, 1.5976826_dp,
     1          2.2795071_dp, 3.0206370_dp, 3.8897249_dp /

       integer i, j
       integer rg1, rg2, rg3
       real (kind=dp) abx, xq, yq, yrrtpi
       real (kind=dp) xlim0, xlim1, xlim2, xlim3, xlim4
       real (kind=dp) a0, d0, d2, e0, e2, e4, h0, h2, h4, h6
       real (kind=dp) p0, p2, p4, p6, p8, z0, z2, z4, z6, z8
       real (kind=dp) xp(0:5), xm(0:5), yp(0:5), ym(0:5)
       real (kind=dp) mq(0:5), pq(0:5), mf(0:5), pf(0:5)
       real (kind=dp) d, yf, ypy0, ypy0q

c-----------------------------------------------------------------------

       rg1 = 1
       rg2 = 1
       rg3 = 1
       yq = y * y
       yrrtpi = y * rrtpi

       xlim0 = r0 - y
       xlim1 = r1 - y
       xlim3 = 3.097_dp*y - 0.45_dp

c      xlim0 = 15100.0 + y * (40.0 + y * 3.6)
c      xlim1 = 164.0 - y * (4.3 + y * 1.8)
c      xlim3 = 5.76 * yq

       xlim2 = 6.8_dp - y
       xlim4 = 18.1_dp * y + 1.65_dp
       if (y <= 1.0e-6_dp) then
         xlim1 = xlim0
         xlim2 = xlim0
       endif

       do i=0,n-1
         abx = abs(x(i))
         xq = abx * abx

         if (abx > xlim0) then
           k(i) = yrrtpi / (xq + yq)

         else if (abx > xlim1) then
           if (rg1 /= 0) then
             rg1 = 0
             a0 = yq + 0.5_dp
             d0 = a0 * a0
             d2 = yq + yq - 1.0_dp
           endif
           d = rrtpi / (d0 + xq * (d2 + xq))
           k(i) = d * y * (a0 + xq)

         else if (abx > xlim2) then
           if (rg2 /= 0) then
             rg2 = 0
             h0 = 0.5625_dp + yq * (4.5_dp + yq * (10.5_dp
     1                      + yq * (6.0_dp + yq)))
             h2 = -4.5_dp + yq * (9.0_dp + yq * (6.0_dp + yq * 4.0_dp))
             h4 = 10.5_dp - yq * (6.0_dp - yq * 6.0_dp)
             h6 = -6.0_dp + yq * 4.0_dp
             e0 = 1.875_dp + yq * (8.25_dp + yq * (5.5_dp + yq))
             e2 = 5.25_dp + yq * (1.0_dp + yq * 3.0_dp)
             e4 = 0.75_dp * h6
           endif
           d = rrtpi / (h0 + xq * (h2 + xq * (h4 + xq * (h6 + xq))))
           k(i) = d * y * (e0 + xq * (e2 + xq * (e4 + xq)))

         else if (abx < xlim3) then
           if (rg3 /= 0) then
             z0 = 272.1014_dp + y * (1280.829_dp + y * (2802.870_dp
     1                        + y * (3764.966_dp + y * (3447.629_dp
     2                        + y * (2256.981_dp + y * (1074.409_dp
     3                        + y * (369.1989_dp + y * (88.26741_dp
     4                        + y * (13.39880_dp + y)))))))))
             z2 = 211.678_dp  + y * (902.3066_dp + y * (1758.336_dp
     1                        + y * (2037.310_dp + y * (1549.675_dp
     2                        + y * (793.4273_dp + y * (266.2987_dp
     3                        + y * (53.59518_dp + y * 5.0_dp)))))))
             z4 = 78.86585_dp + y * (308.1852_dp + y * (497.3014_dp
     1                        + y * (479.2576_dp + y * (269.2916_dp
     2                        + y * (80.39278_dp + y * 10.0_dp)))))
             z6 = 22.03523_dp + y * (55.02933_dp + y * (92.75679_dp
     1                        + y * (53.59518_dp + y * 10.0_dp)))
             z8 = 1.496460_dp + y * (13.39880_dp + y * 5.0_dp)
             p0 = 153.5168_dp + y * (549.3954_dp + y * (919.4955_dp
     1                        + y * (946.8970_dp + y * (662.8097_dp
     2                        + y * (328.2151_dp + y * (115.3772_dp
     3                        + y * (27.93941_dp + y * (4.264678_dp
     4                        + y * 0.3183291_dp))))))))
             p2 = -34.16955_dp + y * (-1.322256_dp + y * (124.5975_dp
     1                        + y * (189.7730_dp  + y * (139.4665_dp
     2                        + y * (56.81652_dp  + y * (12.79458_dp
     3                        + y * 1.2733163_dp))))))
             p4 = 2.584042_dp + y * (10.46332_dp + y * (24.01655_dp
     1                        + y * (29.81482_dp + y * (12.79568_dp
     2                        + y * 1.9099744_dp))))
             p6 = -0.07272979_dp + y * (0.9377051_dp + y * (4.266322_dp
     1                        + y * 1.273316_dp))
             p8 = 0.0005480304_dp + y * 0.3183291_dp
           endif
           d = 1.7724538_dp / (z0 + xq * (z2 + xq * (z4 + xq
     1       * (z6 + xq * (z8 + xq)))))
           k(i ) = d * (p0 + xq * (p2 + xq * (p4 + xq
     1           * (p6 + xq * p8))))

         else
           ypy0 = y + y0
           ypy0q = ypy0 * ypy0
           k(i) = 0.0_dp
           do j=0,5
             d = x(i) - t(j)
             mq(j) = d * d
             mf(j) = 1.0_dp / (mq(j) + ypy0q)
             xm(j) = mf(j) * d
             ym(j) = mf(j) * ypy0
             d = x(i) + t(j)
             pq(j) = d * d
             pf(j) = 1.0_dp / (pq(j) + ypy0q)
             xp(j) = pf(j) * d
             yp(j) = pf(j) * ypy0
           end do

           if (abx < xlim4) then
             do j=0,5
               k(i) = k(i) + c(j) * (ym(j) + yp(j))
     1                     - s(j) * (xm(j) - xp(j))
             end do

           else
             yf = y + y0py0
             do j=0,5
               k(i) = k(i) + (c(j) * (mq(j) * mf(j) - y0 * ym(j))
     1                     + s(j) * yf * xm(j)) / (mq(j) + y0q)
     2                     + (c(j) * (pq(j) * pf(j) - y0 * yp(j))
     3                     - s(j) * yf * xp(j)) / (pq(j) + y0q)
             end do
             k(i) = y * k(i) + exp(-xq)

           endif
         endif
       end do

       end
