
c Copyright (C) 2002 - Observatoire de Paris/Meudon
c                      Universite Paris 7
c                      CNRS (France)
c                      Contact : Jacques.Lebourlot@obspm.fr
c 
c This program is free software; you can redistribute it and/or
c modify it under the terms of the GNU General Public License version 2
c as published by the Free Software Foundation.
c 
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c GNU General Public License for more details.
c 
c You should have received a copy of the GNU General Public License
c along with this program; if not, write to the Free Software
c Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.


c      %%%%%%%%%%%%%%%%%%%%%%%%
       subroutine SORTIE1(ifaf)
c      %%%%%%%%%%%%%%%%%%%%%%%%

       use constantes
       use auxiliaries
       use inoutput
       use RF_TOOLS
       use SP_DATA
       use H2_DATA
       use HD_DATA
       use CHEM_DATA
       USE STR_DATA
       use PROFIL

c--------+---------+---------+---------+---------+---------+---------+-*-------+

c                     ordres non executables:
c                     ***********************

        implicit double precision (a-h,o-z)

        character (LEN=70) :: fichic
        REAL(KIND=DP) :: Emaxh3p_lu

c--------+---------+---------+---------+---------+---------+---------+-*-------+

       fichier = TRIM(out_dir)//TRIM(modele)//'.rf'
       open(44, file=fichier, status="unknown")
       write (44,'(" WL - Av: ",1p,249e12.5)')
     1                (tautav*tau_imp(j), j=0,n_imp)
       do i=rf_wl%lower,rf_wl%upper
         write (44,'(1p,e14.7,249e13.4E3)') rf_wl%Val(i)
     1                           , (rfield(j,i), j=0,n_imp)
       end do
       close (44)

c      fichier = TRIM(out_dir)//TRIM(modele)//'.rf3D'
c      open(44, file=fichier, status="unknown")
c      write (44,'(" ")')
c      do j=0,n_imp
c        do i=rf_wl%lower,rf_wl%upper
c          write (44,'(1p,3e15.7E3)') rf_wl%Val(i) , tautav*tau_imp(j)
c    1                            , rfield(j,i)
c        end do
c      end do
c      close (44)

       ide = ifaf / 10
       iun = ifaf - 10 * ide

c      fichic = TRIM(file_bin)//char(ifaf+48)
       fichic = TRIM(file_bin)//char(ide+48)//char(iun+48)
       open (iwrit1, file = fichic, status = 'unknown'
     1         , form = 'unformatted')

       write (iwrit1) npo, nspec, cdunit, rrr
       write (iwrit1) l0h2, l0hd, mjhd

c  Those parameters are writen for completeness only (not used in prep)
       write (iwrit1) nvbc, njbc
       write (iwrit1) nlvcat, nlvoat, nlvnat, nlvsat, nlvsiat
       write (iwrit1) nlvcpl, nlvopl, nlvnpl, nlvspl, nlvsip
       write (iwrit1) ntrcat, ntroat, ntrnat, ntrsat, ntrsiat
       write (iwrit1) ntrcpl, ntropl, ntrnpl, ntrspl, ntrsip
       write (iwrit1) nlvco0, nlvcs0, nlvhcop, nlvh2o
       write (iwrit1) ntrco0, ntrcs0, ntrhcop, ntrh2o

       Emaxh3p_lu = Emaxh3p ! juste pour la comprehension
       write (iwrit1) nlvh3p, ntrh3p, Emaxh3p_lu

       write (iwrit1)
     1            i_h, i_d, i_hgr, i_dgr, i_h2, i_hd, i_h2gr, i_he,
     1            i_c, i_n, i_o, i_s, i_si,
     1            i_cp, i_np, i_op, i_sp, i_sip,
     1            i_h2o, i_oh, i_co0, i_co1, i_co2, i_co3,
     2            i_hp, i_h2dp, i_h3p, i_fep,
     3            i_c2, i_cs, i_c13, i_o18, i_hcop
       write (iwrit1) speci

       write (iwrit1) npg
       write (iwrit1) ((zmoy(i,j), i=1,npg), j=0,npo)
       write (iwrit1)  (adust(i), i=1,npg)
       write (iwrit1)  (wwmg(i), i=1,npg)
       write (iwrit1)  (surfgr(i), i=1,npg)
       write (iwrit1)  (tau(i), densh(i), tgaz(i)
     1               , (tdust(j,i), j=1,npg), i=0,npo)

c  Heating and cooling rates
c  -------------------------

       write (iwrit1) (rfjh2t(i), rfjhdt(i), refco0(i), refco1(i)
     1               , refco2(i), refcs0(i), refhcop(i), refh3p(i)
     2               , i=0,npo)
       write (iwrit1) (refcat(i), refnat(i), refoat(i)
     1              ,  refsat(i), refsiat(i), i=0,npo)
       write (iwrit1) (refcpl(i), refnpl(i), refopl(i)
     1              ,  refspl(i), refsip(i), i=0,npo)
       write (iwrit1) (refh2o(i), refoh(i), reffep(i), i=0,npo)
       write (iwrit1) (chophg(i), choh2g(i), chohdg(i)
     1               , chopht(i), chorc(i), chophs(i), i=0,npo)
       write (iwrit1) (choeqg(i), chochi(i), chotur(i), reftot(i)
     1               , chotot(i), i=0,npo)

c  Emissivities
c  ------------

       write (iwrit1) ((emicat(j,i),  j=1, ntrcat),  i=0,npo)
       write (iwrit1) ((eminat(j,i),  j=1, ntrnat),  i=0,npo)
       write (iwrit1) ((emioat(j,i),  j=1, ntroat),  i=0,npo)
       write (iwrit1) ((emisat(j,i),  j=1, ntrsat),  i=0,npo)
       write (iwrit1) ((emisiat(j,i), j=1, ntrsiat), i=0,npo)
       write (iwrit1) ((emicpl(j,i),  j=1, ntrcpl),  i=0,npo)
       write (iwrit1) ((eminpl(j,i),  j=1, ntrnpl),  i=0,npo)
       write (iwrit1) ((emiopl(j,i),  j=1, ntropl),  i=0,npo)
       write (iwrit1) ((emispl(j,i),  j=1, ntrspl),  i=0,npo)
       write (iwrit1) ((emisip(j,i),  j=1, ntrsip),  i=0,npo)
       write (iwrit1) ((emico0(j,i),  j=1, ntrco0),  i=0,npo)
       write (iwrit1) ((emico1(j,i),  j=1, ntrco0),  i=0,npo)
       write (iwrit1) ((emico2(j,i),  j=1, ntrco0),  i=0,npo)
       write (iwrit1) ((emico3(j,i),  j=1, ntrco0),  i=0,npo)
       write (iwrit1) ((emics0(j,i),  j=1, ntrcs0),  i=0,npo)
       write (iwrit1) ((emihcop(j,i), j=1, ntrhcop), i=0,npo)
       write (iwrit1) ((emih2o(j,i),  j=1, ntrh2o),  i=0,npo)
       write (iwrit1) ((emih3p(j,i),  j=1, ntrh3p),  i=0,npo)

c 1-Formation and destruction of H2, HD and CO

       write (iwrit1) (timh21(i), timh22(i), timh23(i)
     1               , timh24(i), (t_25(j,i), j=1,npmg), i=0,npo)
       if (i_hd /= 0) then
           write (iwrit1) (timhd1(i), timhd2(i)
     1                   , timhd3(i), timhd4(i), i=0,npo)
       endif
       write (iwrit1) (timco1(i), timco2(i), timco3(i), i=0,npo)

       write (iwrit1) (fluph(i), int_rad(i), i=0,npo)

c 4-Abondances of all species:

       write (iwrit1) ((abnua(j,i), j=0,nspec), i=0,npo)

c 5-Excitation of H2 et HD

       write (iwrit1) ((xreh2(j,i), j=1,l0h2), i=0,npo)
       if (i_hd /= 0) then
           write (iwrit1) ((xrehd(j,i), j=1,l0hd), i=0,npo)
       endif

c 6- Excitation of CO

       write (iwrit1) ((xreco0(j,i), j=1,nlvco0), i=0,npo)
       write (iwrit1) ((opdco0(j,i), j=1,ntrco0), i=0,npo)

c 6- Excitation of CS

       write (iwrit1) ((xrecs0(j,i), j=1,nlvcs0), i=0,npo)
       write (iwrit1) ((opdcs0(j,i), j=1,ntrcs0), i=0,npo)

c 7- Excitation of HCOP
 
       write (iwrit1) ((xrehcop(j,i), j=1,nlvhcop), i=0,npo)
       write (iwrit1) ((opdhcop(j,i), j=1,ntrhcop), i=0,npo)

c 7b- Excitation of H2O
 
       write (iwrit1) ((xreh2o(j,i), j=1,nlvh2o), i=0,npo)
       write (iwrit1) ((opdh2o(j,i), j=1,ntrh2o), i=0,npo)

c 7c- Excitation of H3+

       write (iwrit1) ((xreh3p(j,i), j=1,nlvh3p), i=0,npo)
       write (iwrit1) ((opdh3p(j,i), j=1,ntrh3p), i=0,npo)

c 8-Excitation of C13O CO18 C13O18

       write (iwrit1) ((xreco1(j,i), j=1,nlvco0), i=0,npo)
       write (iwrit1) ((opdco1(j,i), j=1,ntrco0), i=0,npo)

       write (iwrit1) ((xreco2(j,i), j=1,nlvco0), i=0,npo)
       write (iwrit1) ((opdco2(j,i), j=1,ntrco0), i=0,npo)

       write (iwrit1) ((xreco3(j,i), j=1,nlvco0), i=0,npo)
       write (iwrit1) ((opdco3(j,i), j=1,ntrco0), i=0,npo)

c 11-Excitation of O, C, C+
       write (iwrit1) ((xrecat(j,i),  j=1,nlvcat),  i=0,npo)
       write (iwrit1) ((opdcat(j,i),  j=1,ntrcat),  i=0,npo)

       write (iwrit1) ((xrenat(j,i),  j=1,nlvnat),  i=0,npo)
       write (iwrit1) ((opdnat(j,i),  j=1,ntrnat),  i=0,npo)

       write (iwrit1) ((xreoat(j,i),  j=1,nlvoat),  i=0,npo)
       write (iwrit1) ((opdoat(j,i),  j=1,ntroat),  i=0,npo)

       write (iwrit1) ((xresat(j,i),  j=1,nlvsat),  i=0,npo)
       write (iwrit1) ((opdsat(j,i),  j=1,ntrsat),  i=0,npo)

       write (iwrit1) ((xresiat(j,i), j=1,nlvsiat), i=0,npo)
       write (iwrit1) ((opdsiat(j,i), j=1,ntrsiat), i=0,npo)

       write (iwrit1) ((xrecpl(j,i),  j=1,nlvcpl),  i=0,npo)
       write (iwrit1) ((opdcpl(j,i),  j=1,ntrcpl),  i=0,npo)

       write (iwrit1) ((xrenpl(j,i),  j=1,nlvnpl), i=0,npo)
       write (iwrit1) ((opdnpl(j,i),  j=1,ntrnpl), i=0,npo)

       write (iwrit1) ((xreopl(j,i),  j=1,nlvopl),  i=0,npo)
       write (iwrit1) ((opdopl(j,i),  j=1,ntropl),  i=0,npo)

       write (iwrit1) ((xrespl(j,i),  j=1,nlvspl),  i=0,npo)
       write (iwrit1) ((opdspl(j,i),  j=1,ntrspl),  i=0,npo)

       write (iwrit1) ((xresip(j,i),  j=1,nlvsip),  i=0,npo)
       write (iwrit1) ((opdsip(j,i),  j=1,ntrsip),  i=0,npo)

       write (iwrit1) vturb
       write (iwrit1) neqt, radm, radp
       write (iwrit1) ((rxigr(i,j), i=0,nspec), j=0,npo)
       write (iwrit1) ((ikmat(j,i), i=0,neqt), j=0,nspec)
       write (iwrit1) ((react(j,i), i=0,7), j=1,neqt)
       write (iwrit1) (gamm(i), i=1,neqt)
       write (iwrit1) (alpha(i), i=1,neqt)
       write (iwrit1) (bet(i), i=1,neqt)
       write (iwrit1) (de(i), i=1,neqt)
       write (iwrit1) (itype(i), i=1,neqt)
       write (iwrit1) nh2for, ncrion, npsion, nasrad, nrest
       write (iwrit1) nh2endo, nphot_f, nphot_i, n3body, ncpart
     1              , ngsurf, ngphot, i_mandat
       write (iwrit1) ngads, ngneut, nggdes, ncrdes, nphdes, ngevap
       write (iwrit1) nn, ni, nim, nng
       write (iwrit1) ((pdiesp(k,i), k=1,nphot_i), i=0,npo)
       write (iwrit1) (phdest(k)%r1, k=1,nphot_i)

       write (iwrit1) gratio, rhogr, alpgr, rgrmin, rgrmax, zeta
       write (iwrit1) vmaxw , fphsec, signgr, bsitgr, sngclb, rdeso
       write (iwrit1) dsite, (tm1h(i), i=1,nspec)
       write (iwrit1) istic, (mol(i), i=1,np)
       write (iwrit1)  iadhgr, ifh2gr, idh2ph, iaddgr, ifhdgr, idhdph
     1               , idco0p, idco1p, idco2p, idco3p, idcph

c-----------------------------------------------------------------------
c  Excitation of levels B and C of H2
c-----------------------------------------------------------------------
       write(iwrit1) (((h2bnua(iv,ij,iopt), iv=0,nvbc),
     1    ij=0,njbc), iopt=0,npo)
       write(iwrit1) (((h2cnua(iv,ij,iopt), iv=0,nvbc),
     1    ij=0,njbc), iopt=0,npo)

c Fitzpatrick and massa extinction curve coefficients

       write(iwrit1) cc1, cc2, cc3, cc4, xgam, y0

       close (iwrit1)

c--------+---------+---------+---------+---------+---------+---------+-*-------+

       return
       end
