
c Copyright (C) 2002 - Observatoire de Paris/Meudon
c                      Universite Paris 7
c                      CNRS (France)
c                      Contact : Jacques.Lebourlot@obspm.fr
c 
c This program is free software; you can redistribute it and/or
c modify it under the terms of the GNU General Public License version 2
c as published by the Free Software Foundation.
c 
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c GNU General Public License for more details.
c 
c You should have received a copy of the GNU General Public License
c along with this program; if not, write to the Free Software
c Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.


c      %%%%%%%%%%%%%%%%%%
       subroutine SORTIE2
c      %%%%%%%%%%%%%%%%%%

       use constantes
       use auxiliaries
       use RF_TOOLS
       use SP_DATA
       use H2_DATA
       use HD_DATA
       USE STR_DATA
       USE CHEM_DATA
       use PROFIL
       use appel

c--------+---------+---------+---------+---------+---------+---------+-*-------+

c                     ordres non executables:
c                     ***********************

        implicit double precision (a-h,o-z)

        dimension     tion(0:noptm)

c--------+---------+---------+---------+---------+---------+---------+-*-------+

       write (iwrit2,2010)

       do i=0,npo
         tion(i) = abnua(nspec,i) / densh(i)
         write (iwrit2,2020) tau(i), densh(i), tgaz(i)
     1                     , tdust(1,i), tion(i)
       end do

c  Heating and cooling rates
c  -------------------------

       write (iwrit2,6000)

       write (iwrit2,3029) speci(i_h2), speci(i_hd), speci(i_co0)
     1                   , 'C*O    ', 'CO*    '
     2                   , speci(i_cs), speci(i_hcop), speci(i_h3p)
       do i=0,npo
         write (iwrit2,3031) tau(i), rfjh2t(i), rfjhdt(i), refco0(i)
     1                     , refco1(i), refco2(i)
     2                     , refcs0(i), refhcop(i), refh3p(i)
       end do

       write (iwrit2,3019) speci(i_c), speci(i_n), speci(i_o)
     1                   , speci(i_s), speci(i_si)
       do i=0,npo
         write (iwrit2,3021) tau(i), refcat(i), refnat(i), refoat(i)
     1                    , refsat(i), refsiat(i)
       end do

       write (iwrit2,3019) speci(i_cp), speci(i_np), speci(i_op)
     1                   , speci(i_sp), speci(i_sip)
       do i=0,npo
         write (iwrit2,3021) tau(i), refcpl(i), refnpl(i), refopl(i)
     1                    , refspl(i), refsip(i)
       end do

       write (iwrit2,3019) speci(i_h2o), speci(i_oh), speci(i_fep)
       do i=0,npo
         write (iwrit2,3021) tau(i), refh2o(i), refoh(i), reffep(i)
       end do

       write (iwrit2,6001)
       do i=0,npo
         write (iwrit2,3021) tau(i), chophg(i), choh2g(i)
     1                    , chohdg(i), chopht(i), chorc(i), chophs(i)
       end do
       write (iwrit2,6002)
       do i=0,npo
         write (iwrit2,3021) tau(i), choeqg(i), chochi(i)
     1                    , chotur(i), reftot(i), chotot(i)
       end do

c--------+---------+---------+---------+---------+---------+---------+-*-------+

c  Final results
c  -------------

c 1-Formation and destruction of H2, HD et CO

       write (iwrit2,3008)

       write (iwrit2,3014)
       do iopt=0,npo

          write (iwrit2,3020) tau(iopt), timh21(iopt)
     1            , timh22(iopt), timh23(iopt), timh24(iopt)
     2            , sum(t_25(1:npg,iopt))
     3            , timhd1(iopt), timhd2(iopt), timhd3(iopt)
     4            , timhd4(iopt)
     5            , timco1(iopt), timco2(iopt), timco3(iopt)
       end do

c 4-Abondances of all species:

       write (iwrit2,3015) speci(i_h), speci(i_h2), speci(i_d)
     1                   , speci(i_hd), speci(i_cp)
     2                   , speci(i_c), speci(i_co0), speci(i_o)
     3                   , speci(i_hp), speci(i_cs)
       do iopt=0,npo
          write (iwrit2,3020) tau(iopt), abnua(i_h,iopt)
     1            , abnua(i_h2,iopt),  abnua(i_d, iopt)
     2            , abnua(i_hd,iopt), abnua(i_cp,iopt)
     3            , abnua(i_c,iopt), abnua(i_co0,iopt)
     4            , abnua(i_o,iopt), abnua(i_hp, iopt)
     5            , abnua(i_cs,iopt)
       end do

c  Call to prep thru a C interface (so we can use system calls)
c  to compute some integrated emissivities

       call SOREMI

c--------+---------+---------+---------+---------+---------+---------+-*-------+

c  formats:

 2010  format (1x,//,5x,'tau',8x,'density',4x,'temp_gas',2x,
     1        'temp_dust',2x,'ionisation',/,18x,'cm-3',8x,'K',9x,'K')
 2020  format (2x,1pe10.3,3x,e9.2,0p,2f10.2,5x,1pe12.4)
 3008  format(//,10x,'Formation and destruction of H2, HD et CO:',/,
     1            20x,'in cm-3 s-1')
 3014  format(//,30x,'H2',30x,'HD',30x,'CO',/
     1       1x,' tau:      fab chi   des chi    grains   photons',
     2       '   ev_H2ad',
     3       '   fab chi   des chi   photons')
 3015  format (/,1x,' tau:     ',10(2x,a8))
 3019  format(//,3x,'tau:   ',7(3x,a8),/)
 3029  format(//,3x,'tau:   ',9(3x,a8),/)
 3020  format(1x,1pe8.2,12(2x,e8.2))
 3021  format(1x,1pe8.2,8(1x,e10.3))
 3031  format(1x,1pe8.2,9(1x,e10.3))
 6000  format (//,10x,'Cooling and heating rates:',
     1         //,10x,'1- Cooling')
 6001  format (//,10x,'2- Heating',//,1x,'tau:  ',5x,
     1         'pel_Gr      H2_gr    HD_gr    phot_mol',
     2         '    RC_mol    phs_mol')
 6002  format (//,1x,'tau:  ',4x,
     1         'eq_gaz_gr   eq_chim    cho_turb   ref_tot   cho_tot')

c---------------------------------------------------------------------

       return
       end
