
! Copyright (C) 2002 - Observatoire de Paris/Meudon
!                      Universite Paris 7
!                      CNRS (France)
!                      Contact : Jacques.Lebourlot@obspm.fr
! 
! This program is free software; you can redistribute it and/or
! modify it under the terms of the GNU General Public License version 2
! as published by the Free Software Foundation.
! 
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
! 
! You should have received a copy of the GNU General Public License
! along with this program; if not, write to the Free Software
! Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.


module appel

contains

subroutine SOREMI

  USE PROFIL
  use inoutput

  implicit none

  character (LEN=50) ::  ff1, ff2, ff3
  integer            ::  ide, iun

  ide = ifafm / 10
  iun = ifafm - 10 * ide
  open (25, file="toto.prp", status="unknown")

  write(25,'("0")')                  ! Record commands : NON
  ff1 = TRIM(modele)//".bin"
  ff1 = TRIM(ff1)//char(ide+48)//char(iun+48)
  write(25,'(a20)') ff1              ! Binary file
  write(25,'("0")')                  ! Analyse chemistry : NON
  ff2 = TRIM(modele)//".tet1"
  write(25,'(a20)') ff2              ! Output file
  write(25,'("rien")')               ! Comment
  write(25,'("2")')                  ! Free variable : Av
  write(25,'("3")')                  ! Emissivities
  write(25,'("1")')                  ! Integrated
  ff3 = TRIM(modele)//".rai1"
  write(25,'(a20)') ff3              ! Lines file
  write(25,'("0.0")')                ! Angle of view
  write(25,'("h2")')                 ! Species (H2)
  write(25,'("1")')                  ! Bande X
  write(25,'("1")')                  ! Par niveaux
  write(25,'("3 1")')                ! Line 2 -> 0
  write(25,'("1")')                  ! Bande X
  write(25,'("1")')                  ! Par niveaux
  write(25,'("4 2")')                ! Line 2 -> 0
  write(25,'("1")')                  ! Bande X
  write(25,'("1")')                  ! Par niveaux
  write(25,'("5 3")')                ! Line 2 -> 0
  write(25,'("0")')                  ! Fin
  write(25,'("co")')                 ! Species (CO)
  write(25,'("1")')                  ! Line 1 -> 0
  write(25,'("2")')                  ! Line 2 -> 1
  write(25,'("3")')                  ! Line 3 -> 2
  write(25,'("4")')                  ! Line 4 -> 3
  write(25,'("5")')                  ! Line 5 -> 4
  write(25,'("0")')                  ! Fin
  write(25,'("c*o")')                ! Species (CO)
  write(25,'("1")')                  ! Line 1 -> 0
  write(25,'("2")')                  ! Line 2 -> 1
  write(25,'("3")')                  ! Line 3 -> 2
  write(25,'("4")')                  ! Line 4 -> 3
  write(25,'("5")')                  ! Line 5 -> 4
  write(25,'("0")')                  ! Fin
  write(25,'("o")')                  ! Species (O)
  write(25,'("1")')                  ! Line 1 -> 2
  write(25,'("2")')                  ! Line 0 -> 1
  write(25,'("0")')                  ! Fin
  write(25,'("c")')                  ! Species (C)
  write(25,'("1")')                  ! Line 1 -> 0
  write(25,'("2")')                  ! Line 2 -> 1
  write(25,'("0")')                  ! Fin
  write(25,'("c+")')                 ! Species (C+)
  write(25,'("1")')                  ! Line 3/2 -> 1/2
  write(25,'("0")')                  ! Fin
  write(25,'("si+")')                ! Species (Si+)
  write(25,'("1")')                  ! Line 3/2 -> 1/2
  write(25,'("0")')                  ! Fin
  write(25,'("-1")')                 ! Fin Emissivites
  write(25,'("0")')                  ! Other column : NON
  write(25,'("0")')                  ! Other file : NON

  close (25)

  open (25, file="toto.sh", status="unknown")

  ff1 = TRIM(modele)//".emi"
  ff1 = TRIM(out_dir)//ff1
  ff2 = TRIM(out_dir)//ff2
  ff3 = TRIM(out_dir)//ff3
  write(25,'("#!/bin/sh")')
  write(25,'("../src/prep < toto.prp > /dev/null")')             ! Execute prep
  write(25,'("rm ",a50)') ff2                             ! Remove tmp file
  write(25,'("cat ",a50," | grep Emis > ",a50)') ff3, ff1 ! find Emissivities
  write(25,'("rm ",a50)') ff3                             ! Remove tmp file
  write(25,'("rm toto.prp")')                             ! Remove tmp file

  close (25)

! call appel_c                                            ! SG
!  call system ("chmod a+x toto.sh") ;
!  call system ("toto.sh") ;
!  call system ("rm toto.sh") ;


end subroutine SOREMI
end module appel
